module JLG
  module DATA
    # カラム名
    HEADER=['code','pref','name','type','district','furigana']

    # 地方自治体データのマスター
    GOV_DATA={
      10006=>{:code=>"010006", :pref=>"北海道", :name=>"北海道", :type=>"都道府県", :district=>"北海道地方", :furigana=>"ほっかいどう"},
      11002=>{:code=>"011002", :pref=>"北海道", :name=>"札幌市", :type=>"政令市", :district=>"北海道地方", :furigana=>"さっぽろし"},
      11011=>{:code=>"011011", :pref=>"北海道", :name=>"札幌市中央区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしちゅうおうく"},
      11029=>{:code=>"011029", :pref=>"北海道", :name=>"札幌市北区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしきたく"},
      11037=>{:code=>"011037", :pref=>"北海道", :name=>"札幌市東区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしひがしく"},
      11045=>{:code=>"011045", :pref=>"北海道", :name=>"札幌市白石区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろししろいしく"},
      11053=>{:code=>"011053", :pref=>"北海道", :name=>"札幌市豊平区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしとよひらく"},
      11061=>{:code=>"011061", :pref=>"北海道", :name=>"札幌市南区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしみなみく"},
      11070=>{:code=>"011070", :pref=>"北海道", :name=>"札幌市西区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしにしく"},
      11088=>{:code=>"011088", :pref=>"北海道", :name=>"札幌市厚別区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしあつべつく"},
      11096=>{:code=>"011096", :pref=>"北海道", :name=>"札幌市手稲区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしていねく"},
      11100=>{:code=>"011100", :pref=>"北海道", :name=>"札幌市清田区", :type=>"行政区", :district=>"北海道地方", :furigana=>"さっぽろしきよたく"},
      12025=>{:code=>"012025", :pref=>"北海道", :name=>"函館市", :type=>"市", :district=>"北海道地方", :furigana=>"はこだてし"},
      12033=>{:code=>"012033", :pref=>"北海道", :name=>"小樽市", :type=>"市", :district=>"北海道地方", :furigana=>"おたるし"},
      12041=>{:code=>"012041", :pref=>"北海道", :name=>"旭川市", :type=>"市", :district=>"北海道地方", :furigana=>"あさひかわし"},
      12050=>{:code=>"012050", :pref=>"北海道", :name=>"室蘭市", :type=>"市", :district=>"北海道地方", :furigana=>"むろらんし"},
      12068=>{:code=>"012068", :pref=>"北海道", :name=>"釧路市", :type=>"市", :district=>"北海道地方", :furigana=>"くしろし"},
      12076=>{:code=>"012076", :pref=>"北海道", :name=>"帯広市", :type=>"市", :district=>"北海道地方", :furigana=>"おびひろし"},
      12084=>{:code=>"012084", :pref=>"北海道", :name=>"北見市", :type=>"市", :district=>"北海道地方", :furigana=>"きたみし"},
      12092=>{:code=>"012092", :pref=>"北海道", :name=>"夕張市", :type=>"市", :district=>"北海道地方", :furigana=>"ゆうばりし"},
      12106=>{:code=>"012106", :pref=>"北海道", :name=>"岩見沢市", :type=>"市", :district=>"北海道地方", :furigana=>"いわみざわし"},
      12114=>{:code=>"012114", :pref=>"北海道", :name=>"網走市", :type=>"市", :district=>"北海道地方", :furigana=>"あばしりし"},
      12122=>{:code=>"012122", :pref=>"北海道", :name=>"留萌市", :type=>"市", :district=>"北海道地方", :furigana=>"るもいし"},
      12131=>{:code=>"012131", :pref=>"北海道", :name=>"苫小牧市", :type=>"市", :district=>"北海道地方", :furigana=>"とまこまいし"},
      12149=>{:code=>"012149", :pref=>"北海道", :name=>"稚内市", :type=>"市", :district=>"北海道地方", :furigana=>"わっかないし"},
      12157=>{:code=>"012157", :pref=>"北海道", :name=>"美唄市", :type=>"市", :district=>"北海道地方", :furigana=>"びばいし"},
      12165=>{:code=>"012165", :pref=>"北海道", :name=>"芦別市", :type=>"市", :district=>"北海道地方", :furigana=>"あしべつし"},
      12173=>{:code=>"012173", :pref=>"北海道", :name=>"江別市", :type=>"市", :district=>"北海道地方", :furigana=>"えべつし"},
      12181=>{:code=>"012181", :pref=>"北海道", :name=>"赤平市", :type=>"市", :district=>"北海道地方", :furigana=>"あかびらし"},
      12190=>{:code=>"012190", :pref=>"北海道", :name=>"紋別市", :type=>"市", :district=>"北海道地方", :furigana=>"もんべつし"},
      12203=>{:code=>"012203", :pref=>"北海道", :name=>"士別市", :type=>"市", :district=>"北海道地方", :furigana=>"しべつし"},
      12211=>{:code=>"012211", :pref=>"北海道", :name=>"名寄市", :type=>"市", :district=>"北海道地方", :furigana=>"なよろし"},
      12220=>{:code=>"012220", :pref=>"北海道", :name=>"三笠市", :type=>"市", :district=>"北海道地方", :furigana=>"みかさし"},
      12238=>{:code=>"012238", :pref=>"北海道", :name=>"根室市", :type=>"市", :district=>"北海道地方", :furigana=>"ねむろし"},
      12246=>{:code=>"012246", :pref=>"北海道", :name=>"千歳市", :type=>"市", :district=>"北海道地方", :furigana=>"ちとせし"},
      12254=>{:code=>"012254", :pref=>"北海道", :name=>"滝川市", :type=>"市", :district=>"北海道地方", :furigana=>"たきかわし"},
      12262=>{:code=>"012262", :pref=>"北海道", :name=>"砂川市", :type=>"市", :district=>"北海道地方", :furigana=>"すながわし"},
      12271=>{:code=>"012271", :pref=>"北海道", :name=>"歌志内市", :type=>"市", :district=>"北海道地方", :furigana=>"うたしないし"},
      12289=>{:code=>"012289", :pref=>"北海道", :name=>"深川市", :type=>"市", :district=>"北海道地方", :furigana=>"ふかがわし"},
      12297=>{:code=>"012297", :pref=>"北海道", :name=>"富良野市", :type=>"市", :district=>"北海道地方", :furigana=>"ふらのし"},
      12301=>{:code=>"012301", :pref=>"北海道", :name=>"登別市", :type=>"市", :district=>"北海道地方", :furigana=>"のぼりべつし"},
      12319=>{:code=>"012319", :pref=>"北海道", :name=>"恵庭市", :type=>"市", :district=>"北海道地方", :furigana=>"えにわし"},
      12335=>{:code=>"012335", :pref=>"北海道", :name=>"伊達市", :type=>"市", :district=>"北海道地方", :furigana=>"だてし"},
      12343=>{:code=>"012343", :pref=>"北海道", :name=>"北広島市", :type=>"市", :district=>"北海道地方", :furigana=>"きたひろしまし"},
      12351=>{:code=>"012351", :pref=>"北海道", :name=>"石狩市", :type=>"市", :district=>"北海道地方", :furigana=>"いしかりし"},
      12360=>{:code=>"012360", :pref=>"北海道", :name=>"北斗市", :type=>"市", :district=>"北海道地方", :furigana=>"ほくとし"},
      13030=>{:code=>"013030", :pref=>"北海道", :name=>"当別町", :type=>"町", :district=>"北海道地方", :furigana=>"とうべつちょう"},
      13048=>{:code=>"013048", :pref=>"北海道", :name=>"新篠津村", :type=>"村", :district=>"北海道地方", :furigana=>"しんしのつむら"},
      13315=>{:code=>"013315", :pref=>"北海道", :name=>"松前町", :type=>"町", :district=>"北海道地方", :furigana=>"まつまえちょう"},
      13323=>{:code=>"013323", :pref=>"北海道", :name=>"福島町", :type=>"町", :district=>"北海道地方", :furigana=>"ふくしまちょう"},
      13331=>{:code=>"013331", :pref=>"北海道", :name=>"知内町", :type=>"町", :district=>"北海道地方", :furigana=>"しりうちちょう"},
      13340=>{:code=>"013340", :pref=>"北海道", :name=>"木古内町", :type=>"町", :district=>"北海道地方", :furigana=>"きこないちょう"},
      13374=>{:code=>"013374", :pref=>"北海道", :name=>"七飯町", :type=>"町", :district=>"北海道地方", :furigana=>"ななえちょう"},
      13439=>{:code=>"013439", :pref=>"北海道", :name=>"鹿部町", :type=>"町", :district=>"北海道地方", :furigana=>"しかべちょう"},
      13455=>{:code=>"013455", :pref=>"北海道", :name=>"森町", :type=>"町", :district=>"北海道地方", :furigana=>"もりまち"},
      13463=>{:code=>"013463", :pref=>"北海道", :name=>"八雲町", :type=>"町", :district=>"北海道地方", :furigana=>"やくもちょう"},
      13471=>{:code=>"013471", :pref=>"北海道", :name=>"長万部町", :type=>"町", :district=>"北海道地方", :furigana=>"おしゃまんべちょう"},
      13617=>{:code=>"013617", :pref=>"北海道", :name=>"江差町", :type=>"町", :district=>"北海道地方", :furigana=>"えさしちょう"},
      13625=>{:code=>"013625", :pref=>"北海道", :name=>"上ノ国町", :type=>"町", :district=>"北海道地方", :furigana=>"かみのくにちょう"},
      13633=>{:code=>"013633", :pref=>"北海道", :name=>"厚沢部町", :type=>"町", :district=>"北海道地方", :furigana=>"あっさぶちょう"},
      13641=>{:code=>"013641", :pref=>"北海道", :name=>"乙部町", :type=>"町", :district=>"北海道地方", :furigana=>"おとべちょう"},
      13676=>{:code=>"013676", :pref=>"北海道", :name=>"奥尻町", :type=>"町", :district=>"北海道地方", :furigana=>"おくしりちょう"},
      13706=>{:code=>"013706", :pref=>"北海道", :name=>"今金町", :type=>"町", :district=>"北海道地方", :furigana=>"いまかねちょう"},
      13714=>{:code=>"013714", :pref=>"北海道", :name=>"せたな町", :type=>"町", :district=>"北海道地方", :furigana=>"せたなちょう"},
      13919=>{:code=>"013919", :pref=>"北海道", :name=>"島牧村", :type=>"村", :district=>"北海道地方", :furigana=>"しままきむら"},
      13927=>{:code=>"013927", :pref=>"北海道", :name=>"寿都町", :type=>"町", :district=>"北海道地方", :furigana=>"すっつちょう"},
      13935=>{:code=>"013935", :pref=>"北海道", :name=>"黒松内町", :type=>"町", :district=>"北海道地方", :furigana=>"くろまつないちょう"},
      13943=>{:code=>"013943", :pref=>"北海道", :name=>"蘭越町", :type=>"町", :district=>"北海道地方", :furigana=>"らんこしちょう"},
      13951=>{:code=>"013951", :pref=>"北海道", :name=>"ニセコ町", :type=>"町", :district=>"北海道地方", :furigana=>"にせこちょう"},
      13960=>{:code=>"013960", :pref=>"北海道", :name=>"真狩村", :type=>"村", :district=>"北海道地方", :furigana=>"まっかりむら"},
      13978=>{:code=>"013978", :pref=>"北海道", :name=>"留寿都村", :type=>"村", :district=>"北海道地方", :furigana=>"るすつむら"},
      13986=>{:code=>"013986", :pref=>"北海道", :name=>"喜茂別町", :type=>"町", :district=>"北海道地方", :furigana=>"きもべつちょう"},
      13994=>{:code=>"013994", :pref=>"北海道", :name=>"京極町", :type=>"町", :district=>"北海道地方", :furigana=>"きょうごくちょう"},
      14001=>{:code=>"014001", :pref=>"北海道", :name=>"倶知安町", :type=>"町", :district=>"北海道地方", :furigana=>"くっちゃんちょう"},
      14010=>{:code=>"014010", :pref=>"北海道", :name=>"共和町", :type=>"町", :district=>"北海道地方", :furigana=>"きょうわちょう"},
      14028=>{:code=>"014028", :pref=>"北海道", :name=>"岩内町", :type=>"町", :district=>"北海道地方", :furigana=>"いわないちょう"},
      14036=>{:code=>"014036", :pref=>"北海道", :name=>"泊村", :type=>"村", :district=>"北海道地方", :furigana=>"とまりむら"},
      14044=>{:code=>"014044", :pref=>"北海道", :name=>"神恵内村", :type=>"村", :district=>"北海道地方", :furigana=>"かもえないむら"},
      14052=>{:code=>"014052", :pref=>"北海道", :name=>"積丹町", :type=>"町", :district=>"北海道地方", :furigana=>"しゃこたんちょう"},
      14061=>{:code=>"014061", :pref=>"北海道", :name=>"古平町", :type=>"町", :district=>"北海道地方", :furigana=>"ふるびらちょう"},
      14079=>{:code=>"014079", :pref=>"北海道", :name=>"仁木町", :type=>"町", :district=>"北海道地方", :furigana=>"にきちょう"},
      14087=>{:code=>"014087", :pref=>"北海道", :name=>"余市町", :type=>"町", :district=>"北海道地方", :furigana=>"よいちちょう"},
      14095=>{:code=>"014095", :pref=>"北海道", :name=>"赤井川村", :type=>"村", :district=>"北海道地方", :furigana=>"あかいがわむら"},
      14231=>{:code=>"014231", :pref=>"北海道", :name=>"南幌町", :type=>"町", :district=>"北海道地方", :furigana=>"なんぽろちょう"},
      14249=>{:code=>"014249", :pref=>"北海道", :name=>"奈井江町", :type=>"町", :district=>"北海道地方", :furigana=>"ないえちょう"},
      14257=>{:code=>"014257", :pref=>"北海道", :name=>"上砂川町", :type=>"町", :district=>"北海道地方", :furigana=>"かみすながわちょう"},
      14273=>{:code=>"014273", :pref=>"北海道", :name=>"由仁町", :type=>"町", :district=>"北海道地方", :furigana=>"ゆにちょう"},
      14281=>{:code=>"014281", :pref=>"北海道", :name=>"長沼町", :type=>"町", :district=>"北海道地方", :furigana=>"ながぬまちょう"},
      14290=>{:code=>"014290", :pref=>"北海道", :name=>"栗山町", :type=>"町", :district=>"北海道地方", :furigana=>"くりやまちょう"},
      14303=>{:code=>"014303", :pref=>"北海道", :name=>"月形町", :type=>"町", :district=>"北海道地方", :furigana=>"つきがたちょう"},
      14311=>{:code=>"014311", :pref=>"北海道", :name=>"浦臼町", :type=>"町", :district=>"北海道地方", :furigana=>"うらうすちょう"},
      14320=>{:code=>"014320", :pref=>"北海道", :name=>"新十津川町", :type=>"町", :district=>"北海道地方", :furigana=>"しんとつかわちょう"},
      14338=>{:code=>"014338", :pref=>"北海道", :name=>"妹背牛町", :type=>"町", :district=>"北海道地方", :furigana=>"もせうしちょう"},
      14346=>{:code=>"014346", :pref=>"北海道", :name=>"秩父別町", :type=>"町", :district=>"北海道地方", :furigana=>"ちっぷべつちょう"},
      14362=>{:code=>"014362", :pref=>"北海道", :name=>"雨竜町", :type=>"町", :district=>"北海道地方", :furigana=>"うりゅうちょう"},
      14371=>{:code=>"014371", :pref=>"北海道", :name=>"北竜町", :type=>"町", :district=>"北海道地方", :furigana=>"ほくりゅうちょう"},
      14389=>{:code=>"014389", :pref=>"北海道", :name=>"沼田町", :type=>"町", :district=>"北海道地方", :furigana=>"ぬまたちょう"},
      14524=>{:code=>"014524", :pref=>"北海道", :name=>"鷹栖町", :type=>"町", :district=>"北海道地方", :furigana=>"たかすちょう"},
      14532=>{:code=>"014532", :pref=>"北海道", :name=>"東神楽町", :type=>"町", :district=>"北海道地方", :furigana=>"ひがしかぐらちょう"},
      14541=>{:code=>"014541", :pref=>"北海道", :name=>"当麻町", :type=>"町", :district=>"北海道地方", :furigana=>"とうまちょう"},
      14559=>{:code=>"014559", :pref=>"北海道", :name=>"比布町", :type=>"町", :district=>"北海道地方", :furigana=>"ぴっぷちょう"},
      14567=>{:code=>"014567", :pref=>"北海道", :name=>"愛別町", :type=>"町", :district=>"北海道地方", :furigana=>"あいべつちょう"},
      14575=>{:code=>"014575", :pref=>"北海道", :name=>"上川町", :type=>"町", :district=>"北海道地方", :furigana=>"かみかわちょう"},
      14583=>{:code=>"014583", :pref=>"北海道", :name=>"東川町", :type=>"町", :district=>"北海道地方", :furigana=>"ひがしかわちょう"},
      14591=>{:code=>"014591", :pref=>"北海道", :name=>"美瑛町", :type=>"町", :district=>"北海道地方", :furigana=>"びえいちょう"},
      14605=>{:code=>"014605", :pref=>"北海道", :name=>"上富良野町", :type=>"町", :district=>"北海道地方", :furigana=>"かみふらのちょう"},
      14613=>{:code=>"014613", :pref=>"北海道", :name=>"中富良野町", :type=>"町", :district=>"北海道地方", :furigana=>"なかふらのちょう"},
      14621=>{:code=>"014621", :pref=>"北海道", :name=>"南富良野町", :type=>"町", :district=>"北海道地方", :furigana=>"みなみふらのちょう"},
      14630=>{:code=>"014630", :pref=>"北海道", :name=>"占冠村", :type=>"村", :district=>"北海道地方", :furigana=>"しむかっぷむら"},
      14648=>{:code=>"014648", :pref=>"北海道", :name=>"和寒町", :type=>"町", :district=>"北海道地方", :furigana=>"わっさむちょう"},
      14656=>{:code=>"014656", :pref=>"北海道", :name=>"剣淵町", :type=>"町", :district=>"北海道地方", :furigana=>"けんぶちちょう"},
      14681=>{:code=>"014681", :pref=>"北海道", :name=>"下川町", :type=>"町", :district=>"北海道地方", :furigana=>"しもかわちょう"},
      14699=>{:code=>"014699", :pref=>"北海道", :name=>"美深町", :type=>"町", :district=>"北海道地方", :furigana=>"びふかちょう"},
      14702=>{:code=>"014702", :pref=>"北海道", :name=>"音威子府村", :type=>"村", :district=>"北海道地方", :furigana=>"おといねっぷむら"},
      14711=>{:code=>"014711", :pref=>"北海道", :name=>"中川町", :type=>"町", :district=>"北海道地方", :furigana=>"なかがわちょう"},
      14729=>{:code=>"014729", :pref=>"北海道", :name=>"幌加内町", :type=>"町", :district=>"北海道地方", :furigana=>"ほろかないちょう"},
      14818=>{:code=>"014818", :pref=>"北海道", :name=>"増毛町", :type=>"町", :district=>"北海道地方", :furigana=>"ましけちょう"},
      14826=>{:code=>"014826", :pref=>"北海道", :name=>"小平町", :type=>"町", :district=>"北海道地方", :furigana=>"おびらちょう"},
      14834=>{:code=>"014834", :pref=>"北海道", :name=>"苫前町", :type=>"町", :district=>"北海道地方", :furigana=>"とままえちょう"},
      14842=>{:code=>"014842", :pref=>"北海道", :name=>"羽幌町", :type=>"町", :district=>"北海道地方", :furigana=>"はぼろちょう"},
      14851=>{:code=>"014851", :pref=>"北海道", :name=>"初山別村", :type=>"村", :district=>"北海道地方", :furigana=>"しょさんべつむら"},
      14869=>{:code=>"014869", :pref=>"北海道", :name=>"遠別町", :type=>"町", :district=>"北海道地方", :furigana=>"えんべつちょう"},
      14877=>{:code=>"014877", :pref=>"北海道", :name=>"天塩町", :type=>"町", :district=>"北海道地方", :furigana=>"てしおちょう"},
      15113=>{:code=>"015113", :pref=>"北海道", :name=>"猿払村", :type=>"村", :district=>"北海道地方", :furigana=>"さるふつむら"},
      15121=>{:code=>"015121", :pref=>"北海道", :name=>"浜頓別町", :type=>"町", :district=>"北海道地方", :furigana=>"はまとんべつちょう"},
      15130=>{:code=>"015130", :pref=>"北海道", :name=>"中頓別町", :type=>"町", :district=>"北海道地方", :furigana=>"なかとんべつちょう"},
      15148=>{:code=>"015148", :pref=>"北海道", :name=>"枝幸町", :type=>"町", :district=>"北海道地方", :furigana=>"えさしちょう"},
      15164=>{:code=>"015164", :pref=>"北海道", :name=>"豊富町", :type=>"町", :district=>"北海道地方", :furigana=>"とよとみちょう"},
      15172=>{:code=>"015172", :pref=>"北海道", :name=>"礼文町", :type=>"町", :district=>"北海道地方", :furigana=>"れぶんちょう"},
      15181=>{:code=>"015181", :pref=>"北海道", :name=>"利尻町", :type=>"町", :district=>"北海道地方", :furigana=>"りしりちょう"},
      15199=>{:code=>"015199", :pref=>"北海道", :name=>"利尻富士町", :type=>"町", :district=>"北海道地方", :furigana=>"りしりふじちょう"},
      15202=>{:code=>"015202", :pref=>"北海道", :name=>"幌延町", :type=>"町", :district=>"北海道地方", :furigana=>"ほろのべちょう"},
      15431=>{:code=>"015431", :pref=>"北海道", :name=>"美幌町", :type=>"町", :district=>"北海道地方", :furigana=>"びほろちょう"},
      15440=>{:code=>"015440", :pref=>"北海道", :name=>"津別町", :type=>"町", :district=>"北海道地方", :furigana=>"つべつちょう"},
      15458=>{:code=>"015458", :pref=>"北海道", :name=>"斜里町", :type=>"町", :district=>"北海道地方", :furigana=>"しゃりちょう"},
      15466=>{:code=>"015466", :pref=>"北海道", :name=>"清里町", :type=>"町", :district=>"北海道地方", :furigana=>"きよさとちょう"},
      15474=>{:code=>"015474", :pref=>"北海道", :name=>"小清水町", :type=>"町", :district=>"北海道地方", :furigana=>"こしみずちょう"},
      15491=>{:code=>"015491", :pref=>"北海道", :name=>"訓子府町", :type=>"町", :district=>"北海道地方", :furigana=>"くんねっぷちょう"},
      15504=>{:code=>"015504", :pref=>"北海道", :name=>"置戸町", :type=>"町", :district=>"北海道地方", :furigana=>"おけとちょう"},
      15521=>{:code=>"015521", :pref=>"北海道", :name=>"佐呂間町", :type=>"町", :district=>"北海道地方", :furigana=>"さろまちょう"},
      15555=>{:code=>"015555", :pref=>"北海道", :name=>"遠軽町", :type=>"町", :district=>"北海道地方", :furigana=>"えんがるちょう"},
      15598=>{:code=>"015598", :pref=>"北海道", :name=>"湧別町", :type=>"町", :district=>"北海道地方", :furigana=>"ゆうべつちょう"},
      15601=>{:code=>"015601", :pref=>"北海道", :name=>"滝上町", :type=>"町", :district=>"北海道地方", :furigana=>"たきのうえちょう"},
      15610=>{:code=>"015610", :pref=>"北海道", :name=>"興部町", :type=>"町", :district=>"北海道地方", :furigana=>"おこっぺちょう"},
      15628=>{:code=>"015628", :pref=>"北海道", :name=>"西興部村", :type=>"村", :district=>"北海道地方", :furigana=>"にしおこっぺむら"},
      15636=>{:code=>"015636", :pref=>"北海道", :name=>"雄武町", :type=>"町", :district=>"北海道地方", :furigana=>"おうむちょう"},
      15644=>{:code=>"015644", :pref=>"北海道", :name=>"大空町", :type=>"町", :district=>"北海道地方", :furigana=>"おおぞらちょう"},
      15717=>{:code=>"015717", :pref=>"北海道", :name=>"豊浦町", :type=>"町", :district=>"北海道地方", :furigana=>"とようらちょう"},
      15750=>{:code=>"015750", :pref=>"北海道", :name=>"壮瞥町", :type=>"町", :district=>"北海道地方", :furigana=>"そうべつちょう"},
      15784=>{:code=>"015784", :pref=>"北海道", :name=>"白老町", :type=>"町", :district=>"北海道地方", :furigana=>"しらおいちょう"},
      15814=>{:code=>"015814", :pref=>"北海道", :name=>"厚真町", :type=>"町", :district=>"北海道地方", :furigana=>"あつまちょう"},
      15849=>{:code=>"015849", :pref=>"北海道", :name=>"洞爺湖町", :type=>"町", :district=>"北海道地方", :furigana=>"とうやこちょう"},
      15857=>{:code=>"015857", :pref=>"北海道", :name=>"安平町", :type=>"町", :district=>"北海道地方", :furigana=>"あびらちょう"},
      15865=>{:code=>"015865", :pref=>"北海道", :name=>"むかわ町", :type=>"町", :district=>"北海道地方", :furigana=>"むかわちょう"},
      16012=>{:code=>"016012", :pref=>"北海道", :name=>"日高町", :type=>"町", :district=>"北海道地方", :furigana=>"ひだかちょう"},
      16021=>{:code=>"016021", :pref=>"北海道", :name=>"平取町", :type=>"町", :district=>"北海道地方", :furigana=>"びらとりちょう"},
      16047=>{:code=>"016047", :pref=>"北海道", :name=>"新冠町", :type=>"町", :district=>"北海道地方", :furigana=>"にいかっぷちょう"},
      16071=>{:code=>"016071", :pref=>"北海道", :name=>"浦河町", :type=>"町", :district=>"北海道地方", :furigana=>"うらかわちょう"},
      16080=>{:code=>"016080", :pref=>"北海道", :name=>"様似町", :type=>"町", :district=>"北海道地方", :furigana=>"さまにちょう"},
      16098=>{:code=>"016098", :pref=>"北海道", :name=>"えりも町", :type=>"町", :district=>"北海道地方", :furigana=>"えりもちょう"},
      16101=>{:code=>"016101", :pref=>"北海道", :name=>"新ひだか町", :type=>"町", :district=>"北海道地方", :furigana=>"しんひだかちょう"},
      16314=>{:code=>"016314", :pref=>"北海道", :name=>"音更町", :type=>"町", :district=>"北海道地方", :furigana=>"おとふけちょう"},
      16322=>{:code=>"016322", :pref=>"北海道", :name=>"士幌町", :type=>"町", :district=>"北海道地方", :furigana=>"しほろちょう"},
      16331=>{:code=>"016331", :pref=>"北海道", :name=>"上士幌町", :type=>"町", :district=>"北海道地方", :furigana=>"かみしほろちょう"},
      16349=>{:code=>"016349", :pref=>"北海道", :name=>"鹿追町", :type=>"町", :district=>"北海道地方", :furigana=>"しかおいちょう"},
      16357=>{:code=>"016357", :pref=>"北海道", :name=>"新得町", :type=>"町", :district=>"北海道地方", :furigana=>"しんとくちょう"},
      16365=>{:code=>"016365", :pref=>"北海道", :name=>"清水町", :type=>"町", :district=>"北海道地方", :furigana=>"しみずちょう"},
      16373=>{:code=>"016373", :pref=>"北海道", :name=>"芽室町", :type=>"町", :district=>"北海道地方", :furigana=>"めむろちょう"},
      16381=>{:code=>"016381", :pref=>"北海道", :name=>"中札内村", :type=>"村", :district=>"北海道地方", :furigana=>"なかさつないむら"},
      16390=>{:code=>"016390", :pref=>"北海道", :name=>"更別村", :type=>"村", :district=>"北海道地方", :furigana=>"さらべつむら"},
      16411=>{:code=>"016411", :pref=>"北海道", :name=>"大樹町", :type=>"町", :district=>"北海道地方", :furigana=>"たいきちょう"},
      16420=>{:code=>"016420", :pref=>"北海道", :name=>"広尾町", :type=>"町", :district=>"北海道地方", :furigana=>"ひろおちょう"},
      16438=>{:code=>"016438", :pref=>"北海道", :name=>"幕別町", :type=>"町", :district=>"北海道地方", :furigana=>"まくべつちょう"},
      16446=>{:code=>"016446", :pref=>"北海道", :name=>"池田町", :type=>"町", :district=>"北海道地方", :furigana=>"いけだちょう"},
      16454=>{:code=>"016454", :pref=>"北海道", :name=>"豊頃町", :type=>"町", :district=>"北海道地方", :furigana=>"とよころちょう"},
      16462=>{:code=>"016462", :pref=>"北海道", :name=>"本別町", :type=>"町", :district=>"北海道地方", :furigana=>"ほんべつちょう"},
      16471=>{:code=>"016471", :pref=>"北海道", :name=>"足寄町", :type=>"町", :district=>"北海道地方", :furigana=>"あしょろちょう"},
      16489=>{:code=>"016489", :pref=>"北海道", :name=>"陸別町", :type=>"町", :district=>"北海道地方", :furigana=>"りくべつちょう"},
      16497=>{:code=>"016497", :pref=>"北海道", :name=>"浦幌町", :type=>"町", :district=>"北海道地方", :furigana=>"うらほろちょう"},
      16616=>{:code=>"016616", :pref=>"北海道", :name=>"釧路町", :type=>"町", :district=>"北海道地方", :furigana=>"くしろちょう"},
      16624=>{:code=>"016624", :pref=>"北海道", :name=>"厚岸町", :type=>"町", :district=>"北海道地方", :furigana=>"あっけしちょう"},
      16632=>{:code=>"016632", :pref=>"北海道", :name=>"浜中町", :type=>"町", :district=>"北海道地方", :furigana=>"はまなかちょう"},
      16641=>{:code=>"016641", :pref=>"北海道", :name=>"標茶町", :type=>"町", :district=>"北海道地方", :furigana=>"しべちゃちょう"},
      16659=>{:code=>"016659", :pref=>"北海道", :name=>"弟子屈町", :type=>"町", :district=>"北海道地方", :furigana=>"てしかがちょう"},
      16675=>{:code=>"016675", :pref=>"北海道", :name=>"鶴居村", :type=>"村", :district=>"北海道地方", :furigana=>"つるいむら"},
      16683=>{:code=>"016683", :pref=>"北海道", :name=>"白糠町", :type=>"町", :district=>"北海道地方", :furigana=>"しらぬかちょう"},
      16918=>{:code=>"016918", :pref=>"北海道", :name=>"別海町", :type=>"町", :district=>"北海道地方", :furigana=>"べつかいちょう"},
      16926=>{:code=>"016926", :pref=>"北海道", :name=>"中標津町", :type=>"町", :district=>"北海道地方", :furigana=>"なかしべつちょう"},
      16934=>{:code=>"016934", :pref=>"北海道", :name=>"標津町", :type=>"町", :district=>"北海道地方", :furigana=>"しべつちょう"},
      16942=>{:code=>"016942", :pref=>"北海道", :name=>"羅臼町", :type=>"町", :district=>"北海道地方", :furigana=>"らうすちょう"},
      20001=>{:code=>"020001", :pref=>"青森県", :name=>"青森県", :type=>"都道府県", :district=>"東北地方", :furigana=>"あおもりけん"},
      22012=>{:code=>"022012", :pref=>"青森県", :name=>"青森市", :type=>"市", :district=>"東北地方", :furigana=>"あおもりし"},
      22021=>{:code=>"022021", :pref=>"青森県", :name=>"弘前市", :type=>"市", :district=>"東北地方", :furigana=>"ひろさきし"},
      22039=>{:code=>"022039", :pref=>"青森県", :name=>"八戸市", :type=>"市", :district=>"東北地方", :furigana=>"はちのへし"},
      22047=>{:code=>"022047", :pref=>"青森県", :name=>"黒石市", :type=>"市", :district=>"東北地方", :furigana=>"くろいしし"},
      22055=>{:code=>"022055", :pref=>"青森県", :name=>"五所川原市", :type=>"市", :district=>"東北地方", :furigana=>"ごしょがわらし"},
      22063=>{:code=>"022063", :pref=>"青森県", :name=>"十和田市", :type=>"市", :district=>"東北地方", :furigana=>"とわだし"},
      22071=>{:code=>"022071", :pref=>"青森県", :name=>"三沢市", :type=>"市", :district=>"東北地方", :furigana=>"みさわし"},
      22080=>{:code=>"022080", :pref=>"青森県", :name=>"むつ市", :type=>"市", :district=>"東北地方", :furigana=>"むつし"},
      22098=>{:code=>"022098", :pref=>"青森県", :name=>"つがる市", :type=>"市", :district=>"東北地方", :furigana=>"つがるし"},
      22101=>{:code=>"022101", :pref=>"青森県", :name=>"平川市", :type=>"市", :district=>"東北地方", :furigana=>"ひらかわし"},
      23019=>{:code=>"023019", :pref=>"青森県", :name=>"平内町", :type=>"町", :district=>"東北地方", :furigana=>"ひらないまち"},
      23035=>{:code=>"023035", :pref=>"青森県", :name=>"今別町", :type=>"町", :district=>"東北地方", :furigana=>"いまべつまち"},
      23043=>{:code=>"023043", :pref=>"青森県", :name=>"蓬田村", :type=>"村", :district=>"東北地方", :furigana=>"よもぎたむら"},
      23078=>{:code=>"023078", :pref=>"青森県", :name=>"外ヶ浜町", :type=>"町", :district=>"東北地方", :furigana=>"そとがはままち"},
      23213=>{:code=>"023213", :pref=>"青森県", :name=>"鰺ヶ沢町", :type=>"町", :district=>"東北地方", :furigana=>"あじがさわまち"},
      23230=>{:code=>"023230", :pref=>"青森県", :name=>"深浦町", :type=>"町", :district=>"東北地方", :furigana=>"ふかうらまち"},
      23434=>{:code=>"023434", :pref=>"青森県", :name=>"西目屋村", :type=>"村", :district=>"東北地方", :furigana=>"にしめやむら"},
      23612=>{:code=>"023612", :pref=>"青森県", :name=>"藤崎町", :type=>"町", :district=>"東北地方", :furigana=>"ふじさきまち"},
      23621=>{:code=>"023621", :pref=>"青森県", :name=>"大鰐町", :type=>"町", :district=>"東北地方", :furigana=>"おおわにまち"},
      23671=>{:code=>"023671", :pref=>"青森県", :name=>"田舎館村", :type=>"村", :district=>"東北地方", :furigana=>"いなかだてむら"},
      23817=>{:code=>"023817", :pref=>"青森県", :name=>"板柳町", :type=>"町", :district=>"東北地方", :furigana=>"いたやなぎまち"},
      23841=>{:code=>"023841", :pref=>"青森県", :name=>"鶴田町", :type=>"町", :district=>"東北地方", :furigana=>"つるたまち"},
      23876=>{:code=>"023876", :pref=>"青森県", :name=>"中泊町", :type=>"町", :district=>"東北地方", :furigana=>"なかどまりまち"},
      24015=>{:code=>"024015", :pref=>"青森県", :name=>"野辺地町", :type=>"町", :district=>"東北地方", :furigana=>"のへじまち"},
      24023=>{:code=>"024023", :pref=>"青森県", :name=>"七戸町", :type=>"町", :district=>"東北地方", :furigana=>"しちのへまち"},
      24058=>{:code=>"024058", :pref=>"青森県", :name=>"六戸町", :type=>"町", :district=>"東北地方", :furigana=>"ろくのへまち"},
      24066=>{:code=>"024066", :pref=>"青森県", :name=>"横浜町", :type=>"町", :district=>"東北地方", :furigana=>"よこはままち"},
      24082=>{:code=>"024082", :pref=>"青森県", :name=>"東北町", :type=>"町", :district=>"東北地方", :furigana=>"とうほくまち"},
      24112=>{:code=>"024112", :pref=>"青森県", :name=>"六ヶ所村", :type=>"村", :district=>"東北地方", :furigana=>"ろっかしょむら"},
      24121=>{:code=>"024121", :pref=>"青森県", :name=>"おいらせ町", :type=>"町", :district=>"東北地方", :furigana=>"おいらせちょう"},
      24236=>{:code=>"024236", :pref=>"青森県", :name=>"大間町", :type=>"町", :district=>"東北地方", :furigana=>"おおままち"},
      24244=>{:code=>"024244", :pref=>"青森県", :name=>"東通村", :type=>"村", :district=>"東北地方", :furigana=>"ひがしどおりむら"},
      24252=>{:code=>"024252", :pref=>"青森県", :name=>"風間浦村", :type=>"村", :district=>"東北地方", :furigana=>"かざまうらむら"},
      24261=>{:code=>"024261", :pref=>"青森県", :name=>"佐井村", :type=>"村", :district=>"東北地方", :furigana=>"さいむら"},
      24414=>{:code=>"024414", :pref=>"青森県", :name=>"三戸町", :type=>"町", :district=>"東北地方", :furigana=>"さんのへまち"},
      24422=>{:code=>"024422", :pref=>"青森県", :name=>"五戸町", :type=>"町", :district=>"東北地方", :furigana=>"ごのへまち"},
      24431=>{:code=>"024431", :pref=>"青森県", :name=>"田子町", :type=>"町", :district=>"東北地方", :furigana=>"たっこまち"},
      24457=>{:code=>"024457", :pref=>"青森県", :name=>"南部町", :type=>"町", :district=>"東北地方", :furigana=>"なんぶちょう"},
      24465=>{:code=>"024465", :pref=>"青森県", :name=>"階上町", :type=>"町", :district=>"東北地方", :furigana=>"はしかみちょう"},
      24503=>{:code=>"024503", :pref=>"青森県", :name=>"新郷村", :type=>"村", :district=>"東北地方", :furigana=>"しんごうむら"},
      30007=>{:code=>"030007", :pref=>"岩手県", :name=>"岩手県", :type=>"都道府県", :district=>"東北地方", :furigana=>"いわてけん"},
      32018=>{:code=>"032018", :pref=>"岩手県", :name=>"盛岡市", :type=>"市", :district=>"東北地方", :furigana=>"もりおかし"},
      32026=>{:code=>"032026", :pref=>"岩手県", :name=>"宮古市", :type=>"市", :district=>"東北地方", :furigana=>"みやこし"},
      32034=>{:code=>"032034", :pref=>"岩手県", :name=>"大船渡市", :type=>"市", :district=>"東北地方", :furigana=>"おおふなとし"},
      32051=>{:code=>"032051", :pref=>"岩手県", :name=>"花巻市", :type=>"市", :district=>"東北地方", :furigana=>"はなまきし"},
      32069=>{:code=>"032069", :pref=>"岩手県", :name=>"北上市", :type=>"市", :district=>"東北地方", :furigana=>"きたかみし"},
      32077=>{:code=>"032077", :pref=>"岩手県", :name=>"久慈市", :type=>"市", :district=>"東北地方", :furigana=>"くじし"},
      32085=>{:code=>"032085", :pref=>"岩手県", :name=>"遠野市", :type=>"市", :district=>"東北地方", :furigana=>"とおのし"},
      32093=>{:code=>"032093", :pref=>"岩手県", :name=>"一関市", :type=>"市", :district=>"東北地方", :furigana=>"いちのせきし"},
      32107=>{:code=>"032107", :pref=>"岩手県", :name=>"陸前高田市", :type=>"市", :district=>"東北地方", :furigana=>"りくぜんたかたし"},
      32115=>{:code=>"032115", :pref=>"岩手県", :name=>"釜石市", :type=>"市", :district=>"東北地方", :furigana=>"かまいしし"},
      32131=>{:code=>"032131", :pref=>"岩手県", :name=>"二戸市", :type=>"市", :district=>"東北地方", :furigana=>"にのへし"},
      32140=>{:code=>"032140", :pref=>"岩手県", :name=>"八幡平市", :type=>"市", :district=>"東北地方", :furigana=>"はちまんたいし"},
      32158=>{:code=>"032158", :pref=>"岩手県", :name=>"奥州市", :type=>"市", :district=>"東北地方", :furigana=>"おうしゅうし"},
      32166=>{:code=>"032166", :pref=>"岩手県", :name=>"滝沢市", :type=>"市", :district=>"東北地方", :furigana=>"たきざわし"},
      33014=>{:code=>"033014", :pref=>"岩手県", :name=>"雫石町", :type=>"町", :district=>"東北地方", :furigana=>"しずくいしちょう"},
      33022=>{:code=>"033022", :pref=>"岩手県", :name=>"葛巻町", :type=>"町", :district=>"東北地方", :furigana=>"くずまきまち"},
      33031=>{:code=>"033031", :pref=>"岩手県", :name=>"岩手町", :type=>"町", :district=>"東北地方", :furigana=>"いわてまち"},
      33219=>{:code=>"033219", :pref=>"岩手県", :name=>"紫波町", :type=>"町", :district=>"東北地方", :furigana=>"しわちょう"},
      33227=>{:code=>"033227", :pref=>"岩手県", :name=>"矢巾町", :type=>"町", :district=>"東北地方", :furigana=>"やはばちょう"},
      33669=>{:code=>"033669", :pref=>"岩手県", :name=>"西和賀町", :type=>"町", :district=>"東北地方", :furigana=>"にしわがまち"},
      33812=>{:code=>"033812", :pref=>"岩手県", :name=>"金ケ崎町", :type=>"町", :district=>"東北地方", :furigana=>"かねがさきちょう"},
      34029=>{:code=>"034029", :pref=>"岩手県", :name=>"平泉町", :type=>"町", :district=>"東北地方", :furigana=>"ひらいずみちょう"},
      34410=>{:code=>"034410", :pref=>"岩手県", :name=>"住田町", :type=>"町", :district=>"東北地方", :furigana=>"すみたちょう"},
      34614=>{:code=>"034614", :pref=>"岩手県", :name=>"大槌町", :type=>"町", :district=>"東北地方", :furigana=>"おおつちちょう"},
      34827=>{:code=>"034827", :pref=>"岩手県", :name=>"山田町", :type=>"町", :district=>"東北地方", :furigana=>"やまだまち"},
      34835=>{:code=>"034835", :pref=>"岩手県", :name=>"岩泉町", :type=>"町", :district=>"東北地方", :furigana=>"いわいずみちょう"},
      34843=>{:code=>"034843", :pref=>"岩手県", :name=>"田野畑村", :type=>"村", :district=>"東北地方", :furigana=>"たのはたむら"},
      34851=>{:code=>"034851", :pref=>"岩手県", :name=>"普代村", :type=>"村", :district=>"東北地方", :furigana=>"ふだいむら"},
      35017=>{:code=>"035017", :pref=>"岩手県", :name=>"軽米町", :type=>"町", :district=>"東北地方", :furigana=>"かるまいまち"},
      35033=>{:code=>"035033", :pref=>"岩手県", :name=>"野田村", :type=>"村", :district=>"東北地方", :furigana=>"のだむら"},
      35068=>{:code=>"035068", :pref=>"岩手県", :name=>"九戸村", :type=>"村", :district=>"東北地方", :furigana=>"くのへむら"},
      35076=>{:code=>"035076", :pref=>"岩手県", :name=>"洋野町", :type=>"町", :district=>"東北地方", :furigana=>"ひろのちょう"},
      35246=>{:code=>"035246", :pref=>"岩手県", :name=>"一戸町", :type=>"町", :district=>"東北地方", :furigana=>"いちのへまち"},
      40002=>{:code=>"040002", :pref=>"宮城県", :name=>"宮城県", :type=>"都道府県", :district=>"東北地方", :furigana=>"みやぎけん"},
      41009=>{:code=>"041009", :pref=>"宮城県", :name=>"仙台市", :type=>"政令市", :district=>"東北地方", :furigana=>"せんだいし"},
      41017=>{:code=>"041017", :pref=>"宮城県", :name=>"仙台市青葉区", :type=>"行政区", :district=>"東北地方", :furigana=>"せんだいしあおばく"},
      41025=>{:code=>"041025", :pref=>"宮城県", :name=>"仙台市宮城野区", :type=>"行政区", :district=>"東北地方", :furigana=>"せんだいしみやぎのく"},
      41033=>{:code=>"041033", :pref=>"宮城県", :name=>"仙台市若林区", :type=>"行政区", :district=>"東北地方", :furigana=>"せんだいしわかばやしく"},
      41041=>{:code=>"041041", :pref=>"宮城県", :name=>"仙台市太白区", :type=>"行政区", :district=>"東北地方", :furigana=>"せんだいしたいはくく"},
      41050=>{:code=>"041050", :pref=>"宮城県", :name=>"仙台市泉区", :type=>"行政区", :district=>"東北地方", :furigana=>"せんだいしいずみく"},
      42021=>{:code=>"042021", :pref=>"宮城県", :name=>"石巻市", :type=>"市", :district=>"東北地方", :furigana=>"いしのまきし"},
      42030=>{:code=>"042030", :pref=>"宮城県", :name=>"塩竈市", :type=>"市", :district=>"東北地方", :furigana=>"しおがまし"},
      42056=>{:code=>"042056", :pref=>"宮城県", :name=>"気仙沼市", :type=>"市", :district=>"東北地方", :furigana=>"けせんぬまし"},
      42064=>{:code=>"042064", :pref=>"宮城県", :name=>"白石市", :type=>"市", :district=>"東北地方", :furigana=>"しろいしし"},
      42072=>{:code=>"042072", :pref=>"宮城県", :name=>"名取市", :type=>"市", :district=>"東北地方", :furigana=>"なとりし"},
      42081=>{:code=>"042081", :pref=>"宮城県", :name=>"角田市", :type=>"市", :district=>"東北地方", :furigana=>"かくだし"},
      42099=>{:code=>"042099", :pref=>"宮城県", :name=>"多賀城市", :type=>"市", :district=>"東北地方", :furigana=>"たがじょうし"},
      42111=>{:code=>"042111", :pref=>"宮城県", :name=>"岩沼市", :type=>"市", :district=>"東北地方", :furigana=>"いわぬまし"},
      42129=>{:code=>"042129", :pref=>"宮城県", :name=>"登米市", :type=>"市", :district=>"東北地方", :furigana=>"とめし"},
      42137=>{:code=>"042137", :pref=>"宮城県", :name=>"栗原市", :type=>"市", :district=>"東北地方", :furigana=>"くりはらし"},
      42145=>{:code=>"042145", :pref=>"宮城県", :name=>"東松島市", :type=>"市", :district=>"東北地方", :furigana=>"ひがしまつしまし"},
      42153=>{:code=>"042153", :pref=>"宮城県", :name=>"大崎市", :type=>"市", :district=>"東北地方", :furigana=>"おおさきし"},
      42161=>{:code=>"042161", :pref=>"宮城県", :name=>"富谷市", :type=>"市", :district=>"東北地方", :furigana=>"とみやし"},
      43010=>{:code=>"043010", :pref=>"宮城県", :name=>"蔵王町", :type=>"町", :district=>"東北地方", :furigana=>"ざおうまち"},
      43028=>{:code=>"043028", :pref=>"宮城県", :name=>"七ヶ宿町", :type=>"町", :district=>"東北地方", :furigana=>"しちかしゅくまち"},
      43214=>{:code=>"043214", :pref=>"宮城県", :name=>"大河原町", :type=>"町", :district=>"東北地方", :furigana=>"おおがわらまち"},
      43222=>{:code=>"043222", :pref=>"宮城県", :name=>"村田町", :type=>"町", :district=>"東北地方", :furigana=>"むらたまち"},
      43231=>{:code=>"043231", :pref=>"宮城県", :name=>"柴田町", :type=>"町", :district=>"東北地方", :furigana=>"しばたまち"},
      43249=>{:code=>"043249", :pref=>"宮城県", :name=>"川崎町", :type=>"町", :district=>"東北地方", :furigana=>"かわさきまち"},
      43419=>{:code=>"043419", :pref=>"宮城県", :name=>"丸森町", :type=>"町", :district=>"東北地方", :furigana=>"まるもりまち"},
      43613=>{:code=>"043613", :pref=>"宮城県", :name=>"亘理町", :type=>"町", :district=>"東北地方", :furigana=>"わたりちょう"},
      43621=>{:code=>"043621", :pref=>"宮城県", :name=>"山元町", :type=>"町", :district=>"東北地方", :furigana=>"やまもとちょう"},
      44016=>{:code=>"044016", :pref=>"宮城県", :name=>"松島町", :type=>"町", :district=>"東北地方", :furigana=>"まつしままち"},
      44041=>{:code=>"044041", :pref=>"宮城県", :name=>"七ヶ浜町", :type=>"町", :district=>"東北地方", :furigana=>"しちがはままち"},
      44067=>{:code=>"044067", :pref=>"宮城県", :name=>"利府町", :type=>"町", :district=>"東北地方", :furigana=>"りふちょう"},
      44211=>{:code=>"044211", :pref=>"宮城県", :name=>"大和町", :type=>"町", :district=>"東北地方", :furigana=>"たいわちょう"},
      44229=>{:code=>"044229", :pref=>"宮城県", :name=>"大郷町", :type=>"町", :district=>"東北地方", :furigana=>"おおさとちょう"},
      44245=>{:code=>"044245", :pref=>"宮城県", :name=>"大衡村", :type=>"村", :district=>"東北地方", :furigana=>"おおひらむら"},
      44440=>{:code=>"044440", :pref=>"宮城県", :name=>"色麻町", :type=>"町", :district=>"東北地方", :furigana=>"しかまちょう"},
      44458=>{:code=>"044458", :pref=>"宮城県", :name=>"加美町", :type=>"町", :district=>"東北地方", :furigana=>"かみまち"},
      45012=>{:code=>"045012", :pref=>"宮城県", :name=>"涌谷町", :type=>"町", :district=>"東北地方", :furigana=>"わくやちょう"},
      45055=>{:code=>"045055", :pref=>"宮城県", :name=>"美里町", :type=>"町", :district=>"東北地方", :furigana=>"みさとまち"},
      45811=>{:code=>"045811", :pref=>"宮城県", :name=>"女川町", :type=>"町", :district=>"東北地方", :furigana=>"おながわちょう"},
      46060=>{:code=>"046060", :pref=>"宮城県", :name=>"南三陸町", :type=>"町", :district=>"東北地方", :furigana=>"みなみさんりくちょう"},
      50008=>{:code=>"050008", :pref=>"秋田県", :name=>"秋田県", :type=>"都道府県", :district=>"東北地方", :furigana=>"あきたけん"},
      52019=>{:code=>"052019", :pref=>"秋田県", :name=>"秋田市", :type=>"市", :district=>"東北地方", :furigana=>"あきたし"},
      52027=>{:code=>"052027", :pref=>"秋田県", :name=>"能代市", :type=>"市", :district=>"東北地方", :furigana=>"のしろし"},
      52035=>{:code=>"052035", :pref=>"秋田県", :name=>"横手市", :type=>"市", :district=>"東北地方", :furigana=>"よこてし"},
      52043=>{:code=>"052043", :pref=>"秋田県", :name=>"大館市", :type=>"市", :district=>"東北地方", :furigana=>"おおだてし"},
      52060=>{:code=>"052060", :pref=>"秋田県", :name=>"男鹿市", :type=>"市", :district=>"東北地方", :furigana=>"おがし"},
      52078=>{:code=>"052078", :pref=>"秋田県", :name=>"湯沢市", :type=>"市", :district=>"東北地方", :furigana=>"ゆざわし"},
      52094=>{:code=>"052094", :pref=>"秋田県", :name=>"鹿角市", :type=>"市", :district=>"東北地方", :furigana=>"かづのし"},
      52108=>{:code=>"052108", :pref=>"秋田県", :name=>"由利本荘市", :type=>"市", :district=>"東北地方", :furigana=>"ゆりほんじょうし"},
      52116=>{:code=>"052116", :pref=>"秋田県", :name=>"潟上市", :type=>"市", :district=>"東北地方", :furigana=>"かたがみし"},
      52124=>{:code=>"052124", :pref=>"秋田県", :name=>"大仙市", :type=>"市", :district=>"東北地方", :furigana=>"だいせんし"},
      52132=>{:code=>"052132", :pref=>"秋田県", :name=>"北秋田市", :type=>"市", :district=>"東北地方", :furigana=>"きたあきたし"},
      52141=>{:code=>"052141", :pref=>"秋田県", :name=>"にかほ市", :type=>"市", :district=>"東北地方", :furigana=>"にかほし"},
      52159=>{:code=>"052159", :pref=>"秋田県", :name=>"仙北市", :type=>"市", :district=>"東北地方", :furigana=>"せんぼくし"},
      53031=>{:code=>"053031", :pref=>"秋田県", :name=>"小坂町", :type=>"町", :district=>"東北地方", :furigana=>"こさかまち"},
      53279=>{:code=>"053279", :pref=>"秋田県", :name=>"上小阿仁村", :type=>"村", :district=>"東北地方", :furigana=>"かみこあにむら"},
      53465=>{:code=>"053465", :pref=>"秋田県", :name=>"藤里町", :type=>"町", :district=>"東北地方", :furigana=>"ふじさとまち"},
      53481=>{:code=>"053481", :pref=>"秋田県", :name=>"三種町", :type=>"町", :district=>"東北地方", :furigana=>"みたねちょう"},
      53490=>{:code=>"053490", :pref=>"秋田県", :name=>"八峰町", :type=>"町", :district=>"東北地方", :furigana=>"はっぽうちょう"},
      53619=>{:code=>"053619", :pref=>"秋田県", :name=>"五城目町", :type=>"町", :district=>"東北地方", :furigana=>"ごじょうめまち"},
      53635=>{:code=>"053635", :pref=>"秋田県", :name=>"八郎潟町", :type=>"町", :district=>"東北地方", :furigana=>"はちろうがたまち"},
      53660=>{:code=>"053660", :pref=>"秋田県", :name=>"井川町", :type=>"町", :district=>"東北地方", :furigana=>"いかわまち"},
      53686=>{:code=>"053686", :pref=>"秋田県", :name=>"大潟村", :type=>"村", :district=>"東北地方", :furigana=>"おおがたむら"},
      54348=>{:code=>"054348", :pref=>"秋田県", :name=>"美郷町", :type=>"町", :district=>"東北地方", :furigana=>"みさとちょう"},
      54631=>{:code=>"054631", :pref=>"秋田県", :name=>"羽後町", :type=>"町", :district=>"東北地方", :furigana=>"うごまち"},
      54640=>{:code=>"054640", :pref=>"秋田県", :name=>"東成瀬村", :type=>"村", :district=>"東北地方", :furigana=>"ひがしなるせむら"},
      60003=>{:code=>"060003", :pref=>"山形県", :name=>"山形県", :type=>"都道府県", :district=>"東北地方", :furigana=>"やまがたけん"},
      62014=>{:code=>"062014", :pref=>"山形県", :name=>"山形市", :type=>"市", :district=>"東北地方", :furigana=>"やまがたし"},
      62022=>{:code=>"062022", :pref=>"山形県", :name=>"米沢市", :type=>"市", :district=>"東北地方", :furigana=>"よねざわし"},
      62031=>{:code=>"062031", :pref=>"山形県", :name=>"鶴岡市", :type=>"市", :district=>"東北地方", :furigana=>"つるおかし"},
      62049=>{:code=>"062049", :pref=>"山形県", :name=>"酒田市", :type=>"市", :district=>"東北地方", :furigana=>"さかたし"},
      62057=>{:code=>"062057", :pref=>"山形県", :name=>"新庄市", :type=>"市", :district=>"東北地方", :furigana=>"しんじょうし"},
      62065=>{:code=>"062065", :pref=>"山形県", :name=>"寒河江市", :type=>"市", :district=>"東北地方", :furigana=>"さがえし"},
      62073=>{:code=>"062073", :pref=>"山形県", :name=>"上山市", :type=>"市", :district=>"東北地方", :furigana=>"かみのやまし"},
      62081=>{:code=>"062081", :pref=>"山形県", :name=>"村山市", :type=>"市", :district=>"東北地方", :furigana=>"むらやまし"},
      62090=>{:code=>"062090", :pref=>"山形県", :name=>"長井市", :type=>"市", :district=>"東北地方", :furigana=>"ながいし"},
      62103=>{:code=>"062103", :pref=>"山形県", :name=>"天童市", :type=>"市", :district=>"東北地方", :furigana=>"てんどうし"},
      62111=>{:code=>"062111", :pref=>"山形県", :name=>"東根市", :type=>"市", :district=>"東北地方", :furigana=>"ひがしねし"},
      62120=>{:code=>"062120", :pref=>"山形県", :name=>"尾花沢市", :type=>"市", :district=>"東北地方", :furigana=>"おばなざわし"},
      62138=>{:code=>"062138", :pref=>"山形県", :name=>"南陽市", :type=>"市", :district=>"東北地方", :furigana=>"なんようし"},
      63011=>{:code=>"063011", :pref=>"山形県", :name=>"山辺町", :type=>"町", :district=>"東北地方", :furigana=>"やまのべまち"},
      63029=>{:code=>"063029", :pref=>"山形県", :name=>"中山町", :type=>"町", :district=>"東北地方", :furigana=>"なかやままち"},
      63215=>{:code=>"063215", :pref=>"山形県", :name=>"河北町", :type=>"町", :district=>"東北地方", :furigana=>"かほくちょう"},
      63223=>{:code=>"063223", :pref=>"山形県", :name=>"西川町", :type=>"町", :district=>"東北地方", :furigana=>"にしかわまち"},
      63231=>{:code=>"063231", :pref=>"山形県", :name=>"朝日町", :type=>"町", :district=>"東北地方", :furigana=>"あさひまち"},
      63240=>{:code=>"063240", :pref=>"山形県", :name=>"大江町", :type=>"町", :district=>"東北地方", :furigana=>"おおえまち"},
      63410=>{:code=>"063410", :pref=>"山形県", :name=>"大石田町", :type=>"町", :district=>"東北地方", :furigana=>"おおいしだまち"},
      63614=>{:code=>"063614", :pref=>"山形県", :name=>"金山町", :type=>"町", :district=>"東北地方", :furigana=>"かねやままち"},
      63622=>{:code=>"063622", :pref=>"山形県", :name=>"最上町", :type=>"町", :district=>"東北地方", :furigana=>"もがみまち"},
      63631=>{:code=>"063631", :pref=>"山形県", :name=>"舟形町", :type=>"町", :district=>"東北地方", :furigana=>"ふながたまち"},
      63649=>{:code=>"063649", :pref=>"山形県", :name=>"真室川町", :type=>"町", :district=>"東北地方", :furigana=>"まむろがわまち"},
      63657=>{:code=>"063657", :pref=>"山形県", :name=>"大蔵村", :type=>"村", :district=>"東北地方", :furigana=>"おおくらむら"},
      63665=>{:code=>"063665", :pref=>"山形県", :name=>"鮭川村", :type=>"村", :district=>"東北地方", :furigana=>"さけがわむら"},
      63673=>{:code=>"063673", :pref=>"山形県", :name=>"戸沢村", :type=>"村", :district=>"東北地方", :furigana=>"とざわむら"},
      63819=>{:code=>"063819", :pref=>"山形県", :name=>"高畠町", :type=>"町", :district=>"東北地方", :furigana=>"たかはたまち"},
      63827=>{:code=>"063827", :pref=>"山形県", :name=>"川西町", :type=>"町", :district=>"東北地方", :furigana=>"かわにしまち"},
      64017=>{:code=>"064017", :pref=>"山形県", :name=>"小国町", :type=>"町", :district=>"東北地方", :furigana=>"おぐにまち"},
      64025=>{:code=>"064025", :pref=>"山形県", :name=>"白鷹町", :type=>"町", :district=>"東北地方", :furigana=>"しらたかまち"},
      64033=>{:code=>"064033", :pref=>"山形県", :name=>"飯豊町", :type=>"町", :district=>"東北地方", :furigana=>"いいでまち"},
      64262=>{:code=>"064262", :pref=>"山形県", :name=>"三川町", :type=>"町", :district=>"東北地方", :furigana=>"みかわまち"},
      64289=>{:code=>"064289", :pref=>"山形県", :name=>"庄内町", :type=>"町", :district=>"東北地方", :furigana=>"しようないまち"},
      64611=>{:code=>"064611", :pref=>"山形県", :name=>"遊佐町", :type=>"町", :district=>"東北地方", :furigana=>"ゆざまち"},
      70009=>{:code=>"070009", :pref=>"福島県", :name=>"福島県", :type=>"都道府県", :district=>"東北地方", :furigana=>"ふくしまけん"},
      72010=>{:code=>"072010", :pref=>"福島県", :name=>"福島市", :type=>"市", :district=>"東北地方", :furigana=>"ふくしまし"},
      72028=>{:code=>"072028", :pref=>"福島県", :name=>"会津若松市", :type=>"市", :district=>"東北地方", :furigana=>"あいづわかまつし"},
      72036=>{:code=>"072036", :pref=>"福島県", :name=>"郡山市", :type=>"市", :district=>"東北地方", :furigana=>"こおりやまし"},
      72044=>{:code=>"072044", :pref=>"福島県", :name=>"いわき市", :type=>"市", :district=>"東北地方", :furigana=>"いわきし"},
      72052=>{:code=>"072052", :pref=>"福島県", :name=>"白河市", :type=>"市", :district=>"東北地方", :furigana=>"しらかわし"},
      72079=>{:code=>"072079", :pref=>"福島県", :name=>"須賀川市", :type=>"市", :district=>"東北地方", :furigana=>"すかがわし"},
      72087=>{:code=>"072087", :pref=>"福島県", :name=>"喜多方市", :type=>"市", :district=>"東北地方", :furigana=>"きたかたし"},
      72095=>{:code=>"072095", :pref=>"福島県", :name=>"相馬市", :type=>"市", :district=>"東北地方", :furigana=>"そうまし"},
      72109=>{:code=>"072109", :pref=>"福島県", :name=>"二本松市", :type=>"市", :district=>"東北地方", :furigana=>"にほんまつし"},
      72117=>{:code=>"072117", :pref=>"福島県", :name=>"田村市", :type=>"市", :district=>"東北地方", :furigana=>"たむらし"},
      72125=>{:code=>"072125", :pref=>"福島県", :name=>"南相馬市", :type=>"市", :district=>"東北地方", :furigana=>"みなみそうまし"},
      72133=>{:code=>"072133", :pref=>"福島県", :name=>"伊達市", :type=>"市", :district=>"東北地方", :furigana=>"だてし"},
      72141=>{:code=>"072141", :pref=>"福島県", :name=>"本宮市", :type=>"市", :district=>"東北地方", :furigana=>"もとみやし"},
      73016=>{:code=>"073016", :pref=>"福島県", :name=>"桑折町", :type=>"町", :district=>"東北地方", :furigana=>"こおりまち"},
      73032=>{:code=>"073032", :pref=>"福島県", :name=>"国見町", :type=>"町", :district=>"東北地方", :furigana=>"くにみまち"},
      73083=>{:code=>"073083", :pref=>"福島県", :name=>"川俣町", :type=>"町", :district=>"東北地方", :furigana=>"かわまたまち"},
      73229=>{:code=>"073229", :pref=>"福島県", :name=>"大玉村", :type=>"村", :district=>"東北地方", :furigana=>"おおたまむら"},
      73423=>{:code=>"073423", :pref=>"福島県", :name=>"鏡石町", :type=>"町", :district=>"東北地方", :furigana=>"かがみいしまち"},
      73440=>{:code=>"073440", :pref=>"福島県", :name=>"天栄村", :type=>"村", :district=>"東北地方", :furigana=>"てんえいむら"},
      73628=>{:code=>"073628", :pref=>"福島県", :name=>"下郷町", :type=>"町", :district=>"東北地方", :furigana=>"しもごうまち"},
      73644=>{:code=>"073644", :pref=>"福島県", :name=>"檜枝岐村", :type=>"村", :district=>"東北地方", :furigana=>"ひのえまたむら"},
      73679=>{:code=>"073679", :pref=>"福島県", :name=>"只見町", :type=>"町", :district=>"東北地方", :furigana=>"ただみまち"},
      73687=>{:code=>"073687", :pref=>"福島県", :name=>"南会津町", :type=>"町", :district=>"東北地方", :furigana=>"みなみあいづまち"},
      74021=>{:code=>"074021", :pref=>"福島県", :name=>"北塩原村", :type=>"村", :district=>"東北地方", :furigana=>"きたしおばらむら"},
      74055=>{:code=>"074055", :pref=>"福島県", :name=>"西会津町", :type=>"町", :district=>"東北地方", :furigana=>"にしあいづまち"},
      74071=>{:code=>"074071", :pref=>"福島県", :name=>"磐梯町", :type=>"町", :district=>"東北地方", :furigana=>"ばんだいまち"},
      74080=>{:code=>"074080", :pref=>"福島県", :name=>"猪苗代町", :type=>"町", :district=>"東北地方", :furigana=>"いなわしろまち"},
      74217=>{:code=>"074217", :pref=>"福島県", :name=>"会津坂下町", :type=>"町", :district=>"東北地方", :furigana=>"あいづばんげまち"},
      74225=>{:code=>"074225", :pref=>"福島県", :name=>"湯川村", :type=>"村", :district=>"東北地方", :furigana=>"ゆがわむら"},
      74233=>{:code=>"074233", :pref=>"福島県", :name=>"柳津町", :type=>"町", :district=>"東北地方", :furigana=>"やないづまち"},
      74446=>{:code=>"074446", :pref=>"福島県", :name=>"三島町", :type=>"町", :district=>"東北地方", :furigana=>"みしままち"},
      74454=>{:code=>"074454", :pref=>"福島県", :name=>"金山町", :type=>"町", :district=>"東北地方", :furigana=>"かねやままち"},
      74462=>{:code=>"074462", :pref=>"福島県", :name=>"昭和村", :type=>"村", :district=>"東北地方", :furigana=>"しょうわむら"},
      74471=>{:code=>"074471", :pref=>"福島県", :name=>"会津美里町", :type=>"町", :district=>"東北地方", :furigana=>"あいづみさとまち"},
      74616=>{:code=>"074616", :pref=>"福島県", :name=>"西郷村", :type=>"村", :district=>"東北地方", :furigana=>"にしごうむら"},
      74641=>{:code=>"074641", :pref=>"福島県", :name=>"泉崎村", :type=>"村", :district=>"東北地方", :furigana=>"いずみざきむら"},
      74659=>{:code=>"074659", :pref=>"福島県", :name=>"中島村", :type=>"村", :district=>"東北地方", :furigana=>"なかじまむら"},
      74667=>{:code=>"074667", :pref=>"福島県", :name=>"矢吹町", :type=>"町", :district=>"東北地方", :furigana=>"やぶきまち"},
      74811=>{:code=>"074811", :pref=>"福島県", :name=>"棚倉町", :type=>"町", :district=>"東北地方", :furigana=>"たなぐらまち"},
      74829=>{:code=>"074829", :pref=>"福島県", :name=>"矢祭町", :type=>"町", :district=>"東北地方", :furigana=>"やまつりまち"},
      74837=>{:code=>"074837", :pref=>"福島県", :name=>"塙町", :type=>"町", :district=>"東北地方", :furigana=>"はなわまち"},
      74845=>{:code=>"074845", :pref=>"福島県", :name=>"鮫川村", :type=>"村", :district=>"東北地方", :furigana=>"さめがわむら"},
      75019=>{:code=>"075019", :pref=>"福島県", :name=>"石川町", :type=>"町", :district=>"東北地方", :furigana=>"いしかわまち"},
      75027=>{:code=>"075027", :pref=>"福島県", :name=>"玉川村", :type=>"村", :district=>"東北地方", :furigana=>"たまかわむら"},
      75035=>{:code=>"075035", :pref=>"福島県", :name=>"平田村", :type=>"村", :district=>"東北地方", :furigana=>"ひらたむら"},
      75043=>{:code=>"075043", :pref=>"福島県", :name=>"浅川町", :type=>"町", :district=>"東北地方", :furigana=>"あさかわまち"},
      75051=>{:code=>"075051", :pref=>"福島県", :name=>"古殿町", :type=>"町", :district=>"東北地方", :furigana=>"ふるどのまち"},
      75213=>{:code=>"075213", :pref=>"福島県", :name=>"三春町", :type=>"町", :district=>"東北地方", :furigana=>"みはるまち"},
      75221=>{:code=>"075221", :pref=>"福島県", :name=>"小野町", :type=>"町", :district=>"東北地方", :furigana=>"おのまち"},
      75418=>{:code=>"075418", :pref=>"福島県", :name=>"広野町", :type=>"町", :district=>"東北地方", :furigana=>"ひろのまち"},
      75426=>{:code=>"075426", :pref=>"福島県", :name=>"楢葉町", :type=>"町", :district=>"東北地方", :furigana=>"ならはまち"},
      75434=>{:code=>"075434", :pref=>"福島県", :name=>"富岡町", :type=>"町", :district=>"東北地方", :furigana=>"とみおかまち"},
      75442=>{:code=>"075442", :pref=>"福島県", :name=>"川内村", :type=>"村", :district=>"東北地方", :furigana=>"かわうちむら"},
      75451=>{:code=>"075451", :pref=>"福島県", :name=>"大熊町", :type=>"町", :district=>"東北地方", :furigana=>"おおくままち"},
      75469=>{:code=>"075469", :pref=>"福島県", :name=>"双葉町", :type=>"町", :district=>"東北地方", :furigana=>"ふたばまち"},
      75477=>{:code=>"075477", :pref=>"福島県", :name=>"浪江町", :type=>"町", :district=>"東北地方", :furigana=>"なみえまち"},
      75485=>{:code=>"075485", :pref=>"福島県", :name=>"葛尾村", :type=>"村", :district=>"東北地方", :furigana=>"かつらおむら"},
      75612=>{:code=>"075612", :pref=>"福島県", :name=>"新地町", :type=>"町", :district=>"東北地方", :furigana=>"しんちまち"},
      75647=>{:code=>"075647", :pref=>"福島県", :name=>"飯舘村", :type=>"村", :district=>"東北地方", :furigana=>"いいたてむら"},
      80004=>{:code=>"080004", :pref=>"茨城県", :name=>"茨城県", :type=>"都道府県", :district=>"関東地方", :furigana=>"いばらきけん"},
      82015=>{:code=>"082015", :pref=>"茨城県", :name=>"水戸市", :type=>"市", :district=>"関東地方", :furigana=>"みとし"},
      82023=>{:code=>"082023", :pref=>"茨城県", :name=>"日立市", :type=>"市", :district=>"関東地方", :furigana=>"ひたちし"},
      82031=>{:code=>"082031", :pref=>"茨城県", :name=>"土浦市", :type=>"市", :district=>"関東地方", :furigana=>"つちうらし"},
      82040=>{:code=>"082040", :pref=>"茨城県", :name=>"古河市", :type=>"市", :district=>"関東地方", :furigana=>"こがし"},
      82058=>{:code=>"082058", :pref=>"茨城県", :name=>"石岡市", :type=>"市", :district=>"関東地方", :furigana=>"いしおかし"},
      82074=>{:code=>"082074", :pref=>"茨城県", :name=>"結城市", :type=>"市", :district=>"関東地方", :furigana=>"ゆうきし"},
      82082=>{:code=>"082082", :pref=>"茨城県", :name=>"龍ケ崎市", :type=>"市", :district=>"関東地方", :furigana=>"りゅうがさきし"},
      82104=>{:code=>"082104", :pref=>"茨城県", :name=>"下妻市", :type=>"市", :district=>"関東地方", :furigana=>"しもつまし"},
      82112=>{:code=>"082112", :pref=>"茨城県", :name=>"常総市", :type=>"市", :district=>"関東地方", :furigana=>"じょうそうし"},
      82121=>{:code=>"082121", :pref=>"茨城県", :name=>"常陸太田市", :type=>"市", :district=>"関東地方", :furigana=>"ひたちおおたし"},
      82147=>{:code=>"082147", :pref=>"茨城県", :name=>"高萩市", :type=>"市", :district=>"関東地方", :furigana=>"たかはぎし"},
      82155=>{:code=>"082155", :pref=>"茨城県", :name=>"北茨城市", :type=>"市", :district=>"関東地方", :furigana=>"きたいばらきし"},
      82163=>{:code=>"082163", :pref=>"茨城県", :name=>"笠間市", :type=>"市", :district=>"関東地方", :furigana=>"かさまし"},
      82171=>{:code=>"082171", :pref=>"茨城県", :name=>"取手市", :type=>"市", :district=>"関東地方", :furigana=>"とりでし"},
      82198=>{:code=>"082198", :pref=>"茨城県", :name=>"牛久市", :type=>"市", :district=>"関東地方", :furigana=>"うしくし"},
      82201=>{:code=>"082201", :pref=>"茨城県", :name=>"つくば市", :type=>"市", :district=>"関東地方", :furigana=>"つくばし"},
      82210=>{:code=>"082210", :pref=>"茨城県", :name=>"ひたちなか市", :type=>"市", :district=>"関東地方", :furigana=>"ひたちなかし"},
      82228=>{:code=>"082228", :pref=>"茨城県", :name=>"鹿嶋市", :type=>"市", :district=>"関東地方", :furigana=>"かしまし"},
      82236=>{:code=>"082236", :pref=>"茨城県", :name=>"潮来市", :type=>"市", :district=>"関東地方", :furigana=>"いたこし"},
      82244=>{:code=>"082244", :pref=>"茨城県", :name=>"守谷市", :type=>"市", :district=>"関東地方", :furigana=>"もりやし"},
      82252=>{:code=>"082252", :pref=>"茨城県", :name=>"常陸大宮市", :type=>"市", :district=>"関東地方", :furigana=>"ひたちおおみやし"},
      82261=>{:code=>"082261", :pref=>"茨城県", :name=>"那珂市", :type=>"市", :district=>"関東地方", :furigana=>"なかし"},
      82279=>{:code=>"082279", :pref=>"茨城県", :name=>"筑西市", :type=>"市", :district=>"関東地方", :furigana=>"ちくせいし"},
      82287=>{:code=>"082287", :pref=>"茨城県", :name=>"坂東市", :type=>"市", :district=>"関東地方", :furigana=>"ばんどうし"},
      82295=>{:code=>"082295", :pref=>"茨城県", :name=>"稲敷市", :type=>"市", :district=>"関東地方", :furigana=>"いなしきし"},
      82309=>{:code=>"082309", :pref=>"茨城県", :name=>"かすみがうら市", :type=>"市", :district=>"関東地方", :furigana=>"かすみがうらし"},
      82317=>{:code=>"082317", :pref=>"茨城県", :name=>"桜川市", :type=>"市", :district=>"関東地方", :furigana=>"さくらがわし"},
      82325=>{:code=>"082325", :pref=>"茨城県", :name=>"神栖市", :type=>"市", :district=>"関東地方", :furigana=>"かみすし"},
      82333=>{:code=>"082333", :pref=>"茨城県", :name=>"行方市", :type=>"市", :district=>"関東地方", :furigana=>"なめがたし"},
      82341=>{:code=>"082341", :pref=>"茨城県", :name=>"鉾田市", :type=>"市", :district=>"関東地方", :furigana=>"ほこたし"},
      82350=>{:code=>"082350", :pref=>"茨城県", :name=>"つくばみらい市", :type=>"市", :district=>"関東地方", :furigana=>"つくばみらいし"},
      82368=>{:code=>"082368", :pref=>"茨城県", :name=>"小美玉市", :type=>"市", :district=>"関東地方", :furigana=>"おみたまし"},
      83020=>{:code=>"083020", :pref=>"茨城県", :name=>"茨城町", :type=>"町", :district=>"関東地方", :furigana=>"いばらきまち"},
      83097=>{:code=>"083097", :pref=>"茨城県", :name=>"大洗町", :type=>"町", :district=>"関東地方", :furigana=>"おおあらいまち"},
      83101=>{:code=>"083101", :pref=>"茨城県", :name=>"城里町", :type=>"町", :district=>"関東地方", :furigana=>"しろさとまち"},
      83411=>{:code=>"083411", :pref=>"茨城県", :name=>"東海村", :type=>"村", :district=>"関東地方", :furigana=>"とうかいむら"},
      83640=>{:code=>"083640", :pref=>"茨城県", :name=>"大子町", :type=>"町", :district=>"関東地方", :furigana=>"だいごまち"},
      84425=>{:code=>"084425", :pref=>"茨城県", :name=>"美浦村", :type=>"村", :district=>"関東地方", :furigana=>"みほむら"},
      84433=>{:code=>"084433", :pref=>"茨城県", :name=>"阿見町", :type=>"町", :district=>"関東地方", :furigana=>"あみまち"},
      84476=>{:code=>"084476", :pref=>"茨城県", :name=>"河内町", :type=>"町", :district=>"関東地方", :furigana=>"かわちまち"},
      85219=>{:code=>"085219", :pref=>"茨城県", :name=>"八千代町", :type=>"町", :district=>"関東地方", :furigana=>"やちよまち"},
      85421=>{:code=>"085421", :pref=>"茨城県", :name=>"五霞町", :type=>"町", :district=>"関東地方", :furigana=>"ごかまち"},
      85464=>{:code=>"085464", :pref=>"茨城県", :name=>"境町", :type=>"町", :district=>"関東地方", :furigana=>"さかいまち"},
      85642=>{:code=>"085642", :pref=>"茨城県", :name=>"利根町", :type=>"町", :district=>"関東地方", :furigana=>"とねまち"},
      90000=>{:code=>"090000", :pref=>"栃木県", :name=>"栃木県", :type=>"都道府県", :district=>"関東地方", :furigana=>"とちぎけん"},
      92011=>{:code=>"092011", :pref=>"栃木県", :name=>"宇都宮市", :type=>"市", :district=>"関東地方", :furigana=>"うつのみやし"},
      92029=>{:code=>"092029", :pref=>"栃木県", :name=>"足利市", :type=>"市", :district=>"関東地方", :furigana=>"あしかがし"},
      92037=>{:code=>"092037", :pref=>"栃木県", :name=>"栃木市", :type=>"市", :district=>"関東地方", :furigana=>"とちぎし"},
      92045=>{:code=>"092045", :pref=>"栃木県", :name=>"佐野市", :type=>"市", :district=>"関東地方", :furigana=>"さのし"},
      92053=>{:code=>"092053", :pref=>"栃木県", :name=>"鹿沼市", :type=>"市", :district=>"関東地方", :furigana=>"かぬまし"},
      92061=>{:code=>"092061", :pref=>"栃木県", :name=>"日光市", :type=>"市", :district=>"関東地方", :furigana=>"にっこうし"},
      92088=>{:code=>"092088", :pref=>"栃木県", :name=>"小山市", :type=>"市", :district=>"関東地方", :furigana=>"おやまし"},
      92096=>{:code=>"092096", :pref=>"栃木県", :name=>"真岡市", :type=>"市", :district=>"関東地方", :furigana=>"もおかし"},
      92100=>{:code=>"092100", :pref=>"栃木県", :name=>"大田原市", :type=>"市", :district=>"関東地方", :furigana=>"おおたわらし"},
      92118=>{:code=>"092118", :pref=>"栃木県", :name=>"矢板市", :type=>"市", :district=>"関東地方", :furigana=>"やいたし"},
      92134=>{:code=>"092134", :pref=>"栃木県", :name=>"那須塩原市", :type=>"市", :district=>"関東地方", :furigana=>"なすしおばらし"},
      92142=>{:code=>"092142", :pref=>"栃木県", :name=>"さくら市", :type=>"市", :district=>"関東地方", :furigana=>"さくらし"},
      92151=>{:code=>"092151", :pref=>"栃木県", :name=>"那須烏山市", :type=>"市", :district=>"関東地方", :furigana=>"なすからすやまし"},
      92169=>{:code=>"092169", :pref=>"栃木県", :name=>"下野市", :type=>"市", :district=>"関東地方", :furigana=>"しもつけし"},
      93017=>{:code=>"093017", :pref=>"栃木県", :name=>"上三川町", :type=>"町", :district=>"関東地方", :furigana=>"かみのかわまち"},
      93424=>{:code=>"093424", :pref=>"栃木県", :name=>"益子町", :type=>"町", :district=>"関東地方", :furigana=>"ましこまち"},
      93432=>{:code=>"093432", :pref=>"栃木県", :name=>"茂木町", :type=>"町", :district=>"関東地方", :furigana=>"もてぎまち"},
      93441=>{:code=>"093441", :pref=>"栃木県", :name=>"市貝町", :type=>"町", :district=>"関東地方", :furigana=>"いちかいまち"},
      93459=>{:code=>"093459", :pref=>"栃木県", :name=>"芳賀町", :type=>"町", :district=>"関東地方", :furigana=>"はがまち"},
      93611=>{:code=>"093611", :pref=>"栃木県", :name=>"壬生町", :type=>"町", :district=>"関東地方", :furigana=>"みぶまち"},
      93645=>{:code=>"093645", :pref=>"栃木県", :name=>"野木町", :type=>"町", :district=>"関東地方", :furigana=>"のぎまち"},
      93840=>{:code=>"093840", :pref=>"栃木県", :name=>"塩谷町", :type=>"町", :district=>"関東地方", :furigana=>"しおやまち"},
      93866=>{:code=>"093866", :pref=>"栃木県", :name=>"高根沢町", :type=>"町", :district=>"関東地方", :furigana=>"たかねざわまち"},
      94072=>{:code=>"094072", :pref=>"栃木県", :name=>"那須町", :type=>"町", :district=>"関東地方", :furigana=>"なすまち"},
      94111=>{:code=>"094111", :pref=>"栃木県", :name=>"那珂川町", :type=>"町", :district=>"関東地方", :furigana=>"なかがわまち"},
      100005=>{:code=>"100005", :pref=>"群馬県", :name=>"群馬県", :type=>"都道府県", :district=>"関東地方", :furigana=>"ぐんまけん"},
      102016=>{:code=>"102016", :pref=>"群馬県", :name=>"前橋市", :type=>"市", :district=>"関東地方", :furigana=>"まえばしし"},
      102024=>{:code=>"102024", :pref=>"群馬県", :name=>"高崎市", :type=>"市", :district=>"関東地方", :furigana=>"たかさきし"},
      102032=>{:code=>"102032", :pref=>"群馬県", :name=>"桐生市", :type=>"市", :district=>"関東地方", :furigana=>"きりゅうし"},
      102041=>{:code=>"102041", :pref=>"群馬県", :name=>"伊勢崎市", :type=>"市", :district=>"関東地方", :furigana=>"いせさきし"},
      102059=>{:code=>"102059", :pref=>"群馬県", :name=>"太田市", :type=>"市", :district=>"関東地方", :furigana=>"おおたし"},
      102067=>{:code=>"102067", :pref=>"群馬県", :name=>"沼田市", :type=>"市", :district=>"関東地方", :furigana=>"ぬまたし"},
      102075=>{:code=>"102075", :pref=>"群馬県", :name=>"館林市", :type=>"市", :district=>"関東地方", :furigana=>"たてばやしし"},
      102083=>{:code=>"102083", :pref=>"群馬県", :name=>"渋川市", :type=>"市", :district=>"関東地方", :furigana=>"しぶかわし"},
      102091=>{:code=>"102091", :pref=>"群馬県", :name=>"藤岡市", :type=>"市", :district=>"関東地方", :furigana=>"ふじおかし"},
      102105=>{:code=>"102105", :pref=>"群馬県", :name=>"富岡市", :type=>"市", :district=>"関東地方", :furigana=>"とみおかし"},
      102113=>{:code=>"102113", :pref=>"群馬県", :name=>"安中市", :type=>"市", :district=>"関東地方", :furigana=>"あんなかし"},
      102121=>{:code=>"102121", :pref=>"群馬県", :name=>"みどり市", :type=>"市", :district=>"関東地方", :furigana=>"みどりし"},
      103446=>{:code=>"103446", :pref=>"群馬県", :name=>"榛東村", :type=>"村", :district=>"関東地方", :furigana=>"しんとうむら"},
      103454=>{:code=>"103454", :pref=>"群馬県", :name=>"吉岡町", :type=>"町", :district=>"関東地方", :furigana=>"よしおかまち"},
      103667=>{:code=>"103667", :pref=>"群馬県", :name=>"上野村", :type=>"村", :district=>"関東地方", :furigana=>"うえのむら"},
      103675=>{:code=>"103675", :pref=>"群馬県", :name=>"神流町", :type=>"町", :district=>"関東地方", :furigana=>"かんなまち"},
      103829=>{:code=>"103829", :pref=>"群馬県", :name=>"下仁田町", :type=>"町", :district=>"関東地方", :furigana=>"しもにたまち"},
      103837=>{:code=>"103837", :pref=>"群馬県", :name=>"南牧村", :type=>"村", :district=>"関東地方", :furigana=>"なんもくむら"},
      103845=>{:code=>"103845", :pref=>"群馬県", :name=>"甘楽町", :type=>"町", :district=>"関東地方", :furigana=>"かんらまち"},
      104213=>{:code=>"104213", :pref=>"群馬県", :name=>"中之条町", :type=>"町", :district=>"関東地方", :furigana=>"なかのじようまち"},
      104248=>{:code=>"104248", :pref=>"群馬県", :name=>"長野原町", :type=>"町", :district=>"関東地方", :furigana=>"ながのはらまち"},
      104256=>{:code=>"104256", :pref=>"群馬県", :name=>"嬬恋村", :type=>"村", :district=>"関東地方", :furigana=>"つまごいむら"},
      104264=>{:code=>"104264", :pref=>"群馬県", :name=>"草津町", :type=>"町", :district=>"関東地方", :furigana=>"くさつまち"},
      104281=>{:code=>"104281", :pref=>"群馬県", :name=>"高山村", :type=>"村", :district=>"関東地方", :furigana=>"たかやまむら"},
      104299=>{:code=>"104299", :pref=>"群馬県", :name=>"東吾妻町", :type=>"町", :district=>"関東地方", :furigana=>"ひがしあがつままち"},
      104434=>{:code=>"104434", :pref=>"群馬県", :name=>"片品村", :type=>"村", :district=>"関東地方", :furigana=>"かたしなむら"},
      104442=>{:code=>"104442", :pref=>"群馬県", :name=>"川場村", :type=>"村", :district=>"関東地方", :furigana=>"かわばむら"},
      104485=>{:code=>"104485", :pref=>"群馬県", :name=>"昭和村", :type=>"村", :district=>"関東地方", :furigana=>"しょうわむら"},
      104493=>{:code=>"104493", :pref=>"群馬県", :name=>"みなかみ町", :type=>"町", :district=>"関東地方", :furigana=>"みなかみまち"},
      104647=>{:code=>"104647", :pref=>"群馬県", :name=>"玉村町", :type=>"町", :district=>"関東地方", :furigana=>"たまむらまち"},
      105210=>{:code=>"105210", :pref=>"群馬県", :name=>"板倉町", :type=>"町", :district=>"関東地方", :furigana=>"いたくらまち"},
      105228=>{:code=>"105228", :pref=>"群馬県", :name=>"明和町", :type=>"町", :district=>"関東地方", :furigana=>"めいわまち"},
      105236=>{:code=>"105236", :pref=>"群馬県", :name=>"千代田町", :type=>"町", :district=>"関東地方", :furigana=>"ちよだまち"},
      105244=>{:code=>"105244", :pref=>"群馬県", :name=>"大泉町", :type=>"町", :district=>"関東地方", :furigana=>"おおいずみまち"},
      105252=>{:code=>"105252", :pref=>"群馬県", :name=>"邑楽町", :type=>"町", :district=>"関東地方", :furigana=>"おうらまち"},
      110001=>{:code=>"110001", :pref=>"埼玉県", :name=>"埼玉県", :type=>"都道府県", :district=>"関東地方", :furigana=>"さいたまけん"},
      111007=>{:code=>"111007", :pref=>"埼玉県", :name=>"さいたま市", :type=>"政令市", :district=>"関東地方", :furigana=>"さいたまし"},
      111015=>{:code=>"111015", :pref=>"埼玉県", :name=>"さいたま市西区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましにしく"},
      111023=>{:code=>"111023", :pref=>"埼玉県", :name=>"さいたま市北区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましきたく"},
      111031=>{:code=>"111031", :pref=>"埼玉県", :name=>"さいたま市大宮区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましおおみやく"},
      111040=>{:code=>"111040", :pref=>"埼玉県", :name=>"さいたま市見沼区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましみぬまく"},
      111058=>{:code=>"111058", :pref=>"埼玉県", :name=>"さいたま市中央区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましちゅうおうく"},
      111066=>{:code=>"111066", :pref=>"埼玉県", :name=>"さいたま市桜区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましさくらく"},
      111074=>{:code=>"111074", :pref=>"埼玉県", :name=>"さいたま市浦和区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましうらわく"},
      111082=>{:code=>"111082", :pref=>"埼玉県", :name=>"さいたま市南区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましみなみく"},
      111091=>{:code=>"111091", :pref=>"埼玉県", :name=>"さいたま市緑区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましみどりく"},
      111104=>{:code=>"111104", :pref=>"埼玉県", :name=>"さいたま市岩槻区", :type=>"行政区", :district=>"関東地方", :furigana=>"さいたましいわつきく"},
      112011=>{:code=>"112011", :pref=>"埼玉県", :name=>"川越市", :type=>"市", :district=>"関東地方", :furigana=>"かわごえし"},
      112020=>{:code=>"112020", :pref=>"埼玉県", :name=>"熊谷市", :type=>"市", :district=>"関東地方", :furigana=>"くまがやし"},
      112038=>{:code=>"112038", :pref=>"埼玉県", :name=>"川口市", :type=>"市", :district=>"関東地方", :furigana=>"かわぐちし"},
      112062=>{:code=>"112062", :pref=>"埼玉県", :name=>"行田市", :type=>"市", :district=>"関東地方", :furigana=>"ぎようだし"},
      112071=>{:code=>"112071", :pref=>"埼玉県", :name=>"秩父市", :type=>"市", :district=>"関東地方", :furigana=>"ちちぶし"},
      112089=>{:code=>"112089", :pref=>"埼玉県", :name=>"所沢市", :type=>"市", :district=>"関東地方", :furigana=>"ところざわし"},
      112097=>{:code=>"112097", :pref=>"埼玉県", :name=>"飯能市", :type=>"市", :district=>"関東地方", :furigana=>"はんのうし"},
      112101=>{:code=>"112101", :pref=>"埼玉県", :name=>"加須市", :type=>"市", :district=>"関東地方", :furigana=>"かぞし"},
      112119=>{:code=>"112119", :pref=>"埼玉県", :name=>"本庄市", :type=>"市", :district=>"関東地方", :furigana=>"ほんじようし"},
      112127=>{:code=>"112127", :pref=>"埼玉県", :name=>"東松山市", :type=>"市", :district=>"関東地方", :furigana=>"ひがしまつやまし"},
      112143=>{:code=>"112143", :pref=>"埼玉県", :name=>"春日部市", :type=>"市", :district=>"関東地方", :furigana=>"かすかべし"},
      112151=>{:code=>"112151", :pref=>"埼玉県", :name=>"狭山市", :type=>"市", :district=>"関東地方", :furigana=>"さやまし"},
      112160=>{:code=>"112160", :pref=>"埼玉県", :name=>"羽生市", :type=>"市", :district=>"関東地方", :furigana=>"はにゆうし"},
      112178=>{:code=>"112178", :pref=>"埼玉県", :name=>"鴻巣市", :type=>"市", :district=>"関東地方", :furigana=>"こうのすし"},
      112186=>{:code=>"112186", :pref=>"埼玉県", :name=>"深谷市", :type=>"市", :district=>"関東地方", :furigana=>"ふかやし"},
      112194=>{:code=>"112194", :pref=>"埼玉県", :name=>"上尾市", :type=>"市", :district=>"関東地方", :furigana=>"あげおし"},
      112216=>{:code=>"112216", :pref=>"埼玉県", :name=>"草加市", :type=>"市", :district=>"関東地方", :furigana=>"そうかし"},
      112224=>{:code=>"112224", :pref=>"埼玉県", :name=>"越谷市", :type=>"市", :district=>"関東地方", :furigana=>"こしがやし"},
      112232=>{:code=>"112232", :pref=>"埼玉県", :name=>"蕨市", :type=>"市", :district=>"関東地方", :furigana=>"わらびし"},
      112241=>{:code=>"112241", :pref=>"埼玉県", :name=>"戸田市", :type=>"市", :district=>"関東地方", :furigana=>"とだし"},
      112259=>{:code=>"112259", :pref=>"埼玉県", :name=>"入間市", :type=>"市", :district=>"関東地方", :furigana=>"いるまし"},
      112275=>{:code=>"112275", :pref=>"埼玉県", :name=>"朝霞市", :type=>"市", :district=>"関東地方", :furigana=>"あさかし"},
      112283=>{:code=>"112283", :pref=>"埼玉県", :name=>"志木市", :type=>"市", :district=>"関東地方", :furigana=>"しきし"},
      112291=>{:code=>"112291", :pref=>"埼玉県", :name=>"和光市", :type=>"市", :district=>"関東地方", :furigana=>"わこうし"},
      112305=>{:code=>"112305", :pref=>"埼玉県", :name=>"新座市", :type=>"市", :district=>"関東地方", :furigana=>"にいざし"},
      112313=>{:code=>"112313", :pref=>"埼玉県", :name=>"桶川市", :type=>"市", :district=>"関東地方", :furigana=>"おけがわし"},
      112321=>{:code=>"112321", :pref=>"埼玉県", :name=>"久喜市", :type=>"市", :district=>"関東地方", :furigana=>"くきし"},
      112330=>{:code=>"112330", :pref=>"埼玉県", :name=>"北本市", :type=>"市", :district=>"関東地方", :furigana=>"きたもとし"},
      112348=>{:code=>"112348", :pref=>"埼玉県", :name=>"八潮市", :type=>"市", :district=>"関東地方", :furigana=>"やしおし"},
      112356=>{:code=>"112356", :pref=>"埼玉県", :name=>"富士見市", :type=>"市", :district=>"関東地方", :furigana=>"ふじみし"},
      112372=>{:code=>"112372", :pref=>"埼玉県", :name=>"三郷市", :type=>"市", :district=>"関東地方", :furigana=>"みさとし"},
      112381=>{:code=>"112381", :pref=>"埼玉県", :name=>"蓮田市", :type=>"市", :district=>"関東地方", :furigana=>"はすだし"},
      112399=>{:code=>"112399", :pref=>"埼玉県", :name=>"坂戸市", :type=>"市", :district=>"関東地方", :furigana=>"さかどし"},
      112402=>{:code=>"112402", :pref=>"埼玉県", :name=>"幸手市", :type=>"市", :district=>"関東地方", :furigana=>"さってし"},
      112411=>{:code=>"112411", :pref=>"埼玉県", :name=>"鶴ヶ島市", :type=>"市", :district=>"関東地方", :furigana=>"つるがしまし"},
      112429=>{:code=>"112429", :pref=>"埼玉県", :name=>"日高市", :type=>"市", :district=>"関東地方", :furigana=>"ひだかし"},
      112437=>{:code=>"112437", :pref=>"埼玉県", :name=>"吉川市", :type=>"市", :district=>"関東地方", :furigana=>"よしかわし"},
      112453=>{:code=>"112453", :pref=>"埼玉県", :name=>"ふじみ野市", :type=>"市", :district=>"関東地方", :furigana=>"ふじみのし"},
      112461=>{:code=>"112461", :pref=>"埼玉県", :name=>"白岡市", :type=>"市", :district=>"関東地方", :furigana=>"しらおかし"},
      113018=>{:code=>"113018", :pref=>"埼玉県", :name=>"伊奈町", :type=>"町", :district=>"関東地方", :furigana=>"いなまち"},
      113247=>{:code=>"113247", :pref=>"埼玉県", :name=>"三芳町", :type=>"町", :district=>"関東地方", :furigana=>"みよしまち"},
      113263=>{:code=>"113263", :pref=>"埼玉県", :name=>"毛呂山町", :type=>"町", :district=>"関東地方", :furigana=>"もろやままち"},
      113271=>{:code=>"113271", :pref=>"埼玉県", :name=>"越生町", :type=>"町", :district=>"関東地方", :furigana=>"おごせまち"},
      113417=>{:code=>"113417", :pref=>"埼玉県", :name=>"滑川町", :type=>"町", :district=>"関東地方", :furigana=>"なめがわまち"},
      113425=>{:code=>"113425", :pref=>"埼玉県", :name=>"嵐山町", :type=>"町", :district=>"関東地方", :furigana=>"らんざんまち"},
      113433=>{:code=>"113433", :pref=>"埼玉県", :name=>"小川町", :type=>"町", :district=>"関東地方", :furigana=>"おがわまち"},
      113468=>{:code=>"113468", :pref=>"埼玉県", :name=>"川島町", :type=>"町", :district=>"関東地方", :furigana=>"かわじままち"},
      113476=>{:code=>"113476", :pref=>"埼玉県", :name=>"吉見町", :type=>"町", :district=>"関東地方", :furigana=>"よしみまち"},
      113484=>{:code=>"113484", :pref=>"埼玉県", :name=>"鳩山町", :type=>"町", :district=>"関東地方", :furigana=>"はとやままち"},
      113492=>{:code=>"113492", :pref=>"埼玉県", :name=>"ときがわ町", :type=>"町", :district=>"関東地方", :furigana=>"ときがわまち"},
      113611=>{:code=>"113611", :pref=>"埼玉県", :name=>"横瀬町", :type=>"町", :district=>"関東地方", :furigana=>"よこぜまち"},
      113620=>{:code=>"113620", :pref=>"埼玉県", :name=>"皆野町", :type=>"町", :district=>"関東地方", :furigana=>"みなのまち"},
      113638=>{:code=>"113638", :pref=>"埼玉県", :name=>"長瀞町", :type=>"町", :district=>"関東地方", :furigana=>"ながとろまち"},
      113654=>{:code=>"113654", :pref=>"埼玉県", :name=>"小鹿野町", :type=>"町", :district=>"関東地方", :furigana=>"おがのまち"},
      113697=>{:code=>"113697", :pref=>"埼玉県", :name=>"東秩父村", :type=>"村", :district=>"関東地方", :furigana=>"ひがしちちぶむら"},
      113816=>{:code=>"113816", :pref=>"埼玉県", :name=>"美里町", :type=>"町", :district=>"関東地方", :furigana=>"みさとまち"},
      113832=>{:code=>"113832", :pref=>"埼玉県", :name=>"神川町", :type=>"町", :district=>"関東地方", :furigana=>"かみかわまち"},
      113859=>{:code=>"113859", :pref=>"埼玉県", :name=>"上里町", :type=>"町", :district=>"関東地方", :furigana=>"かみさとまち"},
      114081=>{:code=>"114081", :pref=>"埼玉県", :name=>"寄居町", :type=>"町", :district=>"関東地方", :furigana=>"よりいまち"},
      114421=>{:code=>"114421", :pref=>"埼玉県", :name=>"宮代町", :type=>"町", :district=>"関東地方", :furigana=>"みやしろまち"},
      114642=>{:code=>"114642", :pref=>"埼玉県", :name=>"杉戸町", :type=>"町", :district=>"関東地方", :furigana=>"すぎとまち"},
      114651=>{:code=>"114651", :pref=>"埼玉県", :name=>"松伏町", :type=>"町", :district=>"関東地方", :furigana=>"まつぶしまち"},
      120006=>{:code=>"120006", :pref=>"千葉県", :name=>"千葉県", :type=>"都道府県", :district=>"関東地方", :furigana=>"ちばけん"},
      121002=>{:code=>"121002", :pref=>"千葉県", :name=>"千葉市", :type=>"政令市", :district=>"関東地方", :furigana=>"ちばし"},
      121011=>{:code=>"121011", :pref=>"千葉県", :name=>"千葉市中央区", :type=>"行政区", :district=>"関東地方", :furigana=>"ちばしちゅうおうく"},
      121029=>{:code=>"121029", :pref=>"千葉県", :name=>"千葉市花見川区", :type=>"行政区", :district=>"関東地方", :furigana=>"ちばしはなみがわく"},
      121037=>{:code=>"121037", :pref=>"千葉県", :name=>"千葉市稲毛区", :type=>"行政区", :district=>"関東地方", :furigana=>"ちばしいなげく"},
      121045=>{:code=>"121045", :pref=>"千葉県", :name=>"千葉市若葉区", :type=>"行政区", :district=>"関東地方", :furigana=>"ちばしわかばく"},
      121053=>{:code=>"121053", :pref=>"千葉県", :name=>"千葉市緑区", :type=>"行政区", :district=>"関東地方", :furigana=>"ちばしみどりく"},
      121061=>{:code=>"121061", :pref=>"千葉県", :name=>"千葉市美浜区", :type=>"行政区", :district=>"関東地方", :furigana=>"ちばしみはまく"},
      122025=>{:code=>"122025", :pref=>"千葉県", :name=>"銚子市", :type=>"市", :district=>"関東地方", :furigana=>"ちょうしし"},
      122033=>{:code=>"122033", :pref=>"千葉県", :name=>"市川市", :type=>"市", :district=>"関東地方", :furigana=>"いちかわし"},
      122041=>{:code=>"122041", :pref=>"千葉県", :name=>"船橋市", :type=>"市", :district=>"関東地方", :furigana=>"ふなばしし"},
      122050=>{:code=>"122050", :pref=>"千葉県", :name=>"館山市", :type=>"市", :district=>"関東地方", :furigana=>"たてやまし"},
      122068=>{:code=>"122068", :pref=>"千葉県", :name=>"木更津市", :type=>"市", :district=>"関東地方", :furigana=>"きさらづし"},
      122076=>{:code=>"122076", :pref=>"千葉県", :name=>"松戸市", :type=>"市", :district=>"関東地方", :furigana=>"まつどし"},
      122084=>{:code=>"122084", :pref=>"千葉県", :name=>"野田市", :type=>"市", :district=>"関東地方", :furigana=>"のだし"},
      122106=>{:code=>"122106", :pref=>"千葉県", :name=>"茂原市", :type=>"市", :district=>"関東地方", :furigana=>"もばらし"},
      122114=>{:code=>"122114", :pref=>"千葉県", :name=>"成田市", :type=>"市", :district=>"関東地方", :furigana=>"なりたし"},
      122122=>{:code=>"122122", :pref=>"千葉県", :name=>"佐倉市", :type=>"市", :district=>"関東地方", :furigana=>"さくらし"},
      122131=>{:code=>"122131", :pref=>"千葉県", :name=>"東金市", :type=>"市", :district=>"関東地方", :furigana=>"とうがねし"},
      122157=>{:code=>"122157", :pref=>"千葉県", :name=>"旭市", :type=>"市", :district=>"関東地方", :furigana=>"あさひし"},
      122165=>{:code=>"122165", :pref=>"千葉県", :name=>"習志野市", :type=>"市", :district=>"関東地方", :furigana=>"ならしのし"},
      122173=>{:code=>"122173", :pref=>"千葉県", :name=>"柏市", :type=>"市", :district=>"関東地方", :furigana=>"かしわし"},
      122181=>{:code=>"122181", :pref=>"千葉県", :name=>"勝浦市", :type=>"市", :district=>"関東地方", :furigana=>"かつうらし"},
      122190=>{:code=>"122190", :pref=>"千葉県", :name=>"市原市", :type=>"市", :district=>"関東地方", :furigana=>"いちはらし"},
      122203=>{:code=>"122203", :pref=>"千葉県", :name=>"流山市", :type=>"市", :district=>"関東地方", :furigana=>"ながれやまし"},
      122211=>{:code=>"122211", :pref=>"千葉県", :name=>"八千代市", :type=>"市", :district=>"関東地方", :furigana=>"やちよし"},
      122220=>{:code=>"122220", :pref=>"千葉県", :name=>"我孫子市", :type=>"市", :district=>"関東地方", :furigana=>"あびこし"},
      122238=>{:code=>"122238", :pref=>"千葉県", :name=>"鴨川市", :type=>"市", :district=>"関東地方", :furigana=>"かもがわし"},
      122246=>{:code=>"122246", :pref=>"千葉県", :name=>"鎌ケ谷市", :type=>"市", :district=>"関東地方", :furigana=>"かまがやし"},
      122254=>{:code=>"122254", :pref=>"千葉県", :name=>"君津市", :type=>"市", :district=>"関東地方", :furigana=>"きみつし"},
      122262=>{:code=>"122262", :pref=>"千葉県", :name=>"富津市", :type=>"市", :district=>"関東地方", :furigana=>"ふっつし"},
      122271=>{:code=>"122271", :pref=>"千葉県", :name=>"浦安市", :type=>"市", :district=>"関東地方", :furigana=>"うらやすし"},
      122289=>{:code=>"122289", :pref=>"千葉県", :name=>"四街道市", :type=>"市", :district=>"関東地方", :furigana=>"よつかいどうし"},
      122297=>{:code=>"122297", :pref=>"千葉県", :name=>"袖ケ浦市", :type=>"市", :district=>"関東地方", :furigana=>"そでがうらし"},
      122301=>{:code=>"122301", :pref=>"千葉県", :name=>"八街市", :type=>"市", :district=>"関東地方", :furigana=>"やちまたし"},
      122319=>{:code=>"122319", :pref=>"千葉県", :name=>"印西市", :type=>"市", :district=>"関東地方", :furigana=>"いんざいし"},
      122327=>{:code=>"122327", :pref=>"千葉県", :name=>"白井市", :type=>"市", :district=>"関東地方", :furigana=>"しろいし"},
      122335=>{:code=>"122335", :pref=>"千葉県", :name=>"富里市", :type=>"市", :district=>"関東地方", :furigana=>"とみさとし"},
      122343=>{:code=>"122343", :pref=>"千葉県", :name=>"南房総市", :type=>"市", :district=>"関東地方", :furigana=>"みなみぼうそうし"},
      122351=>{:code=>"122351", :pref=>"千葉県", :name=>"匝瑳市", :type=>"市", :district=>"関東地方", :furigana=>"そうさし"},
      122360=>{:code=>"122360", :pref=>"千葉県", :name=>"香取市", :type=>"市", :district=>"関東地方", :furigana=>"かとりし"},
      122378=>{:code=>"122378", :pref=>"千葉県", :name=>"山武市", :type=>"市", :district=>"関東地方", :furigana=>"さんむし"},
      122386=>{:code=>"122386", :pref=>"千葉県", :name=>"いすみ市", :type=>"市", :district=>"関東地方", :furigana=>"いすみし"},
      122394=>{:code=>"122394", :pref=>"千葉県", :name=>"大網白里市", :type=>"市", :district=>"関東地方", :furigana=>"おおあみしらさとし"},
      123226=>{:code=>"123226", :pref=>"千葉県", :name=>"酒々井町", :type=>"町", :district=>"関東地方", :furigana=>"しすいまち"},
      123293=>{:code=>"123293", :pref=>"千葉県", :name=>"栄町", :type=>"町", :district=>"関東地方", :furigana=>"さかえまち"},
      123421=>{:code=>"123421", :pref=>"千葉県", :name=>"神崎町", :type=>"町", :district=>"関東地方", :furigana=>"こうざきまち"},
      123471=>{:code=>"123471", :pref=>"千葉県", :name=>"多古町", :type=>"町", :district=>"関東地方", :furigana=>"たこまち"},
      123498=>{:code=>"123498", :pref=>"千葉県", :name=>"東庄町", :type=>"町", :district=>"関東地方", :furigana=>"とうのしょうまち"},
      124036=>{:code=>"124036", :pref=>"千葉県", :name=>"九十九里町", :type=>"町", :district=>"関東地方", :furigana=>"くじゆうくりまち"},
      124095=>{:code=>"124095", :pref=>"千葉県", :name=>"芝山町", :type=>"町", :district=>"関東地方", :furigana=>"しばやままち"},
      124109=>{:code=>"124109", :pref=>"千葉県", :name=>"横芝光町", :type=>"町", :district=>"関東地方", :furigana=>"よこしばひかりまち"},
      124214=>{:code=>"124214", :pref=>"千葉県", :name=>"一宮町", :type=>"町", :district=>"関東地方", :furigana=>"いちのみやまち"},
      124222=>{:code=>"124222", :pref=>"千葉県", :name=>"睦沢町", :type=>"町", :district=>"関東地方", :furigana=>"むつざわまち"},
      124231=>{:code=>"124231", :pref=>"千葉県", :name=>"長生村", :type=>"村", :district=>"関東地方", :furigana=>"ちょうせいむら"},
      124249=>{:code=>"124249", :pref=>"千葉県", :name=>"白子町", :type=>"町", :district=>"関東地方", :furigana=>"しらこまち"},
      124265=>{:code=>"124265", :pref=>"千葉県", :name=>"長柄町", :type=>"町", :district=>"関東地方", :furigana=>"ながらまち"},
      124273=>{:code=>"124273", :pref=>"千葉県", :name=>"長南町", :type=>"町", :district=>"関東地方", :furigana=>"ちょうなんまち"},
      124419=>{:code=>"124419", :pref=>"千葉県", :name=>"大多喜町", :type=>"町", :district=>"関東地方", :furigana=>"おおたきまち"},
      124435=>{:code=>"124435", :pref=>"千葉県", :name=>"御宿町", :type=>"町", :district=>"関東地方", :furigana=>"おんじゆくまち"},
      124630=>{:code=>"124630", :pref=>"千葉県", :name=>"鋸南町", :type=>"町", :district=>"関東地方", :furigana=>"きよなんまち"},
      130001=>{:code=>"130001", :pref=>"東京都", :name=>"東京都", :type=>"都道府県", :district=>"関東地方", :furigana=>"とうきょうと"},
      131016=>{:code=>"131016", :pref=>"東京都", :name=>"千代田区", :type=>"特別区", :district=>"関東地方", :furigana=>"ちよだく"},
      131024=>{:code=>"131024", :pref=>"東京都", :name=>"中央区", :type=>"特別区", :district=>"関東地方", :furigana=>"ちゅうおうく"},
      131032=>{:code=>"131032", :pref=>"東京都", :name=>"港区", :type=>"特別区", :district=>"関東地方", :furigana=>"みなとく"},
      131041=>{:code=>"131041", :pref=>"東京都", :name=>"新宿区", :type=>"特別区", :district=>"関東地方", :furigana=>"しんじゅくく"},
      131059=>{:code=>"131059", :pref=>"東京都", :name=>"文京区", :type=>"特別区", :district=>"関東地方", :furigana=>"ぶんきょうく"},
      131067=>{:code=>"131067", :pref=>"東京都", :name=>"台東区", :type=>"特別区", :district=>"関東地方", :furigana=>"たいとうく"},
      131075=>{:code=>"131075", :pref=>"東京都", :name=>"墨田区", :type=>"特別区", :district=>"関東地方", :furigana=>"すみだく"},
      131083=>{:code=>"131083", :pref=>"東京都", :name=>"江東区", :type=>"特別区", :district=>"関東地方", :furigana=>"こうとうく"},
      131091=>{:code=>"131091", :pref=>"東京都", :name=>"品川区", :type=>"特別区", :district=>"関東地方", :furigana=>"しながわく"},
      131105=>{:code=>"131105", :pref=>"東京都", :name=>"目黒区", :type=>"特別区", :district=>"関東地方", :furigana=>"めぐろく"},
      131113=>{:code=>"131113", :pref=>"東京都", :name=>"大田区", :type=>"特別区", :district=>"関東地方", :furigana=>"おおたく"},
      131121=>{:code=>"131121", :pref=>"東京都", :name=>"世田谷区", :type=>"特別区", :district=>"関東地方", :furigana=>"せたがやく"},
      131130=>{:code=>"131130", :pref=>"東京都", :name=>"渋谷区", :type=>"特別区", :district=>"関東地方", :furigana=>"しぶやく"},
      131148=>{:code=>"131148", :pref=>"東京都", :name=>"中野区", :type=>"特別区", :district=>"関東地方", :furigana=>"なかのく"},
      131156=>{:code=>"131156", :pref=>"東京都", :name=>"杉並区", :type=>"特別区", :district=>"関東地方", :furigana=>"すぎなみく"},
      131164=>{:code=>"131164", :pref=>"東京都", :name=>"豊島区", :type=>"特別区", :district=>"関東地方", :furigana=>"としまく"},
      131172=>{:code=>"131172", :pref=>"東京都", :name=>"北区", :type=>"特別区", :district=>"関東地方", :furigana=>"きたく"},
      131181=>{:code=>"131181", :pref=>"東京都", :name=>"荒川区", :type=>"特別区", :district=>"関東地方", :furigana=>"あらかわく"},
      131199=>{:code=>"131199", :pref=>"東京都", :name=>"板橋区", :type=>"特別区", :district=>"関東地方", :furigana=>"いたばしく"},
      131202=>{:code=>"131202", :pref=>"東京都", :name=>"練馬区", :type=>"特別区", :district=>"関東地方", :furigana=>"ねりまく"},
      131211=>{:code=>"131211", :pref=>"東京都", :name=>"足立区", :type=>"特別区", :district=>"関東地方", :furigana=>"あだちく"},
      131229=>{:code=>"131229", :pref=>"東京都", :name=>"葛飾区", :type=>"特別区", :district=>"関東地方", :furigana=>"かつしかく"},
      131237=>{:code=>"131237", :pref=>"東京都", :name=>"江戸川区", :type=>"特別区", :district=>"関東地方", :furigana=>"えどがわく"},
      132012=>{:code=>"132012", :pref=>"東京都", :name=>"八王子市", :type=>"市", :district=>"関東地方", :furigana=>"はちおうじし"},
      132021=>{:code=>"132021", :pref=>"東京都", :name=>"立川市", :type=>"市", :district=>"関東地方", :furigana=>"たちかわし"},
      132039=>{:code=>"132039", :pref=>"東京都", :name=>"武蔵野市", :type=>"市", :district=>"関東地方", :furigana=>"むさしのし"},
      132047=>{:code=>"132047", :pref=>"東京都", :name=>"三鷹市", :type=>"市", :district=>"関東地方", :furigana=>"みたかし"},
      132055=>{:code=>"132055", :pref=>"東京都", :name=>"青梅市", :type=>"市", :district=>"関東地方", :furigana=>"おうめし"},
      132063=>{:code=>"132063", :pref=>"東京都", :name=>"府中市", :type=>"市", :district=>"関東地方", :furigana=>"ふちゅうし"},
      132071=>{:code=>"132071", :pref=>"東京都", :name=>"昭島市", :type=>"市", :district=>"関東地方", :furigana=>"あきしまし"},
      132080=>{:code=>"132080", :pref=>"東京都", :name=>"調布市", :type=>"市", :district=>"関東地方", :furigana=>"ちょうふし"},
      132098=>{:code=>"132098", :pref=>"東京都", :name=>"町田市", :type=>"市", :district=>"関東地方", :furigana=>"まちだし"},
      132101=>{:code=>"132101", :pref=>"東京都", :name=>"小金井市", :type=>"市", :district=>"関東地方", :furigana=>"こがねいし"},
      132110=>{:code=>"132110", :pref=>"東京都", :name=>"小平市", :type=>"市", :district=>"関東地方", :furigana=>"こだいらし"},
      132128=>{:code=>"132128", :pref=>"東京都", :name=>"日野市", :type=>"市", :district=>"関東地方", :furigana=>"ひのし"},
      132136=>{:code=>"132136", :pref=>"東京都", :name=>"東村山市", :type=>"市", :district=>"関東地方", :furigana=>"ひがしむらやまし"},
      132144=>{:code=>"132144", :pref=>"東京都", :name=>"国分寺市", :type=>"市", :district=>"関東地方", :furigana=>"こくぶんじし"},
      132152=>{:code=>"132152", :pref=>"東京都", :name=>"国立市", :type=>"市", :district=>"関東地方", :furigana=>"くにたちし"},
      132187=>{:code=>"132187", :pref=>"東京都", :name=>"福生市", :type=>"市", :district=>"関東地方", :furigana=>"ふっさし"},
      132195=>{:code=>"132195", :pref=>"東京都", :name=>"狛江市", :type=>"市", :district=>"関東地方", :furigana=>"こまえし"},
      132209=>{:code=>"132209", :pref=>"東京都", :name=>"東大和市", :type=>"市", :district=>"関東地方", :furigana=>"ひがしやまとし"},
      132217=>{:code=>"132217", :pref=>"東京都", :name=>"清瀬市", :type=>"市", :district=>"関東地方", :furigana=>"きよせし"},
      132225=>{:code=>"132225", :pref=>"東京都", :name=>"東久留米市", :type=>"市", :district=>"関東地方", :furigana=>"ひがしくるめし"},
      132233=>{:code=>"132233", :pref=>"東京都", :name=>"武蔵村山市", :type=>"市", :district=>"関東地方", :furigana=>"むさしむらやまし"},
      132241=>{:code=>"132241", :pref=>"東京都", :name=>"多摩市", :type=>"市", :district=>"関東地方", :furigana=>"たまし"},
      132250=>{:code=>"132250", :pref=>"東京都", :name=>"稲城市", :type=>"市", :district=>"関東地方", :furigana=>"いなぎし"},
      132276=>{:code=>"132276", :pref=>"東京都", :name=>"羽村市", :type=>"市", :district=>"関東地方", :furigana=>"はむらし"},
      132284=>{:code=>"132284", :pref=>"東京都", :name=>"あきる野市", :type=>"市", :district=>"関東地方", :furigana=>"あきるのし"},
      132292=>{:code=>"132292", :pref=>"東京都", :name=>"西東京市", :type=>"市", :district=>"関東地方", :furigana=>"にしとうきょうし"},
      133035=>{:code=>"133035", :pref=>"東京都", :name=>"瑞穂町", :type=>"町", :district=>"関東地方", :furigana=>"みずほまち"},
      133051=>{:code=>"133051", :pref=>"東京都", :name=>"日の出町", :type=>"町", :district=>"関東地方", :furigana=>"ひのでまち"},
      133078=>{:code=>"133078", :pref=>"東京都", :name=>"檜原村", :type=>"村", :district=>"関東地方", :furigana=>"ひのはらむら"},
      133086=>{:code=>"133086", :pref=>"東京都", :name=>"奥多摩町", :type=>"町", :district=>"関東地方", :furigana=>"おくたままち"},
      133612=>{:code=>"133612", :pref=>"東京都", :name=>"大島町", :type=>"町", :district=>"関東地方", :furigana=>"おおしままち"},
      133621=>{:code=>"133621", :pref=>"東京都", :name=>"利島村", :type=>"村", :district=>"関東地方", :furigana=>"としまむら"},
      133639=>{:code=>"133639", :pref=>"東京都", :name=>"新島村", :type=>"村", :district=>"関東地方", :furigana=>"にいじまむら"},
      133647=>{:code=>"133647", :pref=>"東京都", :name=>"神津島村", :type=>"村", :district=>"関東地方", :furigana=>"こうづしまむら"},
      133817=>{:code=>"133817", :pref=>"東京都", :name=>"三宅村", :type=>"村", :district=>"関東地方", :furigana=>"みやけむら"},
      133825=>{:code=>"133825", :pref=>"東京都", :name=>"御蔵島村", :type=>"村", :district=>"関東地方", :furigana=>"みくらじまむら"},
      134015=>{:code=>"134015", :pref=>"東京都", :name=>"八丈町", :type=>"町", :district=>"関東地方", :furigana=>"はちじょうまち"},
      134023=>{:code=>"134023", :pref=>"東京都", :name=>"青ヶ島村", :type=>"村", :district=>"関東地方", :furigana=>"あおがしまむら"},
      134210=>{:code=>"134210", :pref=>"東京都", :name=>"小笠原村", :type=>"村", :district=>"関東地方", :furigana=>"おがさわらむら"},
      140007=>{:code=>"140007", :pref=>"神奈川県", :name=>"神奈川県", :type=>"都道府県", :district=>"関東地方", :furigana=>"かながわけん"},
      141003=>{:code=>"141003", :pref=>"神奈川県", :name=>"横浜市", :type=>"政令市", :district=>"関東地方", :furigana=>"よこはまし"},
      141011=>{:code=>"141011", :pref=>"神奈川県", :name=>"横浜市鶴見区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましつるみく"},
      141020=>{:code=>"141020", :pref=>"神奈川県", :name=>"横浜市神奈川区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましかながわく"},
      141038=>{:code=>"141038", :pref=>"神奈川県", :name=>"横浜市西区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましにしく"},
      141046=>{:code=>"141046", :pref=>"神奈川県", :name=>"横浜市中区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましなかく"},
      141054=>{:code=>"141054", :pref=>"神奈川県", :name=>"横浜市南区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましみなみく"},
      141062=>{:code=>"141062", :pref=>"神奈川県", :name=>"横浜市保土ケ谷区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましほどがやく"},
      141071=>{:code=>"141071", :pref=>"神奈川県", :name=>"横浜市磯子区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましいそごく"},
      141089=>{:code=>"141089", :pref=>"神奈川県", :name=>"横浜市金沢区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましかなざわく"},
      141097=>{:code=>"141097", :pref=>"神奈川県", :name=>"横浜市港北区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましこうほくく"},
      141101=>{:code=>"141101", :pref=>"神奈川県", :name=>"横浜市戸塚区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましとつかく"},
      141119=>{:code=>"141119", :pref=>"神奈川県", :name=>"横浜市港南区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましこうなんく"},
      141127=>{:code=>"141127", :pref=>"神奈川県", :name=>"横浜市旭区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましあさひく"},
      141135=>{:code=>"141135", :pref=>"神奈川県", :name=>"横浜市緑区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましみどりく"},
      141143=>{:code=>"141143", :pref=>"神奈川県", :name=>"横浜市瀬谷区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましせやく"},
      141151=>{:code=>"141151", :pref=>"神奈川県", :name=>"横浜市栄区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましさかえく"},
      141160=>{:code=>"141160", :pref=>"神奈川県", :name=>"横浜市泉区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましいずみく"},
      141178=>{:code=>"141178", :pref=>"神奈川県", :name=>"横浜市青葉区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましあおばく"},
      141186=>{:code=>"141186", :pref=>"神奈川県", :name=>"横浜市都筑区", :type=>"行政区", :district=>"関東地方", :furigana=>"よこはましつづきく"},
      141305=>{:code=>"141305", :pref=>"神奈川県", :name=>"川崎市", :type=>"政令市", :district=>"関東地方", :furigana=>"かわさきし"},
      141313=>{:code=>"141313", :pref=>"神奈川県", :name=>"川崎市川崎区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしかわさきく"},
      141321=>{:code=>"141321", :pref=>"神奈川県", :name=>"川崎市幸区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしさいわいく"},
      141330=>{:code=>"141330", :pref=>"神奈川県", :name=>"川崎市中原区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしなかはらく"},
      141348=>{:code=>"141348", :pref=>"神奈川県", :name=>"川崎市高津区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしたかつく"},
      141356=>{:code=>"141356", :pref=>"神奈川県", :name=>"川崎市多摩区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしたまく"},
      141364=>{:code=>"141364", :pref=>"神奈川県", :name=>"川崎市宮前区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしみやまえく"},
      141372=>{:code=>"141372", :pref=>"神奈川県", :name=>"川崎市麻生区", :type=>"行政区", :district=>"関東地方", :furigana=>"かわさきしあさおく"},
      141500=>{:code=>"141500", :pref=>"神奈川県", :name=>"相模原市", :type=>"政令市", :district=>"関東地方", :furigana=>"さがみはらし"},
      141518=>{:code=>"141518", :pref=>"神奈川県", :name=>"相模原市緑区", :type=>"行政区", :district=>"関東地方", :furigana=>"さがみはらしみどりく"},
      141526=>{:code=>"141526", :pref=>"神奈川県", :name=>"相模原市中央区", :type=>"行政区", :district=>"関東地方", :furigana=>"さがみはらしちゅうおうく"},
      141534=>{:code=>"141534", :pref=>"神奈川県", :name=>"相模原市南区", :type=>"行政区", :district=>"関東地方", :furigana=>"さがみはらしみなみく"},
      142018=>{:code=>"142018", :pref=>"神奈川県", :name=>"横須賀市", :type=>"市", :district=>"関東地方", :furigana=>"よこすかし"},
      142034=>{:code=>"142034", :pref=>"神奈川県", :name=>"平塚市", :type=>"市", :district=>"関東地方", :furigana=>"ひらつかし"},
      142042=>{:code=>"142042", :pref=>"神奈川県", :name=>"鎌倉市", :type=>"市", :district=>"関東地方", :furigana=>"かまくらし"},
      142051=>{:code=>"142051", :pref=>"神奈川県", :name=>"藤沢市", :type=>"市", :district=>"関東地方", :furigana=>"ふじさわし"},
      142069=>{:code=>"142069", :pref=>"神奈川県", :name=>"小田原市", :type=>"市", :district=>"関東地方", :furigana=>"おだわらし"},
      142077=>{:code=>"142077", :pref=>"神奈川県", :name=>"茅ヶ崎市", :type=>"市", :district=>"関東地方", :furigana=>"ちがさきし"},
      142085=>{:code=>"142085", :pref=>"神奈川県", :name=>"逗子市", :type=>"市", :district=>"関東地方", :furigana=>"ずしし"},
      142107=>{:code=>"142107", :pref=>"神奈川県", :name=>"三浦市", :type=>"市", :district=>"関東地方", :furigana=>"みうらし"},
      142115=>{:code=>"142115", :pref=>"神奈川県", :name=>"秦野市", :type=>"市", :district=>"関東地方", :furigana=>"はだのし"},
      142123=>{:code=>"142123", :pref=>"神奈川県", :name=>"厚木市", :type=>"市", :district=>"関東地方", :furigana=>"あつぎし"},
      142131=>{:code=>"142131", :pref=>"神奈川県", :name=>"大和市", :type=>"市", :district=>"関東地方", :furigana=>"やまとし"},
      142140=>{:code=>"142140", :pref=>"神奈川県", :name=>"伊勢原市", :type=>"市", :district=>"関東地方", :furigana=>"いせはらし"},
      142158=>{:code=>"142158", :pref=>"神奈川県", :name=>"海老名市", :type=>"市", :district=>"関東地方", :furigana=>"えびなし"},
      142166=>{:code=>"142166", :pref=>"神奈川県", :name=>"座間市", :type=>"市", :district=>"関東地方", :furigana=>"ざまし"},
      142174=>{:code=>"142174", :pref=>"神奈川県", :name=>"南足柄市", :type=>"市", :district=>"関東地方", :furigana=>"みなみあしがらし"},
      142182=>{:code=>"142182", :pref=>"神奈川県", :name=>"綾瀬市", :type=>"市", :district=>"関東地方", :furigana=>"あやせし"},
      143014=>{:code=>"143014", :pref=>"神奈川県", :name=>"葉山町", :type=>"町", :district=>"関東地方", :furigana=>"はやままち"},
      143219=>{:code=>"143219", :pref=>"神奈川県", :name=>"寒川町", :type=>"町", :district=>"関東地方", :furigana=>"さむかわまち"},
      143413=>{:code=>"143413", :pref=>"神奈川県", :name=>"大磯町", :type=>"町", :district=>"関東地方", :furigana=>"おおいそまち"},
      143421=>{:code=>"143421", :pref=>"神奈川県", :name=>"二宮町", :type=>"町", :district=>"関東地方", :furigana=>"にのみやまち"},
      143618=>{:code=>"143618", :pref=>"神奈川県", :name=>"中井町", :type=>"町", :district=>"関東地方", :furigana=>"なかいまち"},
      143626=>{:code=>"143626", :pref=>"神奈川県", :name=>"大井町", :type=>"町", :district=>"関東地方", :furigana=>"おおいまち"},
      143634=>{:code=>"143634", :pref=>"神奈川県", :name=>"松田町", :type=>"町", :district=>"関東地方", :furigana=>"まつだまち"},
      143642=>{:code=>"143642", :pref=>"神奈川県", :name=>"山北町", :type=>"町", :district=>"関東地方", :furigana=>"やまきたまち"},
      143669=>{:code=>"143669", :pref=>"神奈川県", :name=>"開成町", :type=>"町", :district=>"関東地方", :furigana=>"かいせいまち"},
      143821=>{:code=>"143821", :pref=>"神奈川県", :name=>"箱根町", :type=>"町", :district=>"関東地方", :furigana=>"はこねまち"},
      143839=>{:code=>"143839", :pref=>"神奈川県", :name=>"真鶴町", :type=>"町", :district=>"関東地方", :furigana=>"まなつるまち"},
      143847=>{:code=>"143847", :pref=>"神奈川県", :name=>"湯河原町", :type=>"町", :district=>"関東地方", :furigana=>"ゆがわらまち"},
      144011=>{:code=>"144011", :pref=>"神奈川県", :name=>"愛川町", :type=>"町", :district=>"関東地方", :furigana=>"あいかわまち"},
      144029=>{:code=>"144029", :pref=>"神奈川県", :name=>"清川村", :type=>"村", :district=>"関東地方", :furigana=>"きよかわむら"},
      150002=>{:code=>"150002", :pref=>"新潟県", :name=>"新潟県", :type=>"都道府県", :district=>"中部地方", :furigana=>"にいがたけん"},
      151009=>{:code=>"151009", :pref=>"新潟県", :name=>"新潟市", :type=>"政令市", :district=>"中部地方", :furigana=>"にいがたし"},
      151017=>{:code=>"151017", :pref=>"新潟県", :name=>"新潟市北区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしきたく"},
      151025=>{:code=>"151025", :pref=>"新潟県", :name=>"新潟市東区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしひがしく"},
      151033=>{:code=>"151033", :pref=>"新潟県", :name=>"新潟市中央区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしちゅうおうく"},
      151041=>{:code=>"151041", :pref=>"新潟県", :name=>"新潟市江南区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしこうなんく"},
      151050=>{:code=>"151050", :pref=>"新潟県", :name=>"新潟市秋葉区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしあきはく"},
      151068=>{:code=>"151068", :pref=>"新潟県", :name=>"新潟市南区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしみなみく"},
      151076=>{:code=>"151076", :pref=>"新潟県", :name=>"新潟市西区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしにしく"},
      151084=>{:code=>"151084", :pref=>"新潟県", :name=>"新潟市西蒲区", :type=>"行政区", :district=>"中部地方", :furigana=>"にいがたしにしかんく"},
      152021=>{:code=>"152021", :pref=>"新潟県", :name=>"長岡市", :type=>"市", :district=>"中部地方", :furigana=>"ながおかし"},
      152048=>{:code=>"152048", :pref=>"新潟県", :name=>"三条市", :type=>"市", :district=>"中部地方", :furigana=>"さんじょうし"},
      152056=>{:code=>"152056", :pref=>"新潟県", :name=>"柏崎市", :type=>"市", :district=>"中部地方", :furigana=>"かしわざきし"},
      152064=>{:code=>"152064", :pref=>"新潟県", :name=>"新発田市", :type=>"市", :district=>"中部地方", :furigana=>"しばたし"},
      152081=>{:code=>"152081", :pref=>"新潟県", :name=>"小千谷市", :type=>"市", :district=>"中部地方", :furigana=>"おぢやし"},
      152099=>{:code=>"152099", :pref=>"新潟県", :name=>"加茂市", :type=>"市", :district=>"中部地方", :furigana=>"かもし"},
      152102=>{:code=>"152102", :pref=>"新潟県", :name=>"十日町市", :type=>"市", :district=>"中部地方", :furigana=>"とおかまちし"},
      152111=>{:code=>"152111", :pref=>"新潟県", :name=>"見附市", :type=>"市", :district=>"中部地方", :furigana=>"みつけし"},
      152129=>{:code=>"152129", :pref=>"新潟県", :name=>"村上市", :type=>"市", :district=>"中部地方", :furigana=>"むらかみし"},
      152137=>{:code=>"152137", :pref=>"新潟県", :name=>"燕市", :type=>"市", :district=>"中部地方", :furigana=>"つばめし"},
      152161=>{:code=>"152161", :pref=>"新潟県", :name=>"糸魚川市", :type=>"市", :district=>"中部地方", :furigana=>"いといがわし"},
      152170=>{:code=>"152170", :pref=>"新潟県", :name=>"妙高市", :type=>"市", :district=>"中部地方", :furigana=>"みょうこうし"},
      152188=>{:code=>"152188", :pref=>"新潟県", :name=>"五泉市", :type=>"市", :district=>"中部地方", :furigana=>"ごせんし"},
      152226=>{:code=>"152226", :pref=>"新潟県", :name=>"上越市", :type=>"市", :district=>"中部地方", :furigana=>"じょうえつし"},
      152234=>{:code=>"152234", :pref=>"新潟県", :name=>"阿賀野市", :type=>"市", :district=>"中部地方", :furigana=>"あがのし"},
      152242=>{:code=>"152242", :pref=>"新潟県", :name=>"佐渡市", :type=>"市", :district=>"中部地方", :furigana=>"さどし"},
      152251=>{:code=>"152251", :pref=>"新潟県", :name=>"魚沼市", :type=>"市", :district=>"中部地方", :furigana=>"うおぬまし"},
      152269=>{:code=>"152269", :pref=>"新潟県", :name=>"南魚沼市", :type=>"市", :district=>"中部地方", :furigana=>"みなみうおぬまし"},
      152277=>{:code=>"152277", :pref=>"新潟県", :name=>"胎内市", :type=>"市", :district=>"中部地方", :furigana=>"たいないし"},
      153079=>{:code=>"153079", :pref=>"新潟県", :name=>"聖籠町", :type=>"町", :district=>"中部地方", :furigana=>"せいろうまち"},
      153427=>{:code=>"153427", :pref=>"新潟県", :name=>"弥彦村", :type=>"村", :district=>"中部地方", :furigana=>"やひこむら"},
      153613=>{:code=>"153613", :pref=>"新潟県", :name=>"田上町", :type=>"町", :district=>"中部地方", :furigana=>"たがみまち"},
      153851=>{:code=>"153851", :pref=>"新潟県", :name=>"阿賀町", :type=>"町", :district=>"中部地方", :furigana=>"あがまち"},
      154059=>{:code=>"154059", :pref=>"新潟県", :name=>"出雲崎町", :type=>"町", :district=>"中部地方", :furigana=>"いずもざきまち"},
      154610=>{:code=>"154610", :pref=>"新潟県", :name=>"湯沢町", :type=>"町", :district=>"中部地方", :furigana=>"ゆざわまち"},
      154822=>{:code=>"154822", :pref=>"新潟県", :name=>"津南町", :type=>"町", :district=>"中部地方", :furigana=>"つなんまち"},
      155047=>{:code=>"155047", :pref=>"新潟県", :name=>"刈羽村", :type=>"村", :district=>"中部地方", :furigana=>"かりわむら"},
      155811=>{:code=>"155811", :pref=>"新潟県", :name=>"関川村", :type=>"村", :district=>"中部地方", :furigana=>"せきかわむら"},
      155861=>{:code=>"155861", :pref=>"新潟県", :name=>"粟島浦村", :type=>"村", :district=>"中部地方", :furigana=>"あわしまうらむら"},
      160008=>{:code=>"160008", :pref=>"富山県", :name=>"富山県", :type=>"都道府県", :district=>"中部地方", :furigana=>"とやまけん"},
      162019=>{:code=>"162019", :pref=>"富山県", :name=>"富山市", :type=>"市", :district=>"中部地方", :furigana=>"とやまし"},
      162027=>{:code=>"162027", :pref=>"富山県", :name=>"高岡市", :type=>"市", :district=>"中部地方", :furigana=>"たかおかし"},
      162043=>{:code=>"162043", :pref=>"富山県", :name=>"魚津市", :type=>"市", :district=>"中部地方", :furigana=>"うおづし"},
      162051=>{:code=>"162051", :pref=>"富山県", :name=>"氷見市", :type=>"市", :district=>"中部地方", :furigana=>"ひみし"},
      162060=>{:code=>"162060", :pref=>"富山県", :name=>"滑川市", :type=>"市", :district=>"中部地方", :furigana=>"なめりかわし"},
      162078=>{:code=>"162078", :pref=>"富山県", :name=>"黒部市", :type=>"市", :district=>"中部地方", :furigana=>"くろべし"},
      162086=>{:code=>"162086", :pref=>"富山県", :name=>"砺波市", :type=>"市", :district=>"中部地方", :furigana=>"となみし"},
      162094=>{:code=>"162094", :pref=>"富山県", :name=>"小矢部市", :type=>"市", :district=>"中部地方", :furigana=>"おやべし"},
      162108=>{:code=>"162108", :pref=>"富山県", :name=>"南砺市", :type=>"市", :district=>"中部地方", :furigana=>"なんとし"},
      162116=>{:code=>"162116", :pref=>"富山県", :name=>"射水市", :type=>"市", :district=>"中部地方", :furigana=>"いみずし"},
      163210=>{:code=>"163210", :pref=>"富山県", :name=>"舟橋村", :type=>"村", :district=>"中部地方", :furigana=>"ふなはしむら"},
      163228=>{:code=>"163228", :pref=>"富山県", :name=>"上市町", :type=>"町", :district=>"中部地方", :furigana=>"かみいちまち"},
      163236=>{:code=>"163236", :pref=>"富山県", :name=>"立山町", :type=>"町", :district=>"中部地方", :furigana=>"たてやままち"},
      163422=>{:code=>"163422", :pref=>"富山県", :name=>"入善町", :type=>"町", :district=>"中部地方", :furigana=>"にゅうぜんまち"},
      163431=>{:code=>"163431", :pref=>"富山県", :name=>"朝日町", :type=>"町", :district=>"中部地方", :furigana=>"あさひまち"},
      170003=>{:code=>"170003", :pref=>"石川県", :name=>"石川県", :type=>"都道府県", :district=>"中部地方", :furigana=>"いしかわけん"},
      172014=>{:code=>"172014", :pref=>"石川県", :name=>"金沢市", :type=>"市", :district=>"中部地方", :furigana=>"かなざわし"},
      172022=>{:code=>"172022", :pref=>"石川県", :name=>"七尾市", :type=>"市", :district=>"中部地方", :furigana=>"ななおし"},
      172031=>{:code=>"172031", :pref=>"石川県", :name=>"小松市", :type=>"市", :district=>"中部地方", :furigana=>"こまつし"},
      172049=>{:code=>"172049", :pref=>"石川県", :name=>"輪島市", :type=>"市", :district=>"中部地方", :furigana=>"わじまし"},
      172057=>{:code=>"172057", :pref=>"石川県", :name=>"珠洲市", :type=>"市", :district=>"中部地方", :furigana=>"すずし"},
      172065=>{:code=>"172065", :pref=>"石川県", :name=>"加賀市", :type=>"市", :district=>"中部地方", :furigana=>"かがし"},
      172073=>{:code=>"172073", :pref=>"石川県", :name=>"羽咋市", :type=>"市", :district=>"中部地方", :furigana=>"はくいし"},
      172090=>{:code=>"172090", :pref=>"石川県", :name=>"かほく市", :type=>"市", :district=>"中部地方", :furigana=>"かほくし"},
      172103=>{:code=>"172103", :pref=>"石川県", :name=>"白山市", :type=>"市", :district=>"中部地方", :furigana=>"はくさんし"},
      172111=>{:code=>"172111", :pref=>"石川県", :name=>"能美市", :type=>"市", :district=>"中部地方", :furigana=>"のみし"},
      172120=>{:code=>"172120", :pref=>"石川県", :name=>"野々市市", :type=>"市", :district=>"中部地方", :furigana=>"ののいちし"},
      173240=>{:code=>"173240", :pref=>"石川県", :name=>"川北町", :type=>"町", :district=>"中部地方", :furigana=>"かわきたまち"},
      173614=>{:code=>"173614", :pref=>"石川県", :name=>"津幡町", :type=>"町", :district=>"中部地方", :furigana=>"つばたまち"},
      173657=>{:code=>"173657", :pref=>"石川県", :name=>"内灘町", :type=>"町", :district=>"中部地方", :furigana=>"うちなだまち"},
      173843=>{:code=>"173843", :pref=>"石川県", :name=>"志賀町", :type=>"町", :district=>"中部地方", :furigana=>"しかまち"},
      173860=>{:code=>"173860", :pref=>"石川県", :name=>"宝達志水町", :type=>"町", :district=>"中部地方", :furigana=>"ほうだつしみずちょう"},
      174076=>{:code=>"174076", :pref=>"石川県", :name=>"中能登町", :type=>"町", :district=>"中部地方", :furigana=>"なかのとまち"},
      174611=>{:code=>"174611", :pref=>"石川県", :name=>"穴水町", :type=>"町", :district=>"中部地方", :furigana=>"あなみずまち"},
      174637=>{:code=>"174637", :pref=>"石川県", :name=>"能登町", :type=>"町", :district=>"中部地方", :furigana=>"のとちょう"},
      180009=>{:code=>"180009", :pref=>"福井県", :name=>"福井県", :type=>"都道府県", :district=>"中部地方", :furigana=>"ふくいけん"},
      182010=>{:code=>"182010", :pref=>"福井県", :name=>"福井市", :type=>"市", :district=>"中部地方", :furigana=>"ふくいし"},
      182028=>{:code=>"182028", :pref=>"福井県", :name=>"敦賀市", :type=>"市", :district=>"中部地方", :furigana=>"つるがし"},
      182044=>{:code=>"182044", :pref=>"福井県", :name=>"小浜市", :type=>"市", :district=>"中部地方", :furigana=>"おばまし"},
      182052=>{:code=>"182052", :pref=>"福井県", :name=>"大野市", :type=>"市", :district=>"中部地方", :furigana=>"おおのし"},
      182061=>{:code=>"182061", :pref=>"福井県", :name=>"勝山市", :type=>"市", :district=>"中部地方", :furigana=>"かつやまし"},
      182079=>{:code=>"182079", :pref=>"福井県", :name=>"鯖江市", :type=>"市", :district=>"中部地方", :furigana=>"さばえし"},
      182087=>{:code=>"182087", :pref=>"福井県", :name=>"あわら市", :type=>"市", :district=>"中部地方", :furigana=>"あわらし"},
      182095=>{:code=>"182095", :pref=>"福井県", :name=>"越前市", :type=>"市", :district=>"中部地方", :furigana=>"えちぜんし"},
      182109=>{:code=>"182109", :pref=>"福井県", :name=>"坂井市", :type=>"市", :district=>"中部地方", :furigana=>"さかいし"},
      183229=>{:code=>"183229", :pref=>"福井県", :name=>"永平寺町", :type=>"町", :district=>"中部地方", :furigana=>"えいへいじちょう"},
      183822=>{:code=>"183822", :pref=>"福井県", :name=>"池田町", :type=>"町", :district=>"中部地方", :furigana=>"いけだちょう"},
      184047=>{:code=>"184047", :pref=>"福井県", :name=>"南越前町", :type=>"町", :district=>"中部地方", :furigana=>"みなみえちぜんちょう"},
      184233=>{:code=>"184233", :pref=>"福井県", :name=>"越前町", :type=>"町", :district=>"中部地方", :furigana=>"えちぜんちょう"},
      184420=>{:code=>"184420", :pref=>"福井県", :name=>"美浜町", :type=>"町", :district=>"中部地方", :furigana=>"みはまちょう"},
      184811=>{:code=>"184811", :pref=>"福井県", :name=>"高浜町", :type=>"町", :district=>"中部地方", :furigana=>"たかはまちょう"},
      184837=>{:code=>"184837", :pref=>"福井県", :name=>"おおい町", :type=>"町", :district=>"中部地方", :furigana=>"おおいちょう"},
      185019=>{:code=>"185019", :pref=>"福井県", :name=>"若狭町", :type=>"町", :district=>"中部地方", :furigana=>"わかさちょう"},
      190004=>{:code=>"190004", :pref=>"山梨県", :name=>"山梨県", :type=>"都道府県", :district=>"中部地方", :furigana=>"やまなしけん"},
      192015=>{:code=>"192015", :pref=>"山梨県", :name=>"甲府市", :type=>"市", :district=>"中部地方", :furigana=>"こうふし"},
      192023=>{:code=>"192023", :pref=>"山梨県", :name=>"富士吉田市", :type=>"市", :district=>"中部地方", :furigana=>"ふじよしだし"},
      192040=>{:code=>"192040", :pref=>"山梨県", :name=>"都留市", :type=>"市", :district=>"中部地方", :furigana=>"つるし"},
      192058=>{:code=>"192058", :pref=>"山梨県", :name=>"山梨市", :type=>"市", :district=>"中部地方", :furigana=>"やまなしし"},
      192066=>{:code=>"192066", :pref=>"山梨県", :name=>"大月市", :type=>"市", :district=>"中部地方", :furigana=>"おおつきし"},
      192074=>{:code=>"192074", :pref=>"山梨県", :name=>"韮崎市", :type=>"市", :district=>"中部地方", :furigana=>"にらさきし"},
      192082=>{:code=>"192082", :pref=>"山梨県", :name=>"南アルプス市", :type=>"市", :district=>"中部地方", :furigana=>"みなみあるぷすし"},
      192091=>{:code=>"192091", :pref=>"山梨県", :name=>"北杜市", :type=>"市", :district=>"中部地方", :furigana=>"ほくとし"},
      192104=>{:code=>"192104", :pref=>"山梨県", :name=>"甲斐市", :type=>"市", :district=>"中部地方", :furigana=>"かいし"},
      192112=>{:code=>"192112", :pref=>"山梨県", :name=>"笛吹市", :type=>"市", :district=>"中部地方", :furigana=>"ふえふきし"},
      192121=>{:code=>"192121", :pref=>"山梨県", :name=>"上野原市", :type=>"市", :district=>"中部地方", :furigana=>"うえのはらし"},
      192139=>{:code=>"192139", :pref=>"山梨県", :name=>"甲州市", :type=>"市", :district=>"中部地方", :furigana=>"こうしゅうし"},
      192147=>{:code=>"192147", :pref=>"山梨県", :name=>"中央市", :type=>"市", :district=>"中部地方", :furigana=>"ちゅうおうし"},
      193461=>{:code=>"193461", :pref=>"山梨県", :name=>"市川三郷町", :type=>"町", :district=>"中部地方", :furigana=>"いちかわみさとちょう"},
      193640=>{:code=>"193640", :pref=>"山梨県", :name=>"早川町", :type=>"町", :district=>"中部地方", :furigana=>"はやかわちょう"},
      193658=>{:code=>"193658", :pref=>"山梨県", :name=>"身延町", :type=>"町", :district=>"中部地方", :furigana=>"みのぶちょう"},
      193666=>{:code=>"193666", :pref=>"山梨県", :name=>"南部町", :type=>"町", :district=>"中部地方", :furigana=>"なんぶちょう"},
      193682=>{:code=>"193682", :pref=>"山梨県", :name=>"富士川町", :type=>"町", :district=>"中部地方", :furigana=>"ふじかわちょう"},
      193844=>{:code=>"193844", :pref=>"山梨県", :name=>"昭和町", :type=>"町", :district=>"中部地方", :furigana=>"しょうわちょう"},
      194221=>{:code=>"194221", :pref=>"山梨県", :name=>"道志村", :type=>"村", :district=>"中部地方", :furigana=>"どうしむら"},
      194239=>{:code=>"194239", :pref=>"山梨県", :name=>"西桂町", :type=>"町", :district=>"中部地方", :furigana=>"にしかつらちょう"},
      194247=>{:code=>"194247", :pref=>"山梨県", :name=>"忍野村", :type=>"村", :district=>"中部地方", :furigana=>"おしのむら"},
      194255=>{:code=>"194255", :pref=>"山梨県", :name=>"山中湖村", :type=>"村", :district=>"中部地方", :furigana=>"やまなかこむら"},
      194298=>{:code=>"194298", :pref=>"山梨県", :name=>"鳴沢村", :type=>"村", :district=>"中部地方", :furigana=>"なるさわむら"},
      194301=>{:code=>"194301", :pref=>"山梨県", :name=>"富士河口湖町", :type=>"町", :district=>"中部地方", :furigana=>"ふじかわぐちこまち"},
      194425=>{:code=>"194425", :pref=>"山梨県", :name=>"小菅村", :type=>"村", :district=>"中部地方", :furigana=>"こすげむら"},
      194433=>{:code=>"194433", :pref=>"山梨県", :name=>"丹波山村", :type=>"村", :district=>"中部地方", :furigana=>"たばやまむら"},
      200000=>{:code=>"200000", :pref=>"長野県", :name=>"長野県", :type=>"都道府県", :district=>"中部地方", :furigana=>"ながのけん"},
      202011=>{:code=>"202011", :pref=>"長野県", :name=>"長野市", :type=>"市", :district=>"中部地方", :furigana=>"ながのし"},
      202029=>{:code=>"202029", :pref=>"長野県", :name=>"松本市", :type=>"市", :district=>"中部地方", :furigana=>"まつもとし"},
      202037=>{:code=>"202037", :pref=>"長野県", :name=>"上田市", :type=>"市", :district=>"中部地方", :furigana=>"うえだし"},
      202045=>{:code=>"202045", :pref=>"長野県", :name=>"岡谷市", :type=>"市", :district=>"中部地方", :furigana=>"おかやし"},
      202053=>{:code=>"202053", :pref=>"長野県", :name=>"飯田市", :type=>"市", :district=>"中部地方", :furigana=>"いいだし"},
      202061=>{:code=>"202061", :pref=>"長野県", :name=>"諏訪市", :type=>"市", :district=>"中部地方", :furigana=>"すわし"},
      202070=>{:code=>"202070", :pref=>"長野県", :name=>"須坂市", :type=>"市", :district=>"中部地方", :furigana=>"すざかし"},
      202088=>{:code=>"202088", :pref=>"長野県", :name=>"小諸市", :type=>"市", :district=>"中部地方", :furigana=>"こもろし"},
      202096=>{:code=>"202096", :pref=>"長野県", :name=>"伊那市", :type=>"市", :district=>"中部地方", :furigana=>"いなし"},
      202100=>{:code=>"202100", :pref=>"長野県", :name=>"駒ヶ根市", :type=>"市", :district=>"中部地方", :furigana=>"こまがねし"},
      202118=>{:code=>"202118", :pref=>"長野県", :name=>"中野市", :type=>"市", :district=>"中部地方", :furigana=>"なかのし"},
      202126=>{:code=>"202126", :pref=>"長野県", :name=>"大町市", :type=>"市", :district=>"中部地方", :furigana=>"おおまちし"},
      202134=>{:code=>"202134", :pref=>"長野県", :name=>"飯山市", :type=>"市", :district=>"中部地方", :furigana=>"いいやまし"},
      202142=>{:code=>"202142", :pref=>"長野県", :name=>"茅野市", :type=>"市", :district=>"中部地方", :furigana=>"ちのし"},
      202151=>{:code=>"202151", :pref=>"長野県", :name=>"塩尻市", :type=>"市", :district=>"中部地方", :furigana=>"しおじりし"},
      202177=>{:code=>"202177", :pref=>"長野県", :name=>"佐久市", :type=>"市", :district=>"中部地方", :furigana=>"さくし"},
      202185=>{:code=>"202185", :pref=>"長野県", :name=>"千曲市", :type=>"市", :district=>"中部地方", :furigana=>"ちくまし"},
      202193=>{:code=>"202193", :pref=>"長野県", :name=>"東御市", :type=>"市", :district=>"中部地方", :furigana=>"とうみし"},
      202207=>{:code=>"202207", :pref=>"長野県", :name=>"安曇野市", :type=>"市", :district=>"中部地方", :furigana=>"あづみのし"},
      203033=>{:code=>"203033", :pref=>"長野県", :name=>"小海町", :type=>"町", :district=>"中部地方", :furigana=>"こうみまち"},
      203041=>{:code=>"203041", :pref=>"長野県", :name=>"川上村", :type=>"村", :district=>"中部地方", :furigana=>"かわかみむら"},
      203050=>{:code=>"203050", :pref=>"長野県", :name=>"南牧村", :type=>"村", :district=>"中部地方", :furigana=>"みなみまきむら"},
      203068=>{:code=>"203068", :pref=>"長野県", :name=>"南相木村", :type=>"村", :district=>"中部地方", :furigana=>"みなみあいきむら"},
      203076=>{:code=>"203076", :pref=>"長野県", :name=>"北相木村", :type=>"村", :district=>"中部地方", :furigana=>"きたあいきむら"},
      203092=>{:code=>"203092", :pref=>"長野県", :name=>"佐久穂町", :type=>"町", :district=>"中部地方", :furigana=>"さくほまち"},
      203211=>{:code=>"203211", :pref=>"長野県", :name=>"軽井沢町", :type=>"町", :district=>"中部地方", :furigana=>"かるいざわまち"},
      203238=>{:code=>"203238", :pref=>"長野県", :name=>"御代田町", :type=>"町", :district=>"中部地方", :furigana=>"みよたまち"},
      203246=>{:code=>"203246", :pref=>"長野県", :name=>"立科町", :type=>"町", :district=>"中部地方", :furigana=>"たてしなまち"},
      203491=>{:code=>"203491", :pref=>"長野県", :name=>"青木村", :type=>"村", :district=>"中部地方", :furigana=>"あおきむら"},
      203505=>{:code=>"203505", :pref=>"長野県", :name=>"長和町", :type=>"町", :district=>"中部地方", :furigana=>"ながわまち"},
      203611=>{:code=>"203611", :pref=>"長野県", :name=>"下諏訪町", :type=>"町", :district=>"中部地方", :furigana=>"しもすわまち"},
      203629=>{:code=>"203629", :pref=>"長野県", :name=>"富士見町", :type=>"町", :district=>"中部地方", :furigana=>"ふじみまち"},
      203637=>{:code=>"203637", :pref=>"長野県", :name=>"原村", :type=>"村", :district=>"中部地方", :furigana=>"はらむら"},
      203823=>{:code=>"203823", :pref=>"長野県", :name=>"辰野町", :type=>"町", :district=>"中部地方", :furigana=>"たつのまち"},
      203831=>{:code=>"203831", :pref=>"長野県", :name=>"箕輪町", :type=>"町", :district=>"中部地方", :furigana=>"みのわまち"},
      203840=>{:code=>"203840", :pref=>"長野県", :name=>"飯島町", :type=>"町", :district=>"中部地方", :furigana=>"いいじままち"},
      203858=>{:code=>"203858", :pref=>"長野県", :name=>"南箕輪村", :type=>"村", :district=>"中部地方", :furigana=>"みなみみのわむら"},
      203866=>{:code=>"203866", :pref=>"長野県", :name=>"中川村", :type=>"村", :district=>"中部地方", :furigana=>"なかがわむら"},
      203882=>{:code=>"203882", :pref=>"長野県", :name=>"宮田村", :type=>"村", :district=>"中部地方", :furigana=>"みやだむら"},
      204021=>{:code=>"204021", :pref=>"長野県", :name=>"松川町", :type=>"町", :district=>"中部地方", :furigana=>"まつかわまち"},
      204030=>{:code=>"204030", :pref=>"長野県", :name=>"高森町", :type=>"町", :district=>"中部地方", :furigana=>"たかもりまち"},
      204048=>{:code=>"204048", :pref=>"長野県", :name=>"阿南町", :type=>"町", :district=>"中部地方", :furigana=>"あなんちょう"},
      204072=>{:code=>"204072", :pref=>"長野県", :name=>"阿智村", :type=>"村", :district=>"中部地方", :furigana=>"あちむら"},
      204099=>{:code=>"204099", :pref=>"長野県", :name=>"平谷村", :type=>"村", :district=>"中部地方", :furigana=>"ひらやむら"},
      204102=>{:code=>"204102", :pref=>"長野県", :name=>"根羽村", :type=>"村", :district=>"中部地方", :furigana=>"ねばむら"},
      204111=>{:code=>"204111", :pref=>"長野県", :name=>"下條村", :type=>"村", :district=>"中部地方", :furigana=>"しもじょうむら"},
      204129=>{:code=>"204129", :pref=>"長野県", :name=>"売木村", :type=>"村", :district=>"中部地方", :furigana=>"うるぎむら"},
      204137=>{:code=>"204137", :pref=>"長野県", :name=>"天龍村", :type=>"村", :district=>"中部地方", :furigana=>"てんりゅうむら"},
      204145=>{:code=>"204145", :pref=>"長野県", :name=>"泰阜村", :type=>"村", :district=>"中部地方", :furigana=>"やすおかむら"},
      204153=>{:code=>"204153", :pref=>"長野県", :name=>"喬木村", :type=>"村", :district=>"中部地方", :furigana=>"たかぎむら"},
      204161=>{:code=>"204161", :pref=>"長野県", :name=>"豊丘村", :type=>"村", :district=>"中部地方", :furigana=>"とよおかむら"},
      204170=>{:code=>"204170", :pref=>"長野県", :name=>"大鹿村", :type=>"村", :district=>"中部地方", :furigana=>"おおしかむら"},
      204226=>{:code=>"204226", :pref=>"長野県", :name=>"上松町", :type=>"町", :district=>"中部地方", :furigana=>"あげまつまち"},
      204234=>{:code=>"204234", :pref=>"長野県", :name=>"南木曽町", :type=>"町", :district=>"中部地方", :furigana=>"なぎそまち"},
      204251=>{:code=>"204251", :pref=>"長野県", :name=>"木祖村", :type=>"村", :district=>"中部地方", :furigana=>"きそむら"},
      204293=>{:code=>"204293", :pref=>"長野県", :name=>"王滝村", :type=>"村", :district=>"中部地方", :furigana=>"おうたきむら"},
      204307=>{:code=>"204307", :pref=>"長野県", :name=>"大桑村", :type=>"村", :district=>"中部地方", :furigana=>"おおくわむら"},
      204323=>{:code=>"204323", :pref=>"長野県", :name=>"木曽町", :type=>"町", :district=>"中部地方", :furigana=>"きそまち"},
      204463=>{:code=>"204463", :pref=>"長野県", :name=>"麻績村", :type=>"村", :district=>"中部地方", :furigana=>"おみむら"},
      204480=>{:code=>"204480", :pref=>"長野県", :name=>"生坂村", :type=>"村", :district=>"中部地方", :furigana=>"いくさかむら"},
      204501=>{:code=>"204501", :pref=>"長野県", :name=>"山形村", :type=>"村", :district=>"中部地方", :furigana=>"やまがたむら"},
      204510=>{:code=>"204510", :pref=>"長野県", :name=>"朝日村", :type=>"村", :district=>"中部地方", :furigana=>"あさひむら"},
      204528=>{:code=>"204528", :pref=>"長野県", :name=>"筑北村", :type=>"村", :district=>"中部地方", :furigana=>"ちくほくむら"},
      204811=>{:code=>"204811", :pref=>"長野県", :name=>"池田町", :type=>"町", :district=>"中部地方", :furigana=>"いけだまち"},
      204820=>{:code=>"204820", :pref=>"長野県", :name=>"松川村", :type=>"村", :district=>"中部地方", :furigana=>"まつかわむら"},
      204854=>{:code=>"204854", :pref=>"長野県", :name=>"白馬村", :type=>"村", :district=>"中部地方", :furigana=>"はくばむら"},
      204862=>{:code=>"204862", :pref=>"長野県", :name=>"小谷村", :type=>"村", :district=>"中部地方", :furigana=>"おたりむら"},
      205214=>{:code=>"205214", :pref=>"長野県", :name=>"坂城町", :type=>"町", :district=>"中部地方", :furigana=>"さかきまち"},
      205419=>{:code=>"205419", :pref=>"長野県", :name=>"小布施町", :type=>"町", :district=>"中部地方", :furigana=>"おぶせまち"},
      205435=>{:code=>"205435", :pref=>"長野県", :name=>"高山村", :type=>"村", :district=>"中部地方", :furigana=>"たかやまむら"},
      205613=>{:code=>"205613", :pref=>"長野県", :name=>"山ノ内町", :type=>"町", :district=>"中部地方", :furigana=>"やまのうちまち"},
      205621=>{:code=>"205621", :pref=>"長野県", :name=>"木島平村", :type=>"村", :district=>"中部地方", :furigana=>"きじまだいらむら"},
      205630=>{:code=>"205630", :pref=>"長野県", :name=>"野沢温泉村", :type=>"村", :district=>"中部地方", :furigana=>"のざわおんせんむら"},
      205834=>{:code=>"205834", :pref=>"長野県", :name=>"信濃町", :type=>"町", :district=>"中部地方", :furigana=>"しなのまち"},
      205885=>{:code=>"205885", :pref=>"長野県", :name=>"小川村", :type=>"村", :district=>"中部地方", :furigana=>"おがわむら"},
      205907=>{:code=>"205907", :pref=>"長野県", :name=>"飯綱町", :type=>"町", :district=>"中部地方", :furigana=>"いいづなまち"},
      206024=>{:code=>"206024", :pref=>"長野県", :name=>"栄村", :type=>"村", :district=>"中部地方", :furigana=>"さかえむら"},
      210005=>{:code=>"210005", :pref=>"岐阜県", :name=>"岐阜県", :type=>"都道府県", :district=>"中部地方", :furigana=>"ぎふけん"},
      212016=>{:code=>"212016", :pref=>"岐阜県", :name=>"岐阜市", :type=>"市", :district=>"中部地方", :furigana=>"ぎふし"},
      212024=>{:code=>"212024", :pref=>"岐阜県", :name=>"大垣市", :type=>"市", :district=>"中部地方", :furigana=>"おおがきし"},
      212032=>{:code=>"212032", :pref=>"岐阜県", :name=>"高山市", :type=>"市", :district=>"中部地方", :furigana=>"たかやまし"},
      212041=>{:code=>"212041", :pref=>"岐阜県", :name=>"多治見市", :type=>"市", :district=>"中部地方", :furigana=>"たじみし"},
      212059=>{:code=>"212059", :pref=>"岐阜県", :name=>"関市", :type=>"市", :district=>"中部地方", :furigana=>"せきし"},
      212067=>{:code=>"212067", :pref=>"岐阜県", :name=>"中津川市", :type=>"市", :district=>"中部地方", :furigana=>"なかつがわし"},
      212075=>{:code=>"212075", :pref=>"岐阜県", :name=>"美濃市", :type=>"市", :district=>"中部地方", :furigana=>"みのし"},
      212083=>{:code=>"212083", :pref=>"岐阜県", :name=>"瑞浪市", :type=>"市", :district=>"中部地方", :furigana=>"みずなみし"},
      212091=>{:code=>"212091", :pref=>"岐阜県", :name=>"羽島市", :type=>"市", :district=>"中部地方", :furigana=>"はしまし"},
      212105=>{:code=>"212105", :pref=>"岐阜県", :name=>"恵那市", :type=>"市", :district=>"中部地方", :furigana=>"えなし"},
      212113=>{:code=>"212113", :pref=>"岐阜県", :name=>"美濃加茂市", :type=>"市", :district=>"中部地方", :furigana=>"みのかもし"},
      212121=>{:code=>"212121", :pref=>"岐阜県", :name=>"土岐市", :type=>"市", :district=>"中部地方", :furigana=>"ときし"},
      212130=>{:code=>"212130", :pref=>"岐阜県", :name=>"各務原市", :type=>"市", :district=>"中部地方", :furigana=>"かかみがはらし"},
      212148=>{:code=>"212148", :pref=>"岐阜県", :name=>"可児市", :type=>"市", :district=>"中部地方", :furigana=>"かにし"},
      212156=>{:code=>"212156", :pref=>"岐阜県", :name=>"山県市", :type=>"市", :district=>"中部地方", :furigana=>"やまがたし"},
      212164=>{:code=>"212164", :pref=>"岐阜県", :name=>"瑞穂市", :type=>"市", :district=>"中部地方", :furigana=>"みずほし"},
      212172=>{:code=>"212172", :pref=>"岐阜県", :name=>"飛騨市", :type=>"市", :district=>"中部地方", :furigana=>"ひだし"},
      212181=>{:code=>"212181", :pref=>"岐阜県", :name=>"本巣市", :type=>"市", :district=>"中部地方", :furigana=>"もとすし"},
      212199=>{:code=>"212199", :pref=>"岐阜県", :name=>"郡上市", :type=>"市", :district=>"中部地方", :furigana=>"ぐじょうし"},
      212202=>{:code=>"212202", :pref=>"岐阜県", :name=>"下呂市", :type=>"市", :district=>"中部地方", :furigana=>"げろし"},
      212211=>{:code=>"212211", :pref=>"岐阜県", :name=>"海津市", :type=>"市", :district=>"中部地方", :furigana=>"かいづし"},
      213021=>{:code=>"213021", :pref=>"岐阜県", :name=>"岐南町", :type=>"町", :district=>"中部地方", :furigana=>"ぎなんちょう"},
      213039=>{:code=>"213039", :pref=>"岐阜県", :name=>"笠松町", :type=>"町", :district=>"中部地方", :furigana=>"かさまつちょう"},
      213411=>{:code=>"213411", :pref=>"岐阜県", :name=>"養老町", :type=>"町", :district=>"中部地方", :furigana=>"ようろうちょう"},
      213616=>{:code=>"213616", :pref=>"岐阜県", :name=>"垂井町", :type=>"町", :district=>"中部地方", :furigana=>"たるいちょう"},
      213624=>{:code=>"213624", :pref=>"岐阜県", :name=>"関ケ原町", :type=>"町", :district=>"中部地方", :furigana=>"せきがはらちょう"},
      213811=>{:code=>"213811", :pref=>"岐阜県", :name=>"神戸町", :type=>"町", :district=>"中部地方", :furigana=>"ごうどちょう"},
      213829=>{:code=>"213829", :pref=>"岐阜県", :name=>"輪之内町", :type=>"町", :district=>"中部地方", :furigana=>"わのうちちょう"},
      213837=>{:code=>"213837", :pref=>"岐阜県", :name=>"安八町", :type=>"町", :district=>"中部地方", :furigana=>"あんぱちちょう"},
      214019=>{:code=>"214019", :pref=>"岐阜県", :name=>"揖斐川町", :type=>"町", :district=>"中部地方", :furigana=>"いびがわちょう"},
      214035=>{:code=>"214035", :pref=>"岐阜県", :name=>"大野町", :type=>"町", :district=>"中部地方", :furigana=>"おおのちょう"},
      214043=>{:code=>"214043", :pref=>"岐阜県", :name=>"池田町", :type=>"町", :district=>"中部地方", :furigana=>"いけだちょう"},
      214213=>{:code=>"214213", :pref=>"岐阜県", :name=>"北方町", :type=>"町", :district=>"中部地方", :furigana=>"きたがたちょう"},
      215015=>{:code=>"215015", :pref=>"岐阜県", :name=>"坂祝町", :type=>"町", :district=>"中部地方", :furigana=>"さかほぎちょう"},
      215023=>{:code=>"215023", :pref=>"岐阜県", :name=>"富加町", :type=>"町", :district=>"中部地方", :furigana=>"とみかちょう"},
      215031=>{:code=>"215031", :pref=>"岐阜県", :name=>"川辺町", :type=>"町", :district=>"中部地方", :furigana=>"かわべちょう"},
      215040=>{:code=>"215040", :pref=>"岐阜県", :name=>"七宗町", :type=>"町", :district=>"中部地方", :furigana=>"ひちそうちょう"},
      215058=>{:code=>"215058", :pref=>"岐阜県", :name=>"八百津町", :type=>"町", :district=>"中部地方", :furigana=>"やおつちょう"},
      215066=>{:code=>"215066", :pref=>"岐阜県", :name=>"白川町", :type=>"町", :district=>"中部地方", :furigana=>"しらかわちょう"},
      215074=>{:code=>"215074", :pref=>"岐阜県", :name=>"東白川村", :type=>"村", :district=>"中部地方", :furigana=>"ひがししらかわむら"},
      215210=>{:code=>"215210", :pref=>"岐阜県", :name=>"御嵩町", :type=>"町", :district=>"中部地方", :furigana=>"みたけちょう"},
      216046=>{:code=>"216046", :pref=>"岐阜県", :name=>"白川村", :type=>"村", :district=>"中部地方", :furigana=>"しらかわむら"},
      220001=>{:code=>"220001", :pref=>"静岡県", :name=>"静岡県", :type=>"都道府県", :district=>"中部地方", :furigana=>"しずおかけん"},
      221007=>{:code=>"221007", :pref=>"静岡県", :name=>"静岡市", :type=>"政令市", :district=>"中部地方", :furigana=>"しずおかし"},
      221015=>{:code=>"221015", :pref=>"静岡県", :name=>"静岡市葵区", :type=>"行政区", :district=>"中部地方", :furigana=>"しずおかしあおいく"},
      221023=>{:code=>"221023", :pref=>"静岡県", :name=>"静岡市駿河区", :type=>"行政区", :district=>"中部地方", :furigana=>"しずおかしするがく"},
      221031=>{:code=>"221031", :pref=>"静岡県", :name=>"静岡市清水区", :type=>"行政区", :district=>"中部地方", :furigana=>"しずおかししみずく"},
      221309=>{:code=>"221309", :pref=>"静岡県", :name=>"浜松市", :type=>"政令市", :district=>"中部地方", :furigana=>"はままつし"},
      221317=>{:code=>"221317", :pref=>"静岡県", :name=>"浜松市中区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしなかく"},
      221325=>{:code=>"221325", :pref=>"静岡県", :name=>"浜松市東区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしひがしく"},
      221333=>{:code=>"221333", :pref=>"静岡県", :name=>"浜松市西区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしにしく"},
      221341=>{:code=>"221341", :pref=>"静岡県", :name=>"浜松市南区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしみなみく"},
      221350=>{:code=>"221350", :pref=>"静岡県", :name=>"浜松市北区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしきたく"},
      221368=>{:code=>"221368", :pref=>"静岡県", :name=>"浜松市浜北区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしはまきたく"},
      221376=>{:code=>"221376", :pref=>"静岡県", :name=>"浜松市天竜区", :type=>"行政区", :district=>"中部地方", :furigana=>"はままつしてんりゅうく"},
      222038=>{:code=>"222038", :pref=>"静岡県", :name=>"沼津市", :type=>"市", :district=>"中部地方", :furigana=>"ぬまづし"},
      222054=>{:code=>"222054", :pref=>"静岡県", :name=>"熱海市", :type=>"市", :district=>"中部地方", :furigana=>"あたみし"},
      222062=>{:code=>"222062", :pref=>"静岡県", :name=>"三島市", :type=>"市", :district=>"中部地方", :furigana=>"みしまし"},
      222071=>{:code=>"222071", :pref=>"静岡県", :name=>"富士宮市", :type=>"市", :district=>"中部地方", :furigana=>"ふじのみやし"},
      222089=>{:code=>"222089", :pref=>"静岡県", :name=>"伊東市", :type=>"市", :district=>"中部地方", :furigana=>"いとうし"},
      222097=>{:code=>"222097", :pref=>"静岡県", :name=>"島田市", :type=>"市", :district=>"中部地方", :furigana=>"しまだし"},
      222101=>{:code=>"222101", :pref=>"静岡県", :name=>"富士市", :type=>"市", :district=>"中部地方", :furigana=>"ふじし"},
      222119=>{:code=>"222119", :pref=>"静岡県", :name=>"磐田市", :type=>"市", :district=>"中部地方", :furigana=>"いわたし"},
      222127=>{:code=>"222127", :pref=>"静岡県", :name=>"焼津市", :type=>"市", :district=>"中部地方", :furigana=>"やいづし"},
      222135=>{:code=>"222135", :pref=>"静岡県", :name=>"掛川市", :type=>"市", :district=>"中部地方", :furigana=>"かけがわし"},
      222143=>{:code=>"222143", :pref=>"静岡県", :name=>"藤枝市", :type=>"市", :district=>"中部地方", :furigana=>"ふじえだし"},
      222151=>{:code=>"222151", :pref=>"静岡県", :name=>"御殿場市", :type=>"市", :district=>"中部地方", :furigana=>"ごてんばし"},
      222160=>{:code=>"222160", :pref=>"静岡県", :name=>"袋井市", :type=>"市", :district=>"中部地方", :furigana=>"ふくろいし"},
      222194=>{:code=>"222194", :pref=>"静岡県", :name=>"下田市", :type=>"市", :district=>"中部地方", :furigana=>"しもだし"},
      222208=>{:code=>"222208", :pref=>"静岡県", :name=>"裾野市", :type=>"市", :district=>"中部地方", :furigana=>"すそのし"},
      222216=>{:code=>"222216", :pref=>"静岡県", :name=>"湖西市", :type=>"市", :district=>"中部地方", :furigana=>"こさいし"},
      222224=>{:code=>"222224", :pref=>"静岡県", :name=>"伊豆市", :type=>"市", :district=>"中部地方", :furigana=>"いずし"},
      222232=>{:code=>"222232", :pref=>"静岡県", :name=>"御前崎市", :type=>"市", :district=>"中部地方", :furigana=>"おまえざきし"},
      222241=>{:code=>"222241", :pref=>"静岡県", :name=>"菊川市", :type=>"市", :district=>"中部地方", :furigana=>"きくがわし"},
      222259=>{:code=>"222259", :pref=>"静岡県", :name=>"伊豆の国市", :type=>"市", :district=>"中部地方", :furigana=>"いずのくにし"},
      222267=>{:code=>"222267", :pref=>"静岡県", :name=>"牧之原市", :type=>"市", :district=>"中部地方", :furigana=>"まきのはらし"},
      223018=>{:code=>"223018", :pref=>"静岡県", :name=>"東伊豆町", :type=>"町", :district=>"中部地方", :furigana=>"ひがしいずちょう"},
      223026=>{:code=>"223026", :pref=>"静岡県", :name=>"河津町", :type=>"町", :district=>"中部地方", :furigana=>"かわづちょう"},
      223042=>{:code=>"223042", :pref=>"静岡県", :name=>"南伊豆町", :type=>"町", :district=>"中部地方", :furigana=>"みなみいずちょう"},
      223051=>{:code=>"223051", :pref=>"静岡県", :name=>"松崎町", :type=>"町", :district=>"中部地方", :furigana=>"まつざきちょう"},
      223069=>{:code=>"223069", :pref=>"静岡県", :name=>"西伊豆町", :type=>"町", :district=>"中部地方", :furigana=>"にしいずちょう"},
      223255=>{:code=>"223255", :pref=>"静岡県", :name=>"函南町", :type=>"町", :district=>"中部地方", :furigana=>"かんなみちょう"},
      223417=>{:code=>"223417", :pref=>"静岡県", :name=>"清水町", :type=>"町", :district=>"中部地方", :furigana=>"しみずちょう"},
      223425=>{:code=>"223425", :pref=>"静岡県", :name=>"長泉町", :type=>"町", :district=>"中部地方", :furigana=>"ながいずみちょう"},
      223441=>{:code=>"223441", :pref=>"静岡県", :name=>"小山町", :type=>"町", :district=>"中部地方", :furigana=>"おやまちょう"},
      224243=>{:code=>"224243", :pref=>"静岡県", :name=>"吉田町", :type=>"町", :district=>"中部地方", :furigana=>"よしだちょう"},
      224294=>{:code=>"224294", :pref=>"静岡県", :name=>"川根本町", :type=>"町", :district=>"中部地方", :furigana=>"かわねほんちょう"},
      224618=>{:code=>"224618", :pref=>"静岡県", :name=>"森町", :type=>"町", :district=>"中部地方", :furigana=>"もりまち"},
      230006=>{:code=>"230006", :pref=>"愛知県", :name=>"愛知県", :type=>"都道府県", :district=>"中部地方", :furigana=>"あいちけん"},
      231002=>{:code=>"231002", :pref=>"愛知県", :name=>"名古屋市", :type=>"政令市", :district=>"中部地方", :furigana=>"なごやし"},
      231011=>{:code=>"231011", :pref=>"愛知県", :name=>"名古屋市千種区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしちくさく"},
      231029=>{:code=>"231029", :pref=>"愛知県", :name=>"名古屋市東区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしひがしく"},
      231037=>{:code=>"231037", :pref=>"愛知県", :name=>"名古屋市北区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしきたく"},
      231045=>{:code=>"231045", :pref=>"愛知県", :name=>"名古屋市西区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしにしく"},
      231053=>{:code=>"231053", :pref=>"愛知県", :name=>"名古屋市中村区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしなかむらく"},
      231061=>{:code=>"231061", :pref=>"愛知県", :name=>"名古屋市中区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしなかく"},
      231070=>{:code=>"231070", :pref=>"愛知県", :name=>"名古屋市昭和区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやししょうわく"},
      231088=>{:code=>"231088", :pref=>"愛知県", :name=>"名古屋市瑞穂区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしみずほく"},
      231096=>{:code=>"231096", :pref=>"愛知県", :name=>"名古屋市熱田区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしあつたく"},
      231100=>{:code=>"231100", :pref=>"愛知県", :name=>"名古屋市中川区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしなかがわく"},
      231118=>{:code=>"231118", :pref=>"愛知県", :name=>"名古屋市港区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしみなとく"},
      231126=>{:code=>"231126", :pref=>"愛知県", :name=>"名古屋市南区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしみなみく"},
      231134=>{:code=>"231134", :pref=>"愛知県", :name=>"名古屋市守山区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしもりやまく"},
      231142=>{:code=>"231142", :pref=>"愛知県", :name=>"名古屋市緑区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしみどりく"},
      231151=>{:code=>"231151", :pref=>"愛知県", :name=>"名古屋市名東区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしめいとうく"},
      231169=>{:code=>"231169", :pref=>"愛知県", :name=>"名古屋市天白区", :type=>"行政区", :district=>"中部地方", :furigana=>"なごやしてんぱくく"},
      232017=>{:code=>"232017", :pref=>"愛知県", :name=>"豊橋市", :type=>"市", :district=>"中部地方", :furigana=>"とよはしし"},
      232025=>{:code=>"232025", :pref=>"愛知県", :name=>"岡崎市", :type=>"市", :district=>"中部地方", :furigana=>"おかざきし"},
      232033=>{:code=>"232033", :pref=>"愛知県", :name=>"一宮市", :type=>"市", :district=>"中部地方", :furigana=>"いちのみやし"},
      232041=>{:code=>"232041", :pref=>"愛知県", :name=>"瀬戸市", :type=>"市", :district=>"中部地方", :furigana=>"せとし"},
      232050=>{:code=>"232050", :pref=>"愛知県", :name=>"半田市", :type=>"市", :district=>"中部地方", :furigana=>"はんだし"},
      232068=>{:code=>"232068", :pref=>"愛知県", :name=>"春日井市", :type=>"市", :district=>"中部地方", :furigana=>"かすがいし"},
      232076=>{:code=>"232076", :pref=>"愛知県", :name=>"豊川市", :type=>"市", :district=>"中部地方", :furigana=>"とよかわし"},
      232084=>{:code=>"232084", :pref=>"愛知県", :name=>"津島市", :type=>"市", :district=>"中部地方", :furigana=>"つしまし"},
      232092=>{:code=>"232092", :pref=>"愛知県", :name=>"碧南市", :type=>"市", :district=>"中部地方", :furigana=>"へきなんし"},
      232106=>{:code=>"232106", :pref=>"愛知県", :name=>"刈谷市", :type=>"市", :district=>"中部地方", :furigana=>"かりやし"},
      232114=>{:code=>"232114", :pref=>"愛知県", :name=>"豊田市", :type=>"市", :district=>"中部地方", :furigana=>"とよたし"},
      232122=>{:code=>"232122", :pref=>"愛知県", :name=>"安城市", :type=>"市", :district=>"中部地方", :furigana=>"あんじょうし"},
      232131=>{:code=>"232131", :pref=>"愛知県", :name=>"西尾市", :type=>"市", :district=>"中部地方", :furigana=>"にしおし"},
      232149=>{:code=>"232149", :pref=>"愛知県", :name=>"蒲郡市", :type=>"市", :district=>"中部地方", :furigana=>"がまごおりし"},
      232157=>{:code=>"232157", :pref=>"愛知県", :name=>"犬山市", :type=>"市", :district=>"中部地方", :furigana=>"いぬやまし"},
      232165=>{:code=>"232165", :pref=>"愛知県", :name=>"常滑市", :type=>"市", :district=>"中部地方", :furigana=>"とこなめし"},
      232173=>{:code=>"232173", :pref=>"愛知県", :name=>"江南市", :type=>"市", :district=>"中部地方", :furigana=>"こうなんし"},
      232190=>{:code=>"232190", :pref=>"愛知県", :name=>"小牧市", :type=>"市", :district=>"中部地方", :furigana=>"こまきし"},
      232203=>{:code=>"232203", :pref=>"愛知県", :name=>"稲沢市", :type=>"市", :district=>"中部地方", :furigana=>"いなざわし"},
      232211=>{:code=>"232211", :pref=>"愛知県", :name=>"新城市", :type=>"市", :district=>"中部地方", :furigana=>"しんしろし"},
      232220=>{:code=>"232220", :pref=>"愛知県", :name=>"東海市", :type=>"市", :district=>"中部地方", :furigana=>"とうかいし"},
      232238=>{:code=>"232238", :pref=>"愛知県", :name=>"大府市", :type=>"市", :district=>"中部地方", :furigana=>"おおぶし"},
      232246=>{:code=>"232246", :pref=>"愛知県", :name=>"知多市", :type=>"市", :district=>"中部地方", :furigana=>"ちたし"},
      232254=>{:code=>"232254", :pref=>"愛知県", :name=>"知立市", :type=>"市", :district=>"中部地方", :furigana=>"ちりゅうし"},
      232262=>{:code=>"232262", :pref=>"愛知県", :name=>"尾張旭市", :type=>"市", :district=>"中部地方", :furigana=>"おわりあさひし"},
      232271=>{:code=>"232271", :pref=>"愛知県", :name=>"高浜市", :type=>"市", :district=>"中部地方", :furigana=>"たかはまし"},
      232289=>{:code=>"232289", :pref=>"愛知県", :name=>"岩倉市", :type=>"市", :district=>"中部地方", :furigana=>"いわくらし"},
      232297=>{:code=>"232297", :pref=>"愛知県", :name=>"豊明市", :type=>"市", :district=>"中部地方", :furigana=>"とよあけし"},
      232301=>{:code=>"232301", :pref=>"愛知県", :name=>"日進市", :type=>"市", :district=>"中部地方", :furigana=>"にっしんし"},
      232319=>{:code=>"232319", :pref=>"愛知県", :name=>"田原市", :type=>"市", :district=>"中部地方", :furigana=>"たはらし"},
      232327=>{:code=>"232327", :pref=>"愛知県", :name=>"愛西市", :type=>"市", :district=>"中部地方", :furigana=>"あいさいし"},
      232335=>{:code=>"232335", :pref=>"愛知県", :name=>"清須市", :type=>"市", :district=>"中部地方", :furigana=>"きよすし"},
      232343=>{:code=>"232343", :pref=>"愛知県", :name=>"北名古屋市", :type=>"市", :district=>"中部地方", :furigana=>"きたなごやし"},
      232351=>{:code=>"232351", :pref=>"愛知県", :name=>"弥富市", :type=>"市", :district=>"中部地方", :furigana=>"やとみし"},
      232360=>{:code=>"232360", :pref=>"愛知県", :name=>"みよし市", :type=>"市", :district=>"中部地方", :furigana=>"みよしし"},
      232378=>{:code=>"232378", :pref=>"愛知県", :name=>"あま市", :type=>"市", :district=>"中部地方", :furigana=>"あまし"},
      232386=>{:code=>"232386", :pref=>"愛知県", :name=>"長久手市", :type=>"市", :district=>"中部地方", :furigana=>"ながくてし"},
      233021=>{:code=>"233021", :pref=>"愛知県", :name=>"東郷町", :type=>"町", :district=>"中部地方", :furigana=>"とうごうちょう"},
      233421=>{:code=>"233421", :pref=>"愛知県", :name=>"豊山町", :type=>"町", :district=>"中部地方", :furigana=>"とよやまちょう"},
      233617=>{:code=>"233617", :pref=>"愛知県", :name=>"大口町", :type=>"町", :district=>"中部地方", :furigana=>"おおぐちちょう"},
      233625=>{:code=>"233625", :pref=>"愛知県", :name=>"扶桑町", :type=>"町", :district=>"中部地方", :furigana=>"ふそうちょう"},
      234249=>{:code=>"234249", :pref=>"愛知県", :name=>"大治町", :type=>"町", :district=>"中部地方", :furigana=>"おおはるちょう"},
      234257=>{:code=>"234257", :pref=>"愛知県", :name=>"蟹江町", :type=>"町", :district=>"中部地方", :furigana=>"かにえちょう"},
      234273=>{:code=>"234273", :pref=>"愛知県", :name=>"飛島村", :type=>"村", :district=>"中部地方", :furigana=>"とびしまむら"},
      234419=>{:code=>"234419", :pref=>"愛知県", :name=>"阿久比町", :type=>"町", :district=>"中部地方", :furigana=>"あぐいちょう"},
      234427=>{:code=>"234427", :pref=>"愛知県", :name=>"東浦町", :type=>"町", :district=>"中部地方", :furigana=>"ひがしうらちょう"},
      234451=>{:code=>"234451", :pref=>"愛知県", :name=>"南知多町", :type=>"町", :district=>"中部地方", :furigana=>"みなみちたちょう"},
      234460=>{:code=>"234460", :pref=>"愛知県", :name=>"美浜町", :type=>"町", :district=>"中部地方", :furigana=>"みはまちょう"},
      234478=>{:code=>"234478", :pref=>"愛知県", :name=>"武豊町", :type=>"町", :district=>"中部地方", :furigana=>"たけとよちょう"},
      235016=>{:code=>"235016", :pref=>"愛知県", :name=>"幸田町", :type=>"町", :district=>"中部地方", :furigana=>"こうたちょう"},
      235610=>{:code=>"235610", :pref=>"愛知県", :name=>"設楽町", :type=>"町", :district=>"中部地方", :furigana=>"したらちょう"},
      235628=>{:code=>"235628", :pref=>"愛知県", :name=>"東栄町", :type=>"町", :district=>"中部地方", :furigana=>"とうえいちょう"},
      235636=>{:code=>"235636", :pref=>"愛知県", :name=>"豊根村", :type=>"村", :district=>"中部地方", :furigana=>"とよねむら"},
      240001=>{:code=>"240001", :pref=>"三重県", :name=>"三重県", :type=>"都道府県", :district=>"近畿地方", :furigana=>"みえけん"},
      242012=>{:code=>"242012", :pref=>"三重県", :name=>"津市", :type=>"市", :district=>"近畿地方", :furigana=>"つし"},
      242021=>{:code=>"242021", :pref=>"三重県", :name=>"四日市市", :type=>"市", :district=>"近畿地方", :furigana=>"よっかいちし"},
      242039=>{:code=>"242039", :pref=>"三重県", :name=>"伊勢市", :type=>"市", :district=>"近畿地方", :furigana=>"いせし"},
      242047=>{:code=>"242047", :pref=>"三重県", :name=>"松阪市", :type=>"市", :district=>"近畿地方", :furigana=>"まつさかし"},
      242055=>{:code=>"242055", :pref=>"三重県", :name=>"桑名市", :type=>"市", :district=>"近畿地方", :furigana=>"くわなし"},
      242071=>{:code=>"242071", :pref=>"三重県", :name=>"鈴鹿市", :type=>"市", :district=>"近畿地方", :furigana=>"すずかし"},
      242080=>{:code=>"242080", :pref=>"三重県", :name=>"名張市", :type=>"市", :district=>"近畿地方", :furigana=>"なばりし"},
      242098=>{:code=>"242098", :pref=>"三重県", :name=>"尾鷲市", :type=>"市", :district=>"近畿地方", :furigana=>"おわせし"},
      242101=>{:code=>"242101", :pref=>"三重県", :name=>"亀山市", :type=>"市", :district=>"近畿地方", :furigana=>"かめやまし"},
      242110=>{:code=>"242110", :pref=>"三重県", :name=>"鳥羽市", :type=>"市", :district=>"近畿地方", :furigana=>"とばし"},
      242128=>{:code=>"242128", :pref=>"三重県", :name=>"熊野市", :type=>"市", :district=>"近畿地方", :furigana=>"くまのし"},
      242144=>{:code=>"242144", :pref=>"三重県", :name=>"いなべ市", :type=>"市", :district=>"近畿地方", :furigana=>"いなべし"},
      242152=>{:code=>"242152", :pref=>"三重県", :name=>"志摩市", :type=>"市", :district=>"近畿地方", :furigana=>"しまし"},
      242161=>{:code=>"242161", :pref=>"三重県", :name=>"伊賀市", :type=>"市", :district=>"近畿地方", :furigana=>"いがし"},
      243035=>{:code=>"243035", :pref=>"三重県", :name=>"木曽岬町", :type=>"町", :district=>"近畿地方", :furigana=>"きそさきちょう"},
      243248=>{:code=>"243248", :pref=>"三重県", :name=>"東員町", :type=>"町", :district=>"近畿地方", :furigana=>"とういんちょう"},
      243418=>{:code=>"243418", :pref=>"三重県", :name=>"菰野町", :type=>"町", :district=>"近畿地方", :furigana=>"こものちょう"},
      243434=>{:code=>"243434", :pref=>"三重県", :name=>"朝日町", :type=>"町", :district=>"近畿地方", :furigana=>"あさひちょう"},
      243442=>{:code=>"243442", :pref=>"三重県", :name=>"川越町", :type=>"町", :district=>"近畿地方", :furigana=>"かわごえちょう"},
      244414=>{:code=>"244414", :pref=>"三重県", :name=>"多気町", :type=>"町", :district=>"近畿地方", :furigana=>"たきちょう"},
      244422=>{:code=>"244422", :pref=>"三重県", :name=>"明和町", :type=>"町", :district=>"近畿地方", :furigana=>"めいわちょう"},
      244431=>{:code=>"244431", :pref=>"三重県", :name=>"大台町", :type=>"町", :district=>"近畿地方", :furigana=>"おおだいちょう"},
      244619=>{:code=>"244619", :pref=>"三重県", :name=>"玉城町", :type=>"町", :district=>"近畿地方", :furigana=>"たまきちょう"},
      244708=>{:code=>"244708", :pref=>"三重県", :name=>"度会町", :type=>"町", :district=>"近畿地方", :furigana=>"わたらいちょう"},
      244716=>{:code=>"244716", :pref=>"三重県", :name=>"大紀町", :type=>"町", :district=>"近畿地方", :furigana=>"たいきちょう"},
      244724=>{:code=>"244724", :pref=>"三重県", :name=>"南伊勢町", :type=>"町", :district=>"近畿地方", :furigana=>"みなみいせちょう"},
      245437=>{:code=>"245437", :pref=>"三重県", :name=>"紀北町", :type=>"町", :district=>"近畿地方", :furigana=>"きほくちょう"},
      245615=>{:code=>"245615", :pref=>"三重県", :name=>"御浜町", :type=>"町", :district=>"近畿地方", :furigana=>"みはまちょう"},
      245623=>{:code=>"245623", :pref=>"三重県", :name=>"紀宝町", :type=>"町", :district=>"近畿地方", :furigana=>"きほうちょう"},
      250007=>{:code=>"250007", :pref=>"滋賀県", :name=>"滋賀県", :type=>"都道府県", :district=>"近畿地方", :furigana=>"しがけん"},
      252018=>{:code=>"252018", :pref=>"滋賀県", :name=>"大津市", :type=>"市", :district=>"近畿地方", :furigana=>"おおつし"},
      252026=>{:code=>"252026", :pref=>"滋賀県", :name=>"彦根市", :type=>"市", :district=>"近畿地方", :furigana=>"ひこねし"},
      252034=>{:code=>"252034", :pref=>"滋賀県", :name=>"長浜市", :type=>"市", :district=>"近畿地方", :furigana=>"ながはまし"},
      252042=>{:code=>"252042", :pref=>"滋賀県", :name=>"近江八幡市", :type=>"市", :district=>"近畿地方", :furigana=>"おうみはちまんし"},
      252069=>{:code=>"252069", :pref=>"滋賀県", :name=>"草津市", :type=>"市", :district=>"近畿地方", :furigana=>"くさつし"},
      252077=>{:code=>"252077", :pref=>"滋賀県", :name=>"守山市", :type=>"市", :district=>"近畿地方", :furigana=>"もりやまし"},
      252085=>{:code=>"252085", :pref=>"滋賀県", :name=>"栗東市", :type=>"市", :district=>"近畿地方", :furigana=>"りっとうし"},
      252093=>{:code=>"252093", :pref=>"滋賀県", :name=>"甲賀市", :type=>"市", :district=>"近畿地方", :furigana=>"こうかし"},
      252107=>{:code=>"252107", :pref=>"滋賀県", :name=>"野洲市", :type=>"市", :district=>"近畿地方", :furigana=>"やすし"},
      252115=>{:code=>"252115", :pref=>"滋賀県", :name=>"湖南市", :type=>"市", :district=>"近畿地方", :furigana=>"こなんし"},
      252123=>{:code=>"252123", :pref=>"滋賀県", :name=>"高島市", :type=>"市", :district=>"近畿地方", :furigana=>"たかしまし"},
      252131=>{:code=>"252131", :pref=>"滋賀県", :name=>"東近江市", :type=>"市", :district=>"近畿地方", :furigana=>"ひがしおうみし"},
      252140=>{:code=>"252140", :pref=>"滋賀県", :name=>"米原市", :type=>"市", :district=>"近畿地方", :furigana=>"まいばらし"},
      253839=>{:code=>"253839", :pref=>"滋賀県", :name=>"日野町", :type=>"町", :district=>"近畿地方", :furigana=>"ひのちょう"},
      253847=>{:code=>"253847", :pref=>"滋賀県", :name=>"竜王町", :type=>"町", :district=>"近畿地方", :furigana=>"りゆうおうちょう"},
      254258=>{:code=>"254258", :pref=>"滋賀県", :name=>"愛荘町", :type=>"町", :district=>"近畿地方", :furigana=>"あいしょうちょう"},
      254410=>{:code=>"254410", :pref=>"滋賀県", :name=>"豊郷町", :type=>"町", :district=>"近畿地方", :furigana=>"とよさとちょう"},
      254428=>{:code=>"254428", :pref=>"滋賀県", :name=>"甲良町", :type=>"町", :district=>"近畿地方", :furigana=>"こうらちょう"},
      254436=>{:code=>"254436", :pref=>"滋賀県", :name=>"多賀町", :type=>"町", :district=>"近畿地方", :furigana=>"たがちょう"},
      260002=>{:code=>"260002", :pref=>"京都府", :name=>"京都府", :type=>"都道府県", :district=>"近畿地方", :furigana=>"きょうとふ"},
      261009=>{:code=>"261009", :pref=>"京都府", :name=>"京都市", :type=>"政令市", :district=>"近畿地方", :furigana=>"きょうとし"},
      261017=>{:code=>"261017", :pref=>"京都府", :name=>"京都市北区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしきたく"},
      261025=>{:code=>"261025", :pref=>"京都府", :name=>"京都市上京区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしかみぎょうく"},
      261033=>{:code=>"261033", :pref=>"京都府", :name=>"京都市左京区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしさきょうく"},
      261041=>{:code=>"261041", :pref=>"京都府", :name=>"京都市中京区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしなかぎょうく"},
      261050=>{:code=>"261050", :pref=>"京都府", :name=>"京都市東山区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしひがしやまく"},
      261068=>{:code=>"261068", :pref=>"京都府", :name=>"京都市下京区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとししもぎょうく"},
      261076=>{:code=>"261076", :pref=>"京都府", :name=>"京都市南区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしみなみく"},
      261084=>{:code=>"261084", :pref=>"京都府", :name=>"京都市右京区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしうきょうく"},
      261092=>{:code=>"261092", :pref=>"京都府", :name=>"京都市伏見区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしふしみく"},
      261106=>{:code=>"261106", :pref=>"京都府", :name=>"京都市山科区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしやましなく"},
      261114=>{:code=>"261114", :pref=>"京都府", :name=>"京都市西京区", :type=>"行政区", :district=>"近畿地方", :furigana=>"きょうとしにしきょうく"},
      262013=>{:code=>"262013", :pref=>"京都府", :name=>"福知山市", :type=>"市", :district=>"近畿地方", :furigana=>"ふくちやまし"},
      262021=>{:code=>"262021", :pref=>"京都府", :name=>"舞鶴市", :type=>"市", :district=>"近畿地方", :furigana=>"まいづるし"},
      262030=>{:code=>"262030", :pref=>"京都府", :name=>"綾部市", :type=>"市", :district=>"近畿地方", :furigana=>"あやべし"},
      262048=>{:code=>"262048", :pref=>"京都府", :name=>"宇治市", :type=>"市", :district=>"近畿地方", :furigana=>"うじし"},
      262056=>{:code=>"262056", :pref=>"京都府", :name=>"宮津市", :type=>"市", :district=>"近畿地方", :furigana=>"みやづし"},
      262064=>{:code=>"262064", :pref=>"京都府", :name=>"亀岡市", :type=>"市", :district=>"近畿地方", :furigana=>"かめおかし"},
      262072=>{:code=>"262072", :pref=>"京都府", :name=>"城陽市", :type=>"市", :district=>"近畿地方", :furigana=>"じょうようし"},
      262081=>{:code=>"262081", :pref=>"京都府", :name=>"向日市", :type=>"市", :district=>"近畿地方", :furigana=>"むこうし"},
      262099=>{:code=>"262099", :pref=>"京都府", :name=>"長岡京市", :type=>"市", :district=>"近畿地方", :furigana=>"ながおかきょうし"},
      262102=>{:code=>"262102", :pref=>"京都府", :name=>"八幡市", :type=>"市", :district=>"近畿地方", :furigana=>"やわたし"},
      262111=>{:code=>"262111", :pref=>"京都府", :name=>"京田辺市", :type=>"市", :district=>"近畿地方", :furigana=>"きょうたなべし"},
      262129=>{:code=>"262129", :pref=>"京都府", :name=>"京丹後市", :type=>"市", :district=>"近畿地方", :furigana=>"きょうたんごし"},
      262137=>{:code=>"262137", :pref=>"京都府", :name=>"南丹市", :type=>"市", :district=>"近畿地方", :furigana=>"なんたんし"},
      262145=>{:code=>"262145", :pref=>"京都府", :name=>"木津川市", :type=>"市", :district=>"近畿地方", :furigana=>"きづがわし"},
      263036=>{:code=>"263036", :pref=>"京都府", :name=>"大山崎町", :type=>"町", :district=>"近畿地方", :furigana=>"おおやまざきちょう"},
      263222=>{:code=>"263222", :pref=>"京都府", :name=>"久御山町", :type=>"町", :district=>"近畿地方", :furigana=>"くみやまちょう"},
      263435=>{:code=>"263435", :pref=>"京都府", :name=>"井手町", :type=>"町", :district=>"近畿地方", :furigana=>"いでちょう"},
      263443=>{:code=>"263443", :pref=>"京都府", :name=>"宇治田原町", :type=>"町", :district=>"近畿地方", :furigana=>"うじたわらちょう"},
      263648=>{:code=>"263648", :pref=>"京都府", :name=>"笠置町", :type=>"町", :district=>"近畿地方", :furigana=>"かさぎちょう"},
      263656=>{:code=>"263656", :pref=>"京都府", :name=>"和束町", :type=>"町", :district=>"近畿地方", :furigana=>"わづかちょう"},
      263664=>{:code=>"263664", :pref=>"京都府", :name=>"精華町", :type=>"町", :district=>"近畿地方", :furigana=>"せいかちょう"},
      263672=>{:code=>"263672", :pref=>"京都府", :name=>"南山城村", :type=>"村", :district=>"近畿地方", :furigana=>"みなみやましろむら"},
      264075=>{:code=>"264075", :pref=>"京都府", :name=>"京丹波町", :type=>"町", :district=>"近畿地方", :furigana=>"きょうたんばちょう"},
      264636=>{:code=>"264636", :pref=>"京都府", :name=>"伊根町", :type=>"町", :district=>"近畿地方", :furigana=>"いねちょう"},
      264652=>{:code=>"264652", :pref=>"京都府", :name=>"与謝野町", :type=>"町", :district=>"近畿地方", :furigana=>"よさのちょう"},
      270008=>{:code=>"270008", :pref=>"大阪府", :name=>"大阪府", :type=>"都道府県", :district=>"近畿地方", :furigana=>"おおさかふ"},
      271004=>{:code=>"271004", :pref=>"大阪府", :name=>"大阪市", :type=>"政令市", :district=>"近畿地方", :furigana=>"おおさかし"},
      271021=>{:code=>"271021", :pref=>"大阪府", :name=>"大阪市都島区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしみやこじまく"},
      271039=>{:code=>"271039", :pref=>"大阪府", :name=>"大阪市福島区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしふくしまく"},
      271047=>{:code=>"271047", :pref=>"大阪府", :name=>"大阪市此花区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしこのはなく"},
      271063=>{:code=>"271063", :pref=>"大阪府", :name=>"大阪市西区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしにしく"},
      271071=>{:code=>"271071", :pref=>"大阪府", :name=>"大阪市港区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしみなとく"},
      271080=>{:code=>"271080", :pref=>"大阪府", :name=>"大阪市大正区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしたいしょうく"},
      271098=>{:code=>"271098", :pref=>"大阪府", :name=>"大阪市天王寺区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしてんのうじく"},
      271110=>{:code=>"271110", :pref=>"大阪府", :name=>"大阪市浪速区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしなにわく"},
      271136=>{:code=>"271136", :pref=>"大阪府", :name=>"大阪市西淀川区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしにしよどがわく"},
      271144=>{:code=>"271144", :pref=>"大阪府", :name=>"大阪市東淀川区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしひがしよどがわく"},
      271152=>{:code=>"271152", :pref=>"大阪府", :name=>"大阪市東成区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしひがしなりく"},
      271161=>{:code=>"271161", :pref=>"大阪府", :name=>"大阪市生野区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしいくのく"},
      271179=>{:code=>"271179", :pref=>"大阪府", :name=>"大阪市旭区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしあさひく"},
      271187=>{:code=>"271187", :pref=>"大阪府", :name=>"大阪市城東区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしじょうとうく"},
      271195=>{:code=>"271195", :pref=>"大阪府", :name=>"大阪市阿倍野区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしあべのく"},
      271209=>{:code=>"271209", :pref=>"大阪府", :name=>"大阪市住吉区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしすみよしく"},
      271217=>{:code=>"271217", :pref=>"大阪府", :name=>"大阪市東住吉区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしひがしすみよしく"},
      271225=>{:code=>"271225", :pref=>"大阪府", :name=>"大阪市西成区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしにしなりく"},
      271233=>{:code=>"271233", :pref=>"大阪府", :name=>"大阪市淀川区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしよどがわく"},
      271241=>{:code=>"271241", :pref=>"大阪府", :name=>"大阪市鶴見区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしつるみく"},
      271250=>{:code=>"271250", :pref=>"大阪府", :name=>"大阪市住之江区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしすみのえく"},
      271268=>{:code=>"271268", :pref=>"大阪府", :name=>"大阪市平野区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしひらのく"},
      271276=>{:code=>"271276", :pref=>"大阪府", :name=>"大阪市北区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしきたく"},
      271284=>{:code=>"271284", :pref=>"大阪府", :name=>"大阪市中央区", :type=>"行政区", :district=>"近畿地方", :furigana=>"おおさかしちゅうおうく"},
      271403=>{:code=>"271403", :pref=>"大阪府", :name=>"堺市", :type=>"政令市", :district=>"近畿地方", :furigana=>"さかいし"},
      271411=>{:code=>"271411", :pref=>"大阪府", :name=>"堺市堺区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしさかいく"},
      271420=>{:code=>"271420", :pref=>"大阪府", :name=>"堺市中区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしなかく"},
      271438=>{:code=>"271438", :pref=>"大阪府", :name=>"堺市東区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしひがしく"},
      271446=>{:code=>"271446", :pref=>"大阪府", :name=>"堺市西区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしにしく"},
      271454=>{:code=>"271454", :pref=>"大阪府", :name=>"堺市南区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしみなみく"},
      271462=>{:code=>"271462", :pref=>"大阪府", :name=>"堺市北区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしきたく"},
      271471=>{:code=>"271471", :pref=>"大阪府", :name=>"堺市美原区", :type=>"行政区", :district=>"近畿地方", :furigana=>"さかいしみはらく"},
      272027=>{:code=>"272027", :pref=>"大阪府", :name=>"岸和田市", :type=>"市", :district=>"近畿地方", :furigana=>"きしわだし"},
      272035=>{:code=>"272035", :pref=>"大阪府", :name=>"豊中市", :type=>"市", :district=>"近畿地方", :furigana=>"とよなかし"},
      272043=>{:code=>"272043", :pref=>"大阪府", :name=>"池田市", :type=>"市", :district=>"近畿地方", :furigana=>"いけだし"},
      272051=>{:code=>"272051", :pref=>"大阪府", :name=>"吹田市", :type=>"市", :district=>"近畿地方", :furigana=>"すいたし"},
      272060=>{:code=>"272060", :pref=>"大阪府", :name=>"泉大津市", :type=>"市", :district=>"近畿地方", :furigana=>"いずみおおつし"},
      272078=>{:code=>"272078", :pref=>"大阪府", :name=>"高槻市", :type=>"市", :district=>"近畿地方", :furigana=>"たかつきし"},
      272086=>{:code=>"272086", :pref=>"大阪府", :name=>"貝塚市", :type=>"市", :district=>"近畿地方", :furigana=>"かいづかし"},
      272094=>{:code=>"272094", :pref=>"大阪府", :name=>"守口市", :type=>"市", :district=>"近畿地方", :furigana=>"もりぐちし"},
      272108=>{:code=>"272108", :pref=>"大阪府", :name=>"枚方市", :type=>"市", :district=>"近畿地方", :furigana=>"ひらかたし"},
      272116=>{:code=>"272116", :pref=>"大阪府", :name=>"茨木市", :type=>"市", :district=>"近畿地方", :furigana=>"いばらきし"},
      272124=>{:code=>"272124", :pref=>"大阪府", :name=>"八尾市", :type=>"市", :district=>"近畿地方", :furigana=>"やおし"},
      272132=>{:code=>"272132", :pref=>"大阪府", :name=>"泉佐野市", :type=>"市", :district=>"近畿地方", :furigana=>"いずみさのし"},
      272141=>{:code=>"272141", :pref=>"大阪府", :name=>"富田林市", :type=>"市", :district=>"近畿地方", :furigana=>"とんだばやしし"},
      272159=>{:code=>"272159", :pref=>"大阪府", :name=>"寝屋川市", :type=>"市", :district=>"近畿地方", :furigana=>"ねやがわし"},
      272167=>{:code=>"272167", :pref=>"大阪府", :name=>"河内長野市", :type=>"市", :district=>"近畿地方", :furigana=>"かわちながのし"},
      272175=>{:code=>"272175", :pref=>"大阪府", :name=>"松原市", :type=>"市", :district=>"近畿地方", :furigana=>"まつばらし"},
      272183=>{:code=>"272183", :pref=>"大阪府", :name=>"大東市", :type=>"市", :district=>"近畿地方", :furigana=>"だいとうし"},
      272191=>{:code=>"272191", :pref=>"大阪府", :name=>"和泉市", :type=>"市", :district=>"近畿地方", :furigana=>"いずみし"},
      272205=>{:code=>"272205", :pref=>"大阪府", :name=>"箕面市", :type=>"市", :district=>"近畿地方", :furigana=>"みのおし"},
      272213=>{:code=>"272213", :pref=>"大阪府", :name=>"柏原市", :type=>"市", :district=>"近畿地方", :furigana=>"かしわらし"},
      272221=>{:code=>"272221", :pref=>"大阪府", :name=>"羽曳野市", :type=>"市", :district=>"近畿地方", :furigana=>"はびきのし"},
      272230=>{:code=>"272230", :pref=>"大阪府", :name=>"門真市", :type=>"市", :district=>"近畿地方", :furigana=>"かどまし"},
      272248=>{:code=>"272248", :pref=>"大阪府", :name=>"摂津市", :type=>"市", :district=>"近畿地方", :furigana=>"せっつし"},
      272256=>{:code=>"272256", :pref=>"大阪府", :name=>"高石市", :type=>"市", :district=>"近畿地方", :furigana=>"たかいしし"},
      272264=>{:code=>"272264", :pref=>"大阪府", :name=>"藤井寺市", :type=>"市", :district=>"近畿地方", :furigana=>"ふじいでらし"},
      272272=>{:code=>"272272", :pref=>"大阪府", :name=>"東大阪市", :type=>"市", :district=>"近畿地方", :furigana=>"ひがしおおさかし"},
      272281=>{:code=>"272281", :pref=>"大阪府", :name=>"泉南市", :type=>"市", :district=>"近畿地方", :furigana=>"せんなんし"},
      272299=>{:code=>"272299", :pref=>"大阪府", :name=>"四條畷市", :type=>"市", :district=>"近畿地方", :furigana=>"しじようなわてし"},
      272302=>{:code=>"272302", :pref=>"大阪府", :name=>"交野市", :type=>"市", :district=>"近畿地方", :furigana=>"かたのし"},
      272311=>{:code=>"272311", :pref=>"大阪府", :name=>"大阪狭山市", :type=>"市", :district=>"近畿地方", :furigana=>"おおさかさやまし"},
      272329=>{:code=>"272329", :pref=>"大阪府", :name=>"阪南市", :type=>"市", :district=>"近畿地方", :furigana=>"はんなんし"},
      273015=>{:code=>"273015", :pref=>"大阪府", :name=>"島本町", :type=>"町", :district=>"近畿地方", :furigana=>"しまもとちょう"},
      273210=>{:code=>"273210", :pref=>"大阪府", :name=>"豊能町", :type=>"町", :district=>"近畿地方", :furigana=>"とよのちょう"},
      273228=>{:code=>"273228", :pref=>"大阪府", :name=>"能勢町", :type=>"町", :district=>"近畿地方", :furigana=>"のせちょう"},
      273414=>{:code=>"273414", :pref=>"大阪府", :name=>"忠岡町", :type=>"町", :district=>"近畿地方", :furigana=>"ただおかちょう"},
      273619=>{:code=>"273619", :pref=>"大阪府", :name=>"熊取町", :type=>"町", :district=>"近畿地方", :furigana=>"くまとりちょう"},
      273627=>{:code=>"273627", :pref=>"大阪府", :name=>"田尻町", :type=>"町", :district=>"近畿地方", :furigana=>"たじりちょう"},
      273660=>{:code=>"273660", :pref=>"大阪府", :name=>"岬町", :type=>"町", :district=>"近畿地方", :furigana=>"みさきちょう"},
      273813=>{:code=>"273813", :pref=>"大阪府", :name=>"太子町", :type=>"町", :district=>"近畿地方", :furigana=>"たいしちょう"},
      273821=>{:code=>"273821", :pref=>"大阪府", :name=>"河南町", :type=>"町", :district=>"近畿地方", :furigana=>"かなんちょう"},
      273830=>{:code=>"273830", :pref=>"大阪府", :name=>"千早赤阪村", :type=>"村", :district=>"近畿地方", :furigana=>"ちはやあかさかむら"},
      280003=>{:code=>"280003", :pref=>"兵庫県", :name=>"兵庫県", :type=>"都道府県", :district=>"近畿地方", :furigana=>"ひょうごけん"},
      281000=>{:code=>"281000", :pref=>"兵庫県", :name=>"神戸市", :type=>"政令市", :district=>"近畿地方", :furigana=>"こうべし"},
      281018=>{:code=>"281018", :pref=>"兵庫県", :name=>"神戸市東灘区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしひがしなだく"},
      281026=>{:code=>"281026", :pref=>"兵庫県", :name=>"神戸市灘区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしなだく"},
      281051=>{:code=>"281051", :pref=>"兵庫県", :name=>"神戸市兵庫区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしひょうごく"},
      281069=>{:code=>"281069", :pref=>"兵庫県", :name=>"神戸市長田区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしながたく"},
      281077=>{:code=>"281077", :pref=>"兵庫県", :name=>"神戸市須磨区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしすまく"},
      281085=>{:code=>"281085", :pref=>"兵庫県", :name=>"神戸市垂水区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしたるみく"},
      281093=>{:code=>"281093", :pref=>"兵庫県", :name=>"神戸市北区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしきたく"},
      281107=>{:code=>"281107", :pref=>"兵庫県", :name=>"神戸市中央区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしちゅうおうく"},
      281115=>{:code=>"281115", :pref=>"兵庫県", :name=>"神戸市西区", :type=>"行政区", :district=>"近畿地方", :furigana=>"こうべしにしく"},
      282014=>{:code=>"282014", :pref=>"兵庫県", :name=>"姫路市", :type=>"市", :district=>"近畿地方", :furigana=>"ひめじし"},
      282022=>{:code=>"282022", :pref=>"兵庫県", :name=>"尼崎市", :type=>"市", :district=>"近畿地方", :furigana=>"あまがさきし"},
      282031=>{:code=>"282031", :pref=>"兵庫県", :name=>"明石市", :type=>"市", :district=>"近畿地方", :furigana=>"あかしし"},
      282049=>{:code=>"282049", :pref=>"兵庫県", :name=>"西宮市", :type=>"市", :district=>"近畿地方", :furigana=>"にしのみやし"},
      282057=>{:code=>"282057", :pref=>"兵庫県", :name=>"洲本市", :type=>"市", :district=>"近畿地方", :furigana=>"すもとし"},
      282065=>{:code=>"282065", :pref=>"兵庫県", :name=>"芦屋市", :type=>"市", :district=>"近畿地方", :furigana=>"あしやし"},
      282073=>{:code=>"282073", :pref=>"兵庫県", :name=>"伊丹市", :type=>"市", :district=>"近畿地方", :furigana=>"いたみし"},
      282081=>{:code=>"282081", :pref=>"兵庫県", :name=>"相生市", :type=>"市", :district=>"近畿地方", :furigana=>"あいおいし"},
      282090=>{:code=>"282090", :pref=>"兵庫県", :name=>"豊岡市", :type=>"市", :district=>"近畿地方", :furigana=>"とよおかし"},
      282103=>{:code=>"282103", :pref=>"兵庫県", :name=>"加古川市", :type=>"市", :district=>"近畿地方", :furigana=>"かこがわし"},
      282120=>{:code=>"282120", :pref=>"兵庫県", :name=>"赤穂市", :type=>"市", :district=>"近畿地方", :furigana=>"あこうし"},
      282138=>{:code=>"282138", :pref=>"兵庫県", :name=>"西脇市", :type=>"市", :district=>"近畿地方", :furigana=>"にしわきし"},
      282146=>{:code=>"282146", :pref=>"兵庫県", :name=>"宝塚市", :type=>"市", :district=>"近畿地方", :furigana=>"たからづかし"},
      282154=>{:code=>"282154", :pref=>"兵庫県", :name=>"三木市", :type=>"市", :district=>"近畿地方", :furigana=>"みきし"},
      282162=>{:code=>"282162", :pref=>"兵庫県", :name=>"高砂市", :type=>"市", :district=>"近畿地方", :furigana=>"たかさごし"},
      282171=>{:code=>"282171", :pref=>"兵庫県", :name=>"川西市", :type=>"市", :district=>"近畿地方", :furigana=>"かわにしし"},
      282189=>{:code=>"282189", :pref=>"兵庫県", :name=>"小野市", :type=>"市", :district=>"近畿地方", :furigana=>"おのし"},
      282197=>{:code=>"282197", :pref=>"兵庫県", :name=>"三田市", :type=>"市", :district=>"近畿地方", :furigana=>"さんだし"},
      282201=>{:code=>"282201", :pref=>"兵庫県", :name=>"加西市", :type=>"市", :district=>"近畿地方", :furigana=>"かさいし"},
      282219=>{:code=>"282219", :pref=>"兵庫県", :name=>"篠山市", :type=>"市", :district=>"近畿地方", :furigana=>"ささやまし"},
      282227=>{:code=>"282227", :pref=>"兵庫県", :name=>"養父市", :type=>"市", :district=>"近畿地方", :furigana=>"やぶし"},
      282235=>{:code=>"282235", :pref=>"兵庫県", :name=>"丹波市", :type=>"市", :district=>"近畿地方", :furigana=>"たんばし"},
      282243=>{:code=>"282243", :pref=>"兵庫県", :name=>"南あわじ市", :type=>"市", :district=>"近畿地方", :furigana=>"みなみあわじし"},
      282251=>{:code=>"282251", :pref=>"兵庫県", :name=>"朝来市", :type=>"市", :district=>"近畿地方", :furigana=>"あさごし"},
      282260=>{:code=>"282260", :pref=>"兵庫県", :name=>"淡路市", :type=>"市", :district=>"近畿地方", :furigana=>"あわじし"},
      282278=>{:code=>"282278", :pref=>"兵庫県", :name=>"宍粟市", :type=>"市", :district=>"近畿地方", :furigana=>"しそうし"},
      282286=>{:code=>"282286", :pref=>"兵庫県", :name=>"加東市", :type=>"市", :district=>"近畿地方", :furigana=>"かとうし"},
      282294=>{:code=>"282294", :pref=>"兵庫県", :name=>"たつの市", :type=>"市", :district=>"近畿地方", :furigana=>"たつのし"},
      283011=>{:code=>"283011", :pref=>"兵庫県", :name=>"猪名川町", :type=>"町", :district=>"近畿地方", :furigana=>"いながわちょう"},
      283657=>{:code=>"283657", :pref=>"兵庫県", :name=>"多可町", :type=>"町", :district=>"近畿地方", :furigana=>"たかちょう"},
      283819=>{:code=>"283819", :pref=>"兵庫県", :name=>"稲美町", :type=>"町", :district=>"近畿地方", :furigana=>"いなみちょう"},
      283827=>{:code=>"283827", :pref=>"兵庫県", :name=>"播磨町", :type=>"町", :district=>"近畿地方", :furigana=>"はりまちょう"},
      284424=>{:code=>"284424", :pref=>"兵庫県", :name=>"市川町", :type=>"町", :district=>"近畿地方", :furigana=>"いちかわちょう"},
      284432=>{:code=>"284432", :pref=>"兵庫県", :name=>"福崎町", :type=>"町", :district=>"近畿地方", :furigana=>"ふくさきちょう"},
      284467=>{:code=>"284467", :pref=>"兵庫県", :name=>"神河町", :type=>"町", :district=>"近畿地方", :furigana=>"かみかわちょう"},
      284645=>{:code=>"284645", :pref=>"兵庫県", :name=>"太子町", :type=>"町", :district=>"近畿地方", :furigana=>"たいしちょう"},
      284815=>{:code=>"284815", :pref=>"兵庫県", :name=>"上郡町", :type=>"町", :district=>"近畿地方", :furigana=>"かみごおりちょう"},
      285013=>{:code=>"285013", :pref=>"兵庫県", :name=>"佐用町", :type=>"町", :district=>"近畿地方", :furigana=>"さようちょう"},
      285854=>{:code=>"285854", :pref=>"兵庫県", :name=>"香美町", :type=>"町", :district=>"近畿地方", :furigana=>"かみちょう"},
      285862=>{:code=>"285862", :pref=>"兵庫県", :name=>"新温泉町", :type=>"町", :district=>"近畿地方", :furigana=>"しんおんせんちょう"},
      290009=>{:code=>"290009", :pref=>"奈良県", :name=>"奈良県", :type=>"都道府県", :district=>"近畿地方", :furigana=>"ならけん"},
      292010=>{:code=>"292010", :pref=>"奈良県", :name=>"奈良市", :type=>"市", :district=>"近畿地方", :furigana=>"ならし"},
      292028=>{:code=>"292028", :pref=>"奈良県", :name=>"大和高田市", :type=>"市", :district=>"近畿地方", :furigana=>"やまとたかだし"},
      292036=>{:code=>"292036", :pref=>"奈良県", :name=>"大和郡山市", :type=>"市", :district=>"近畿地方", :furigana=>"やまとこおりやまし"},
      292044=>{:code=>"292044", :pref=>"奈良県", :name=>"天理市", :type=>"市", :district=>"近畿地方", :furigana=>"てんりし"},
      292052=>{:code=>"292052", :pref=>"奈良県", :name=>"橿原市", :type=>"市", :district=>"近畿地方", :furigana=>"かしはらし"},
      292061=>{:code=>"292061", :pref=>"奈良県", :name=>"桜井市", :type=>"市", :district=>"近畿地方", :furigana=>"さくらいし"},
      292079=>{:code=>"292079", :pref=>"奈良県", :name=>"五條市", :type=>"市", :district=>"近畿地方", :furigana=>"ごじょうし"},
      292087=>{:code=>"292087", :pref=>"奈良県", :name=>"御所市", :type=>"市", :district=>"近畿地方", :furigana=>"ごせし"},
      292095=>{:code=>"292095", :pref=>"奈良県", :name=>"生駒市", :type=>"市", :district=>"近畿地方", :furigana=>"いこまし"},
      292109=>{:code=>"292109", :pref=>"奈良県", :name=>"香芝市", :type=>"市", :district=>"近畿地方", :furigana=>"かしばし"},
      292117=>{:code=>"292117", :pref=>"奈良県", :name=>"葛城市", :type=>"市", :district=>"近畿地方", :furigana=>"かつらぎし"},
      292125=>{:code=>"292125", :pref=>"奈良県", :name=>"宇陀市", :type=>"市", :district=>"近畿地方", :furigana=>"うだし"},
      293229=>{:code=>"293229", :pref=>"奈良県", :name=>"山添村", :type=>"村", :district=>"近畿地方", :furigana=>"やまぞえむら"},
      293423=>{:code=>"293423", :pref=>"奈良県", :name=>"平群町", :type=>"町", :district=>"近畿地方", :furigana=>"へぐりちょう"},
      293431=>{:code=>"293431", :pref=>"奈良県", :name=>"三郷町", :type=>"町", :district=>"近畿地方", :furigana=>"さんごうちょう"},
      293440=>{:code=>"293440", :pref=>"奈良県", :name=>"斑鳩町", :type=>"町", :district=>"近畿地方", :furigana=>"いかるがちょう"},
      293458=>{:code=>"293458", :pref=>"奈良県", :name=>"安堵町", :type=>"町", :district=>"近畿地方", :furigana=>"あんどちょう"},
      293610=>{:code=>"293610", :pref=>"奈良県", :name=>"川西町", :type=>"町", :district=>"近畿地方", :furigana=>"かわにしちょう"},
      293628=>{:code=>"293628", :pref=>"奈良県", :name=>"三宅町", :type=>"町", :district=>"近畿地方", :furigana=>"みやけちょう"},
      293636=>{:code=>"293636", :pref=>"奈良県", :name=>"田原本町", :type=>"町", :district=>"近畿地方", :furigana=>"たわらもとちょう"},
      293857=>{:code=>"293857", :pref=>"奈良県", :name=>"曽爾村", :type=>"村", :district=>"近畿地方", :furigana=>"そにむら"},
      293865=>{:code=>"293865", :pref=>"奈良県", :name=>"御杖村", :type=>"村", :district=>"近畿地方", :furigana=>"みつえむら"},
      294012=>{:code=>"294012", :pref=>"奈良県", :name=>"高取町", :type=>"町", :district=>"近畿地方", :furigana=>"たかとりちょう"},
      294021=>{:code=>"294021", :pref=>"奈良県", :name=>"明日香村", :type=>"村", :district=>"近畿地方", :furigana=>"あすかむら"},
      294241=>{:code=>"294241", :pref=>"奈良県", :name=>"上牧町", :type=>"町", :district=>"近畿地方", :furigana=>"かんまきちょう"},
      294250=>{:code=>"294250", :pref=>"奈良県", :name=>"王寺町", :type=>"町", :district=>"近畿地方", :furigana=>"おうじちょう"},
      294268=>{:code=>"294268", :pref=>"奈良県", :name=>"広陵町", :type=>"町", :district=>"近畿地方", :furigana=>"こうりようちょう"},
      294276=>{:code=>"294276", :pref=>"奈良県", :name=>"河合町", :type=>"町", :district=>"近畿地方", :furigana=>"かわいちょう"},
      294411=>{:code=>"294411", :pref=>"奈良県", :name=>"吉野町", :type=>"町", :district=>"近畿地方", :furigana=>"よしのちょう"},
      294420=>{:code=>"294420", :pref=>"奈良県", :name=>"大淀町", :type=>"町", :district=>"近畿地方", :furigana=>"おおよどちょう"},
      294438=>{:code=>"294438", :pref=>"奈良県", :name=>"下市町", :type=>"町", :district=>"近畿地方", :furigana=>"しもいちちょう"},
      294446=>{:code=>"294446", :pref=>"奈良県", :name=>"黒滝村", :type=>"村", :district=>"近畿地方", :furigana=>"くろたきむら"},
      294462=>{:code=>"294462", :pref=>"奈良県", :name=>"天川村", :type=>"村", :district=>"近畿地方", :furigana=>"てんかわむら"},
      294471=>{:code=>"294471", :pref=>"奈良県", :name=>"野迫川村", :type=>"村", :district=>"近畿地方", :furigana=>"のせがわむら"},
      294497=>{:code=>"294497", :pref=>"奈良県", :name=>"十津川村", :type=>"村", :district=>"近畿地方", :furigana=>"とつかわむら"},
      294501=>{:code=>"294501", :pref=>"奈良県", :name=>"下北山村", :type=>"村", :district=>"近畿地方", :furigana=>"しもきたやまむら"},
      294519=>{:code=>"294519", :pref=>"奈良県", :name=>"上北山村", :type=>"村", :district=>"近畿地方", :furigana=>"かみきたやまむら"},
      294527=>{:code=>"294527", :pref=>"奈良県", :name=>"川上村", :type=>"村", :district=>"近畿地方", :furigana=>"かわかみむら"},
      294535=>{:code=>"294535", :pref=>"奈良県", :name=>"東吉野村", :type=>"村", :district=>"近畿地方", :furigana=>"ひがしよしのむら"},
      300004=>{:code=>"300004", :pref=>"和歌山県", :name=>"和歌山県", :type=>"都道府県", :district=>"近畿地方", :furigana=>"わかやまけん"},
      302015=>{:code=>"302015", :pref=>"和歌山県", :name=>"和歌山市", :type=>"市", :district=>"近畿地方", :furigana=>"わかやまし"},
      302023=>{:code=>"302023", :pref=>"和歌山県", :name=>"海南市", :type=>"市", :district=>"近畿地方", :furigana=>"かいなんし"},
      302031=>{:code=>"302031", :pref=>"和歌山県", :name=>"橋本市", :type=>"市", :district=>"近畿地方", :furigana=>"はしもとし"},
      302040=>{:code=>"302040", :pref=>"和歌山県", :name=>"有田市", :type=>"市", :district=>"近畿地方", :furigana=>"ありだし"},
      302058=>{:code=>"302058", :pref=>"和歌山県", :name=>"御坊市", :type=>"市", :district=>"近畿地方", :furigana=>"ごぼうし"},
      302066=>{:code=>"302066", :pref=>"和歌山県", :name=>"田辺市", :type=>"市", :district=>"近畿地方", :furigana=>"たなべし"},
      302074=>{:code=>"302074", :pref=>"和歌山県", :name=>"新宮市", :type=>"市", :district=>"近畿地方", :furigana=>"しんぐうし"},
      302082=>{:code=>"302082", :pref=>"和歌山県", :name=>"紀の川市", :type=>"市", :district=>"近畿地方", :furigana=>"きのかわし"},
      302091=>{:code=>"302091", :pref=>"和歌山県", :name=>"岩出市", :type=>"市", :district=>"近畿地方", :furigana=>"いわでし"},
      303046=>{:code=>"303046", :pref=>"和歌山県", :name=>"紀美野町", :type=>"町", :district=>"近畿地方", :furigana=>"きみのちょう"},
      303411=>{:code=>"303411", :pref=>"和歌山県", :name=>"かつらぎ町", :type=>"町", :district=>"近畿地方", :furigana=>"かつらぎちょう"},
      303437=>{:code=>"303437", :pref=>"和歌山県", :name=>"九度山町", :type=>"町", :district=>"近畿地方", :furigana=>"くどやまちょう"},
      303445=>{:code=>"303445", :pref=>"和歌山県", :name=>"高野町", :type=>"町", :district=>"近畿地方", :furigana=>"こうやちょう"},
      303615=>{:code=>"303615", :pref=>"和歌山県", :name=>"湯浅町", :type=>"町", :district=>"近畿地方", :furigana=>"ゆあさちょう"},
      303623=>{:code=>"303623", :pref=>"和歌山県", :name=>"広川町", :type=>"町", :district=>"近畿地方", :furigana=>"ひろがわちょう"},
      303666=>{:code=>"303666", :pref=>"和歌山県", :name=>"有田川町", :type=>"町", :district=>"近畿地方", :furigana=>"ありだがわちょう"},
      303810=>{:code=>"303810", :pref=>"和歌山県", :name=>"美浜町", :type=>"町", :district=>"近畿地方", :furigana=>"みはまちょう"},
      303828=>{:code=>"303828", :pref=>"和歌山県", :name=>"日高町", :type=>"町", :district=>"近畿地方", :furigana=>"ひだかちょう"},
      303836=>{:code=>"303836", :pref=>"和歌山県", :name=>"由良町", :type=>"町", :district=>"近畿地方", :furigana=>"ゆらちょう"},
      303909=>{:code=>"303909", :pref=>"和歌山県", :name=>"印南町", :type=>"町", :district=>"近畿地方", :furigana=>"いなみちょう"},
      303917=>{:code=>"303917", :pref=>"和歌山県", :name=>"みなべ町", :type=>"町", :district=>"近畿地方", :furigana=>"みなべちょう"},
      303925=>{:code=>"303925", :pref=>"和歌山県", :name=>"日高川町", :type=>"町", :district=>"近畿地方", :furigana=>"ひだかがわちょう"},
      304018=>{:code=>"304018", :pref=>"和歌山県", :name=>"白浜町", :type=>"町", :district=>"近畿地方", :furigana=>"しらはまちょう"},
      304042=>{:code=>"304042", :pref=>"和歌山県", :name=>"上富田町", :type=>"町", :district=>"近畿地方", :furigana=>"かみとんだちょう"},
      304069=>{:code=>"304069", :pref=>"和歌山県", :name=>"すさみ町", :type=>"町", :district=>"近畿地方", :furigana=>"すさみちょう"},
      304212=>{:code=>"304212", :pref=>"和歌山県", :name=>"那智勝浦町", :type=>"町", :district=>"近畿地方", :furigana=>"なちかつうらちょう"},
      304221=>{:code=>"304221", :pref=>"和歌山県", :name=>"太地町", :type=>"町", :district=>"近畿地方", :furigana=>"たいじちょう"},
      304247=>{:code=>"304247", :pref=>"和歌山県", :name=>"古座川町", :type=>"町", :district=>"近畿地方", :furigana=>"こざがわちょう"},
      304271=>{:code=>"304271", :pref=>"和歌山県", :name=>"北山村", :type=>"村", :district=>"近畿地方", :furigana=>"きたやまむら"},
      304280=>{:code=>"304280", :pref=>"和歌山県", :name=>"串本町", :type=>"町", :district=>"近畿地方", :furigana=>"くしもとちょう"},
      310000=>{:code=>"310000", :pref=>"鳥取県", :name=>"鳥取県", :type=>"都道府県", :district=>"中国地方", :furigana=>"とっとりけん"},
      312011=>{:code=>"312011", :pref=>"鳥取県", :name=>"鳥取市", :type=>"市", :district=>"中国地方", :furigana=>"とっとりし"},
      312029=>{:code=>"312029", :pref=>"鳥取県", :name=>"米子市", :type=>"市", :district=>"中国地方", :furigana=>"よなごし"},
      312037=>{:code=>"312037", :pref=>"鳥取県", :name=>"倉吉市", :type=>"市", :district=>"中国地方", :furigana=>"くらよしし"},
      312045=>{:code=>"312045", :pref=>"鳥取県", :name=>"境港市", :type=>"市", :district=>"中国地方", :furigana=>"さかいみなとし"},
      313025=>{:code=>"313025", :pref=>"鳥取県", :name=>"岩美町", :type=>"町", :district=>"中国地方", :furigana=>"いわみちょう"},
      313254=>{:code=>"313254", :pref=>"鳥取県", :name=>"若桜町", :type=>"町", :district=>"中国地方", :furigana=>"わかさちょう"},
      313289=>{:code=>"313289", :pref=>"鳥取県", :name=>"智頭町", :type=>"町", :district=>"中国地方", :furigana=>"ちづちょう"},
      313297=>{:code=>"313297", :pref=>"鳥取県", :name=>"八頭町", :type=>"町", :district=>"中国地方", :furigana=>"やずちょう"},
      313645=>{:code=>"313645", :pref=>"鳥取県", :name=>"三朝町", :type=>"町", :district=>"中国地方", :furigana=>"みささちょう"},
      313700=>{:code=>"313700", :pref=>"鳥取県", :name=>"湯梨浜町", :type=>"町", :district=>"中国地方", :furigana=>"ゆりはまちょう"},
      313718=>{:code=>"313718", :pref=>"鳥取県", :name=>"琴浦町", :type=>"町", :district=>"中国地方", :furigana=>"ことうらちょう"},
      313726=>{:code=>"313726", :pref=>"鳥取県", :name=>"北栄町", :type=>"町", :district=>"中国地方", :furigana=>"ほくえいちょう"},
      313840=>{:code=>"313840", :pref=>"鳥取県", :name=>"日吉津村", :type=>"村", :district=>"中国地方", :furigana=>"ひえづそん"},
      313866=>{:code=>"313866", :pref=>"鳥取県", :name=>"大山町", :type=>"町", :district=>"中国地方", :furigana=>"だいせんちょう"},
      313891=>{:code=>"313891", :pref=>"鳥取県", :name=>"南部町", :type=>"町", :district=>"中国地方", :furigana=>"なんぶちょう"},
      313904=>{:code=>"313904", :pref=>"鳥取県", :name=>"伯耆町", :type=>"町", :district=>"中国地方", :furigana=>"ほうきちょう"},
      314013=>{:code=>"314013", :pref=>"鳥取県", :name=>"日南町", :type=>"町", :district=>"中国地方", :furigana=>"にちなんちょう"},
      314021=>{:code=>"314021", :pref=>"鳥取県", :name=>"日野町", :type=>"町", :district=>"中国地方", :furigana=>"ひのちょう"},
      314030=>{:code=>"314030", :pref=>"鳥取県", :name=>"江府町", :type=>"町", :district=>"中国地方", :furigana=>"こうふちょう"},
      320005=>{:code=>"320005", :pref=>"島根県", :name=>"島根県", :type=>"都道府県", :district=>"中国地方", :furigana=>"しまねけん"},
      322016=>{:code=>"322016", :pref=>"島根県", :name=>"松江市", :type=>"市", :district=>"中国地方", :furigana=>"まつえし"},
      322024=>{:code=>"322024", :pref=>"島根県", :name=>"浜田市", :type=>"市", :district=>"中国地方", :furigana=>"はまだし"},
      322032=>{:code=>"322032", :pref=>"島根県", :name=>"出雲市", :type=>"市", :district=>"中国地方", :furigana=>"いずもし"},
      322041=>{:code=>"322041", :pref=>"島根県", :name=>"益田市", :type=>"市", :district=>"中国地方", :furigana=>"ますだし"},
      322059=>{:code=>"322059", :pref=>"島根県", :name=>"大田市", :type=>"市", :district=>"中国地方", :furigana=>"おおだし"},
      322067=>{:code=>"322067", :pref=>"島根県", :name=>"安来市", :type=>"市", :district=>"中国地方", :furigana=>"やすぎし"},
      322075=>{:code=>"322075", :pref=>"島根県", :name=>"江津市", :type=>"市", :district=>"中国地方", :furigana=>"ごうつし"},
      322091=>{:code=>"322091", :pref=>"島根県", :name=>"雲南市", :type=>"市", :district=>"中国地方", :furigana=>"うんなんし"},
      323438=>{:code=>"323438", :pref=>"島根県", :name=>"奥出雲町", :type=>"町", :district=>"中国地方", :furigana=>"おくいずもちょう"},
      323861=>{:code=>"323861", :pref=>"島根県", :name=>"飯南町", :type=>"町", :district=>"中国地方", :furigana=>"いいなんちょう"},
      324418=>{:code=>"324418", :pref=>"島根県", :name=>"川本町", :type=>"町", :district=>"中国地方", :furigana=>"かわもとまち"},
      324485=>{:code=>"324485", :pref=>"島根県", :name=>"美郷町", :type=>"町", :district=>"中国地方", :furigana=>"みさとちょう"},
      324493=>{:code=>"324493", :pref=>"島根県", :name=>"邑南町", :type=>"町", :district=>"中国地方", :furigana=>"おおなんちょう"},
      325015=>{:code=>"325015", :pref=>"島根県", :name=>"津和野町", :type=>"町", :district=>"中国地方", :furigana=>"つわのちょう"},
      325058=>{:code=>"325058", :pref=>"島根県", :name=>"吉賀町", :type=>"町", :district=>"中国地方", :furigana=>"よしかちょう"},
      325252=>{:code=>"325252", :pref=>"島根県", :name=>"海士町", :type=>"町", :district=>"中国地方", :furigana=>"あまちょう"},
      325261=>{:code=>"325261", :pref=>"島根県", :name=>"西ノ島町", :type=>"町", :district=>"中国地方", :furigana=>"にしのしまちょう"},
      325279=>{:code=>"325279", :pref=>"島根県", :name=>"知夫村", :type=>"村", :district=>"中国地方", :furigana=>"ちぶむら"},
      325287=>{:code=>"325287", :pref=>"島根県", :name=>"隠岐の島町", :type=>"町", :district=>"中国地方", :furigana=>"おきのしまちょう"},
      330001=>{:code=>"330001", :pref=>"岡山県", :name=>"岡山県", :type=>"都道府県", :district=>"中国地方", :furigana=>"おかやまけん"},
      331007=>{:code=>"331007", :pref=>"岡山県", :name=>"岡山市", :type=>"政令市", :district=>"中国地方", :furigana=>"おかやまし"},
      331015=>{:code=>"331015", :pref=>"岡山県", :name=>"岡山市北区", :type=>"行政区", :district=>"中国地方", :furigana=>"おかやましきたく"},
      331023=>{:code=>"331023", :pref=>"岡山県", :name=>"岡山市中区", :type=>"行政区", :district=>"中国地方", :furigana=>"おかやましなかく"},
      331031=>{:code=>"331031", :pref=>"岡山県", :name=>"岡山市東区", :type=>"行政区", :district=>"中国地方", :furigana=>"おかやましひがしく"},
      331040=>{:code=>"331040", :pref=>"岡山県", :name=>"岡山市南区", :type=>"行政区", :district=>"中国地方", :furigana=>"おかやましみなみく"},
      332020=>{:code=>"332020", :pref=>"岡山県", :name=>"倉敷市", :type=>"市", :district=>"中国地方", :furigana=>"くらしきし"},
      332038=>{:code=>"332038", :pref=>"岡山県", :name=>"津山市", :type=>"市", :district=>"中国地方", :furigana=>"つやまし"},
      332046=>{:code=>"332046", :pref=>"岡山県", :name=>"玉野市", :type=>"市", :district=>"中国地方", :furigana=>"たまのし"},
      332054=>{:code=>"332054", :pref=>"岡山県", :name=>"笠岡市", :type=>"市", :district=>"中国地方", :furigana=>"かさおかし"},
      332071=>{:code=>"332071", :pref=>"岡山県", :name=>"井原市", :type=>"市", :district=>"中国地方", :furigana=>"いばらし"},
      332089=>{:code=>"332089", :pref=>"岡山県", :name=>"総社市", :type=>"市", :district=>"中国地方", :furigana=>"そうじやし"},
      332097=>{:code=>"332097", :pref=>"岡山県", :name=>"高梁市", :type=>"市", :district=>"中国地方", :furigana=>"たかはしし"},
      332101=>{:code=>"332101", :pref=>"岡山県", :name=>"新見市", :type=>"市", :district=>"中国地方", :furigana=>"にいみし"},
      332119=>{:code=>"332119", :pref=>"岡山県", :name=>"備前市", :type=>"市", :district=>"中国地方", :furigana=>"びぜんし"},
      332127=>{:code=>"332127", :pref=>"岡山県", :name=>"瀬戸内市", :type=>"市", :district=>"中国地方", :furigana=>"せとうちし"},
      332135=>{:code=>"332135", :pref=>"岡山県", :name=>"赤磐市", :type=>"市", :district=>"中国地方", :furigana=>"あかいわし"},
      332143=>{:code=>"332143", :pref=>"岡山県", :name=>"真庭市", :type=>"市", :district=>"中国地方", :furigana=>"まにわし"},
      332151=>{:code=>"332151", :pref=>"岡山県", :name=>"美作市", :type=>"市", :district=>"中国地方", :furigana=>"みまさかし"},
      332160=>{:code=>"332160", :pref=>"岡山県", :name=>"浅口市", :type=>"市", :district=>"中国地方", :furigana=>"あさくちし"},
      333468=>{:code=>"333468", :pref=>"岡山県", :name=>"和気町", :type=>"町", :district=>"中国地方", :furigana=>"わけちょう"},
      334235=>{:code=>"334235", :pref=>"岡山県", :name=>"早島町", :type=>"町", :district=>"中国地方", :furigana=>"はやしまちょう"},
      334456=>{:code=>"334456", :pref=>"岡山県", :name=>"里庄町", :type=>"町", :district=>"中国地方", :furigana=>"さとしょうちょう"},
      334618=>{:code=>"334618", :pref=>"岡山県", :name=>"矢掛町", :type=>"町", :district=>"中国地方", :furigana=>"やかげちょう"},
      335860=>{:code=>"335860", :pref=>"岡山県", :name=>"新庄村", :type=>"村", :district=>"中国地方", :furigana=>"しんじようそん"},
      336068=>{:code=>"336068", :pref=>"岡山県", :name=>"鏡野町", :type=>"町", :district=>"中国地方", :furigana=>"かがみのちょう"},
      336220=>{:code=>"336220", :pref=>"岡山県", :name=>"勝央町", :type=>"町", :district=>"中国地方", :furigana=>"しょうおうちょう"},
      336238=>{:code=>"336238", :pref=>"岡山県", :name=>"奈義町", :type=>"町", :district=>"中国地方", :furigana=>"なぎちょう"},
      336432=>{:code=>"336432", :pref=>"岡山県", :name=>"西粟倉村", :type=>"村", :district=>"中国地方", :furigana=>"にしあわくらそん"},
      336637=>{:code=>"336637", :pref=>"岡山県", :name=>"久米南町", :type=>"町", :district=>"中国地方", :furigana=>"くめなんちょう"},
      336661=>{:code=>"336661", :pref=>"岡山県", :name=>"美咲町", :type=>"町", :district=>"中国地方", :furigana=>"みさきちょう"},
      336815=>{:code=>"336815", :pref=>"岡山県", :name=>"吉備中央町", :type=>"町", :district=>"中国地方", :furigana=>"きびちゅうおうちょう"},
      340006=>{:code=>"340006", :pref=>"広島県", :name=>"広島県", :type=>"都道府県", :district=>"中国地方", :furigana=>"ひろしまけん"},
      341002=>{:code=>"341002", :pref=>"広島県", :name=>"広島市", :type=>"政令市", :district=>"中国地方", :furigana=>"ひろしまし"},
      341011=>{:code=>"341011", :pref=>"広島県", :name=>"広島市中区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましなかく"},
      341029=>{:code=>"341029", :pref=>"広島県", :name=>"広島市東区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましひがしく"},
      341037=>{:code=>"341037", :pref=>"広島県", :name=>"広島市南区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましみなみく"},
      341045=>{:code=>"341045", :pref=>"広島県", :name=>"広島市西区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましにしく"},
      341053=>{:code=>"341053", :pref=>"広島県", :name=>"広島市安佐南区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましあさみなみく"},
      341061=>{:code=>"341061", :pref=>"広島県", :name=>"広島市安佐北区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましあさきたく"},
      341070=>{:code=>"341070", :pref=>"広島県", :name=>"広島市安芸区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましあきく"},
      341088=>{:code=>"341088", :pref=>"広島県", :name=>"広島市佐伯区", :type=>"行政区", :district=>"中国地方", :furigana=>"ひろしましさえきく"},
      342025=>{:code=>"342025", :pref=>"広島県", :name=>"呉市", :type=>"市", :district=>"中国地方", :furigana=>"くれし"},
      342033=>{:code=>"342033", :pref=>"広島県", :name=>"竹原市", :type=>"市", :district=>"中国地方", :furigana=>"たけはらし"},
      342041=>{:code=>"342041", :pref=>"広島県", :name=>"三原市", :type=>"市", :district=>"中国地方", :furigana=>"みはらし"},
      342050=>{:code=>"342050", :pref=>"広島県", :name=>"尾道市", :type=>"市", :district=>"中国地方", :furigana=>"おのみちし"},
      342076=>{:code=>"342076", :pref=>"広島県", :name=>"福山市", :type=>"市", :district=>"中国地方", :furigana=>"ふくやまし"},
      342084=>{:code=>"342084", :pref=>"広島県", :name=>"府中市", :type=>"市", :district=>"中国地方", :furigana=>"ふちゅうし"},
      342092=>{:code=>"342092", :pref=>"広島県", :name=>"三次市", :type=>"市", :district=>"中国地方", :furigana=>"みよしし"},
      342106=>{:code=>"342106", :pref=>"広島県", :name=>"庄原市", :type=>"市", :district=>"中国地方", :furigana=>"しょうばらし"},
      342114=>{:code=>"342114", :pref=>"広島県", :name=>"大竹市", :type=>"市", :district=>"中国地方", :furigana=>"おおたけし"},
      342122=>{:code=>"342122", :pref=>"広島県", :name=>"東広島市", :type=>"市", :district=>"中国地方", :furigana=>"ひがしひろしまし"},
      342131=>{:code=>"342131", :pref=>"広島県", :name=>"廿日市市", :type=>"市", :district=>"中国地方", :furigana=>"はつかいちし"},
      342149=>{:code=>"342149", :pref=>"広島県", :name=>"安芸高田市", :type=>"市", :district=>"中国地方", :furigana=>"あきたかたし"},
      342157=>{:code=>"342157", :pref=>"広島県", :name=>"江田島市", :type=>"市", :district=>"中国地方", :furigana=>"えたじまし"},
      343021=>{:code=>"343021", :pref=>"広島県", :name=>"府中町", :type=>"町", :district=>"中国地方", :furigana=>"ふちゅうちょう"},
      343048=>{:code=>"343048", :pref=>"広島県", :name=>"海田町", :type=>"町", :district=>"中国地方", :furigana=>"かいたちょう"},
      343072=>{:code=>"343072", :pref=>"広島県", :name=>"熊野町", :type=>"町", :district=>"中国地方", :furigana=>"くまのちょう"},
      343099=>{:code=>"343099", :pref=>"広島県", :name=>"坂町", :type=>"町", :district=>"中国地方", :furigana=>"さかちょう"},
      343684=>{:code=>"343684", :pref=>"広島県", :name=>"安芸太田町", :type=>"町", :district=>"中国地方", :furigana=>"あきおおたちょう"},
      343692=>{:code=>"343692", :pref=>"広島県", :name=>"北広島町", :type=>"町", :district=>"中国地方", :furigana=>"きたひろしまちょう"},
      344311=>{:code=>"344311", :pref=>"広島県", :name=>"大崎上島町", :type=>"町", :district=>"中国地方", :furigana=>"おおさきかみじまちょう"},
      344621=>{:code=>"344621", :pref=>"広島県", :name=>"世羅町", :type=>"町", :district=>"中国地方", :furigana=>"せらちょう"},
      345458=>{:code=>"345458", :pref=>"広島県", :name=>"神石高原町", :type=>"町", :district=>"中国地方", :furigana=>"じんせきこうげんちょう"},
      350001=>{:code=>"350001", :pref=>"山口県", :name=>"山口県", :type=>"都道府県", :district=>"中国地方", :furigana=>"やまぐちけん"},
      352012=>{:code=>"352012", :pref=>"山口県", :name=>"下関市", :type=>"市", :district=>"中国地方", :furigana=>"しものせきし"},
      352021=>{:code=>"352021", :pref=>"山口県", :name=>"宇部市", :type=>"市", :district=>"中国地方", :furigana=>"うべし"},
      352039=>{:code=>"352039", :pref=>"山口県", :name=>"山口市", :type=>"市", :district=>"中国地方", :furigana=>"やまぐちし"},
      352047=>{:code=>"352047", :pref=>"山口県", :name=>"萩市", :type=>"市", :district=>"中国地方", :furigana=>"はぎし"},
      352063=>{:code=>"352063", :pref=>"山口県", :name=>"防府市", :type=>"市", :district=>"中国地方", :furigana=>"ほうふし"},
      352071=>{:code=>"352071", :pref=>"山口県", :name=>"下松市", :type=>"市", :district=>"中国地方", :furigana=>"くだまつし"},
      352080=>{:code=>"352080", :pref=>"山口県", :name=>"岩国市", :type=>"市", :district=>"中国地方", :furigana=>"いわくにし"},
      352101=>{:code=>"352101", :pref=>"山口県", :name=>"光市", :type=>"市", :district=>"中国地方", :furigana=>"ひかりし"},
      352110=>{:code=>"352110", :pref=>"山口県", :name=>"長門市", :type=>"市", :district=>"中国地方", :furigana=>"ながとし"},
      352128=>{:code=>"352128", :pref=>"山口県", :name=>"柳井市", :type=>"市", :district=>"中国地方", :furigana=>"やないし"},
      352136=>{:code=>"352136", :pref=>"山口県", :name=>"美祢市", :type=>"市", :district=>"中国地方", :furigana=>"みねし"},
      352152=>{:code=>"352152", :pref=>"山口県", :name=>"周南市", :type=>"市", :district=>"中国地方", :furigana=>"しゅうなんし"},
      352161=>{:code=>"352161", :pref=>"山口県", :name=>"山陽小野田市", :type=>"市", :district=>"中国地方", :furigana=>"さんようおのだし"},
      353051=>{:code=>"353051", :pref=>"山口県", :name=>"周防大島町", :type=>"町", :district=>"中国地方", :furigana=>"すおうおおしまちょう"},
      353213=>{:code=>"353213", :pref=>"山口県", :name=>"和木町", :type=>"町", :district=>"中国地方", :furigana=>"わきちょう"},
      353418=>{:code=>"353418", :pref=>"山口県", :name=>"上関町", :type=>"町", :district=>"中国地方", :furigana=>"かみのせきちょう"},
      353434=>{:code=>"353434", :pref=>"山口県", :name=>"田布施町", :type=>"町", :district=>"中国地方", :furigana=>"たぶせちょう"},
      353442=>{:code=>"353442", :pref=>"山口県", :name=>"平生町", :type=>"町", :district=>"中国地方", :furigana=>"ひらおちょう"},
      355020=>{:code=>"355020", :pref=>"山口県", :name=>"阿武町", :type=>"町", :district=>"中国地方", :furigana=>"あぶちょう"},
      360007=>{:code=>"360007", :pref=>"徳島県", :name=>"徳島県", :type=>"都道府県", :district=>"四国地方", :furigana=>"とくしまけん"},
      362018=>{:code=>"362018", :pref=>"徳島県", :name=>"徳島市", :type=>"市", :district=>"四国地方", :furigana=>"とくしまし"},
      362026=>{:code=>"362026", :pref=>"徳島県", :name=>"鳴門市", :type=>"市", :district=>"四国地方", :furigana=>"なるとし"},
      362034=>{:code=>"362034", :pref=>"徳島県", :name=>"小松島市", :type=>"市", :district=>"四国地方", :furigana=>"こまつしまし"},
      362042=>{:code=>"362042", :pref=>"徳島県", :name=>"阿南市", :type=>"市", :district=>"四国地方", :furigana=>"あなんし"},
      362051=>{:code=>"362051", :pref=>"徳島県", :name=>"吉野川市", :type=>"市", :district=>"四国地方", :furigana=>"よしのがわし"},
      362069=>{:code=>"362069", :pref=>"徳島県", :name=>"阿波市", :type=>"市", :district=>"四国地方", :furigana=>"あわし"},
      362077=>{:code=>"362077", :pref=>"徳島県", :name=>"美馬市", :type=>"市", :district=>"四国地方", :furigana=>"みまし"},
      362085=>{:code=>"362085", :pref=>"徳島県", :name=>"三好市", :type=>"市", :district=>"四国地方", :furigana=>"みよしし"},
      363014=>{:code=>"363014", :pref=>"徳島県", :name=>"勝浦町", :type=>"町", :district=>"四国地方", :furigana=>"かつうらちょう"},
      363022=>{:code=>"363022", :pref=>"徳島県", :name=>"上勝町", :type=>"町", :district=>"四国地方", :furigana=>"かみかつちょう"},
      363219=>{:code=>"363219", :pref=>"徳島県", :name=>"佐那河内村", :type=>"村", :district=>"四国地方", :furigana=>"さなごうちそん"},
      363413=>{:code=>"363413", :pref=>"徳島県", :name=>"石井町", :type=>"町", :district=>"四国地方", :furigana=>"いしいちょう"},
      363421=>{:code=>"363421", :pref=>"徳島県", :name=>"神山町", :type=>"町", :district=>"四国地方", :furigana=>"かみやまちょう"},
      363685=>{:code=>"363685", :pref=>"徳島県", :name=>"那賀町", :type=>"町", :district=>"四国地方", :furigana=>"なかちょう"},
      363839=>{:code=>"363839", :pref=>"徳島県", :name=>"牟岐町", :type=>"町", :district=>"四国地方", :furigana=>"むぎちょう"},
      363871=>{:code=>"363871", :pref=>"徳島県", :name=>"美波町", :type=>"町", :district=>"四国地方", :furigana=>"みなみちょう"},
      363880=>{:code=>"363880", :pref=>"徳島県", :name=>"海陽町", :type=>"町", :district=>"四国地方", :furigana=>"かいようちょう"},
      364011=>{:code=>"364011", :pref=>"徳島県", :name=>"松茂町", :type=>"町", :district=>"四国地方", :furigana=>"まつしげちょう"},
      364029=>{:code=>"364029", :pref=>"徳島県", :name=>"北島町", :type=>"町", :district=>"四国地方", :furigana=>"きたじまちょう"},
      364037=>{:code=>"364037", :pref=>"徳島県", :name=>"藍住町", :type=>"町", :district=>"四国地方", :furigana=>"あいずみちょう"},
      364045=>{:code=>"364045", :pref=>"徳島県", :name=>"板野町", :type=>"町", :district=>"四国地方", :furigana=>"いたのちょう"},
      364053=>{:code=>"364053", :pref=>"徳島県", :name=>"上板町", :type=>"町", :district=>"四国地方", :furigana=>"かみいたちょう"},
      364681=>{:code=>"364681", :pref=>"徳島県", :name=>"つるぎ町", :type=>"町", :district=>"四国地方", :furigana=>"つるぎちょう"},
      364894=>{:code=>"364894", :pref=>"徳島県", :name=>"東みよし町", :type=>"町", :district=>"四国地方", :furigana=>"ひがしみよしちょう"},
      370002=>{:code=>"370002", :pref=>"香川県", :name=>"香川県", :type=>"都道府県", :district=>"四国地方", :furigana=>"かがわけん"},
      372013=>{:code=>"372013", :pref=>"香川県", :name=>"高松市", :type=>"市", :district=>"四国地方", :furigana=>"たかまつし"},
      372021=>{:code=>"372021", :pref=>"香川県", :name=>"丸亀市", :type=>"市", :district=>"四国地方", :furigana=>"まるがめし"},
      372030=>{:code=>"372030", :pref=>"香川県", :name=>"坂出市", :type=>"市", :district=>"四国地方", :furigana=>"さかいでし"},
      372048=>{:code=>"372048", :pref=>"香川県", :name=>"善通寺市", :type=>"市", :district=>"四国地方", :furigana=>"ぜんつうじし"},
      372056=>{:code=>"372056", :pref=>"香川県", :name=>"観音寺市", :type=>"市", :district=>"四国地方", :furigana=>"かんおんじし"},
      372064=>{:code=>"372064", :pref=>"香川県", :name=>"さぬき市", :type=>"市", :district=>"四国地方", :furigana=>"さぬきし"},
      372072=>{:code=>"372072", :pref=>"香川県", :name=>"東かがわ市", :type=>"市", :district=>"四国地方", :furigana=>"ひがしかがわし"},
      372081=>{:code=>"372081", :pref=>"香川県", :name=>"三豊市", :type=>"市", :district=>"四国地方", :furigana=>"みとよし"},
      373222=>{:code=>"373222", :pref=>"香川県", :name=>"土庄町", :type=>"町", :district=>"四国地方", :furigana=>"とのしょうちょう"},
      373249=>{:code=>"373249", :pref=>"香川県", :name=>"小豆島町", :type=>"町", :district=>"四国地方", :furigana=>"しょうどしまちょう"},
      373419=>{:code=>"373419", :pref=>"香川県", :name=>"三木町", :type=>"町", :district=>"四国地方", :furigana=>"みきちょう"},
      373648=>{:code=>"373648", :pref=>"香川県", :name=>"直島町", :type=>"町", :district=>"四国地方", :furigana=>"なおしまちょう"},
      373869=>{:code=>"373869", :pref=>"香川県", :name=>"宇多津町", :type=>"町", :district=>"四国地方", :furigana=>"うたづちょう"},
      373877=>{:code=>"373877", :pref=>"香川県", :name=>"綾川町", :type=>"町", :district=>"四国地方", :furigana=>"あやがわちょう"},
      374032=>{:code=>"374032", :pref=>"香川県", :name=>"琴平町", :type=>"町", :district=>"四国地方", :furigana=>"ことひらちょう"},
      374041=>{:code=>"374041", :pref=>"香川県", :name=>"多度津町", :type=>"町", :district=>"四国地方", :furigana=>"たどつちょう"},
      374067=>{:code=>"374067", :pref=>"香川県", :name=>"まんのう町", :type=>"町", :district=>"四国地方", :furigana=>"まんのうちょう"},
      380008=>{:code=>"380008", :pref=>"愛媛県", :name=>"愛媛県", :type=>"都道府県", :district=>"四国地方", :furigana=>"えひめけん"},
      382019=>{:code=>"382019", :pref=>"愛媛県", :name=>"松山市", :type=>"市", :district=>"四国地方", :furigana=>"まつやまし"},
      382027=>{:code=>"382027", :pref=>"愛媛県", :name=>"今治市", :type=>"市", :district=>"四国地方", :furigana=>"いまばりし"},
      382035=>{:code=>"382035", :pref=>"愛媛県", :name=>"宇和島市", :type=>"市", :district=>"四国地方", :furigana=>"うわじまし"},
      382043=>{:code=>"382043", :pref=>"愛媛県", :name=>"八幡浜市", :type=>"市", :district=>"四国地方", :furigana=>"やわたはまし"},
      382051=>{:code=>"382051", :pref=>"愛媛県", :name=>"新居浜市", :type=>"市", :district=>"四国地方", :furigana=>"にいはまし"},
      382060=>{:code=>"382060", :pref=>"愛媛県", :name=>"西条市", :type=>"市", :district=>"四国地方", :furigana=>"さいじょうし"},
      382078=>{:code=>"382078", :pref=>"愛媛県", :name=>"大洲市", :type=>"市", :district=>"四国地方", :furigana=>"おおずし"},
      382108=>{:code=>"382108", :pref=>"愛媛県", :name=>"伊予市", :type=>"市", :district=>"四国地方", :furigana=>"いよし"},
      382132=>{:code=>"382132", :pref=>"愛媛県", :name=>"四国中央市", :type=>"市", :district=>"四国地方", :furigana=>"しこくちゅうおうし"},
      382141=>{:code=>"382141", :pref=>"愛媛県", :name=>"西予市", :type=>"市", :district=>"四国地方", :furigana=>"せいよし"},
      382159=>{:code=>"382159", :pref=>"愛媛県", :name=>"東温市", :type=>"市", :district=>"四国地方", :furigana=>"とうおんし"},
      383562=>{:code=>"383562", :pref=>"愛媛県", :name=>"上島町", :type=>"町", :district=>"四国地方", :furigana=>"かみじまちょう"},
      383864=>{:code=>"383864", :pref=>"愛媛県", :name=>"久万高原町", :type=>"町", :district=>"四国地方", :furigana=>"くまこうげんちょう"},
      384011=>{:code=>"384011", :pref=>"愛媛県", :name=>"松前町", :type=>"町", :district=>"四国地方", :furigana=>"まさきちょう"},
      384020=>{:code=>"384020", :pref=>"愛媛県", :name=>"砥部町", :type=>"町", :district=>"四国地方", :furigana=>"とべちょう"},
      384224=>{:code=>"384224", :pref=>"愛媛県", :name=>"内子町", :type=>"町", :district=>"四国地方", :furigana=>"うちこちょう"},
      384429=>{:code=>"384429", :pref=>"愛媛県", :name=>"伊方町", :type=>"町", :district=>"四国地方", :furigana=>"いかたちょう"},
      384844=>{:code=>"384844", :pref=>"愛媛県", :name=>"松野町", :type=>"町", :district=>"四国地方", :furigana=>"まつのちょう"},
      384887=>{:code=>"384887", :pref=>"愛媛県", :name=>"鬼北町", :type=>"町", :district=>"四国地方", :furigana=>"きほくちょう"},
      385069=>{:code=>"385069", :pref=>"愛媛県", :name=>"愛南町", :type=>"町", :district=>"四国地方", :furigana=>"あいなんちょう"},
      390003=>{:code=>"390003", :pref=>"高知県", :name=>"高知県", :type=>"都道府県", :district=>"四国地方", :furigana=>"こうちけん"},
      392014=>{:code=>"392014", :pref=>"高知県", :name=>"高知市", :type=>"市", :district=>"四国地方", :furigana=>"こうちし"},
      392022=>{:code=>"392022", :pref=>"高知県", :name=>"室戸市", :type=>"市", :district=>"四国地方", :furigana=>"むろとし"},
      392031=>{:code=>"392031", :pref=>"高知県", :name=>"安芸市", :type=>"市", :district=>"四国地方", :furigana=>"あきし"},
      392049=>{:code=>"392049", :pref=>"高知県", :name=>"南国市", :type=>"市", :district=>"四国地方", :furigana=>"なんこくし"},
      392057=>{:code=>"392057", :pref=>"高知県", :name=>"土佐市", :type=>"市", :district=>"四国地方", :furigana=>"とさし"},
      392065=>{:code=>"392065", :pref=>"高知県", :name=>"須崎市", :type=>"市", :district=>"四国地方", :furigana=>"すさきし"},
      392081=>{:code=>"392081", :pref=>"高知県", :name=>"宿毛市", :type=>"市", :district=>"四国地方", :furigana=>"すくもし"},
      392090=>{:code=>"392090", :pref=>"高知県", :name=>"土佐清水市", :type=>"市", :district=>"四国地方", :furigana=>"とさしみずし"},
      392103=>{:code=>"392103", :pref=>"高知県", :name=>"四万十市", :type=>"市", :district=>"四国地方", :furigana=>"しまんとし"},
      392111=>{:code=>"392111", :pref=>"高知県", :name=>"香南市", :type=>"市", :district=>"四国地方", :furigana=>"こうなんし"},
      392120=>{:code=>"392120", :pref=>"高知県", :name=>"香美市", :type=>"市", :district=>"四国地方", :furigana=>"かみし"},
      393011=>{:code=>"393011", :pref=>"高知県", :name=>"東洋町", :type=>"町", :district=>"四国地方", :furigana=>"とうようちょう"},
      393029=>{:code=>"393029", :pref=>"高知県", :name=>"奈半利町", :type=>"町", :district=>"四国地方", :furigana=>"なはりちょう"},
      393037=>{:code=>"393037", :pref=>"高知県", :name=>"田野町", :type=>"町", :district=>"四国地方", :furigana=>"たのちょう"},
      393045=>{:code=>"393045", :pref=>"高知県", :name=>"安田町", :type=>"町", :district=>"四国地方", :furigana=>"やすだちょう"},
      393053=>{:code=>"393053", :pref=>"高知県", :name=>"北川村", :type=>"村", :district=>"四国地方", :furigana=>"きたがわむら"},
      393061=>{:code=>"393061", :pref=>"高知県", :name=>"馬路村", :type=>"村", :district=>"四国地方", :furigana=>"うまじむら"},
      393070=>{:code=>"393070", :pref=>"高知県", :name=>"芸西村", :type=>"村", :district=>"四国地方", :furigana=>"げいせいむら"},
      393410=>{:code=>"393410", :pref=>"高知県", :name=>"本山町", :type=>"町", :district=>"四国地方", :furigana=>"もとやまちょう"},
      393444=>{:code=>"393444", :pref=>"高知県", :name=>"大豊町", :type=>"町", :district=>"四国地方", :furigana=>"おおとよちょう"},
      393631=>{:code=>"393631", :pref=>"高知県", :name=>"土佐町", :type=>"町", :district=>"四国地方", :furigana=>"とさちょう"},
      393649=>{:code=>"393649", :pref=>"高知県", :name=>"大川村", :type=>"村", :district=>"四国地方", :furigana=>"おおかわむら"},
      393860=>{:code=>"393860", :pref=>"高知県", :name=>"いの町", :type=>"町", :district=>"四国地方", :furigana=>"いのちょう"},
      393878=>{:code=>"393878", :pref=>"高知県", :name=>"仁淀川町", :type=>"町", :district=>"四国地方", :furigana=>"によどがわちょう"},
      394017=>{:code=>"394017", :pref=>"高知県", :name=>"中土佐町", :type=>"町", :district=>"四国地方", :furigana=>"なかとさちょう"},
      394025=>{:code=>"394025", :pref=>"高知県", :name=>"佐川町", :type=>"町", :district=>"四国地方", :furigana=>"さかわちょう"},
      394033=>{:code=>"394033", :pref=>"高知県", :name=>"越知町", :type=>"町", :district=>"四国地方", :furigana=>"おちちょう"},
      394050=>{:code=>"394050", :pref=>"高知県", :name=>"梼原町", :type=>"町", :district=>"四国地方", :furigana=>"ゆすはらちょう"},
      394106=>{:code=>"394106", :pref=>"高知県", :name=>"日高村", :type=>"村", :district=>"四国地方", :furigana=>"ひだかむら"},
      394114=>{:code=>"394114", :pref=>"高知県", :name=>"津野町", :type=>"町", :district=>"四国地方", :furigana=>"つのちょう"},
      394122=>{:code=>"394122", :pref=>"高知県", :name=>"四万十町", :type=>"町", :district=>"四国地方", :furigana=>"しまんとちょう"},
      394246=>{:code=>"394246", :pref=>"高知県", :name=>"大月町", :type=>"町", :district=>"四国地方", :furigana=>"おおつきちょう"},
      394271=>{:code=>"394271", :pref=>"高知県", :name=>"三原村", :type=>"村", :district=>"四国地方", :furigana=>"みはらむら"},
      394289=>{:code=>"394289", :pref=>"高知県", :name=>"黒潮町", :type=>"町", :district=>"四国地方", :furigana=>"くろしおちょう"},
      400009=>{:code=>"400009", :pref=>"福岡県", :name=>"福岡県", :type=>"都道府県", :district=>"九州地方", :furigana=>"ふくおかけん"},
      401005=>{:code=>"401005", :pref=>"福岡県", :name=>"北九州市", :type=>"政令市", :district=>"九州地方", :furigana=>"きたきゅうしゅうし"},
      401013=>{:code=>"401013", :pref=>"福岡県", :name=>"北九州市門司区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしもじく"},
      401030=>{:code=>"401030", :pref=>"福岡県", :name=>"北九州市若松区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしわかまつく"},
      401056=>{:code=>"401056", :pref=>"福岡県", :name=>"北九州市戸畑区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしとばたく"},
      401064=>{:code=>"401064", :pref=>"福岡県", :name=>"北九州市小倉北区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしこくらきたく"},
      401072=>{:code=>"401072", :pref=>"福岡県", :name=>"北九州市小倉南区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしこくらみなみく"},
      401081=>{:code=>"401081", :pref=>"福岡県", :name=>"北九州市八幡東区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしやはたひがしく"},
      401099=>{:code=>"401099", :pref=>"福岡県", :name=>"北九州市八幡西区", :type=>"行政区", :district=>"九州地方", :furigana=>"きたきゅうしゅうしやはたにしく"},
      401307=>{:code=>"401307", :pref=>"福岡県", :name=>"福岡市", :type=>"政令市", :district=>"九州地方", :furigana=>"ふくおかし"},
      401315=>{:code=>"401315", :pref=>"福岡県", :name=>"福岡市東区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしひがしく"},
      401323=>{:code=>"401323", :pref=>"福岡県", :name=>"福岡市博多区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしはかたく"},
      401331=>{:code=>"401331", :pref=>"福岡県", :name=>"福岡市中央区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしちゅうおうく"},
      401340=>{:code=>"401340", :pref=>"福岡県", :name=>"福岡市南区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしみなみく"},
      401358=>{:code=>"401358", :pref=>"福岡県", :name=>"福岡市西区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしにしく"},
      401366=>{:code=>"401366", :pref=>"福岡県", :name=>"福岡市城南区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしじょうなんく"},
      401374=>{:code=>"401374", :pref=>"福岡県", :name=>"福岡市早良区", :type=>"行政区", :district=>"九州地方", :furigana=>"ふくおかしさわらく"},
      402028=>{:code=>"402028", :pref=>"福岡県", :name=>"大牟田市", :type=>"市", :district=>"九州地方", :furigana=>"おおむたし"},
      402036=>{:code=>"402036", :pref=>"福岡県", :name=>"久留米市", :type=>"市", :district=>"九州地方", :furigana=>"くるめし"},
      402044=>{:code=>"402044", :pref=>"福岡県", :name=>"直方市", :type=>"市", :district=>"九州地方", :furigana=>"のおがたし"},
      402052=>{:code=>"402052", :pref=>"福岡県", :name=>"飯塚市", :type=>"市", :district=>"九州地方", :furigana=>"いいづかし"},
      402061=>{:code=>"402061", :pref=>"福岡県", :name=>"田川市", :type=>"市", :district=>"九州地方", :furigana=>"たがわし"},
      402079=>{:code=>"402079", :pref=>"福岡県", :name=>"柳川市", :type=>"市", :district=>"九州地方", :furigana=>"やながわし"},
      402109=>{:code=>"402109", :pref=>"福岡県", :name=>"八女市", :type=>"市", :district=>"九州地方", :furigana=>"やめし"},
      402117=>{:code=>"402117", :pref=>"福岡県", :name=>"筑後市", :type=>"市", :district=>"九州地方", :furigana=>"ちくごし"},
      402125=>{:code=>"402125", :pref=>"福岡県", :name=>"大川市", :type=>"市", :district=>"九州地方", :furigana=>"おおかわし"},
      402133=>{:code=>"402133", :pref=>"福岡県", :name=>"行橋市", :type=>"市", :district=>"九州地方", :furigana=>"ゆくはしし"},
      402141=>{:code=>"402141", :pref=>"福岡県", :name=>"豊前市", :type=>"市", :district=>"九州地方", :furigana=>"ぶぜんし"},
      402150=>{:code=>"402150", :pref=>"福岡県", :name=>"中間市", :type=>"市", :district=>"九州地方", :furigana=>"なかまし"},
      402168=>{:code=>"402168", :pref=>"福岡県", :name=>"小郡市", :type=>"市", :district=>"九州地方", :furigana=>"おごおりし"},
      402176=>{:code=>"402176", :pref=>"福岡県", :name=>"筑紫野市", :type=>"市", :district=>"九州地方", :furigana=>"ちくしのし"},
      402184=>{:code=>"402184", :pref=>"福岡県", :name=>"春日市", :type=>"市", :district=>"九州地方", :furigana=>"かすがし"},
      402192=>{:code=>"402192", :pref=>"福岡県", :name=>"大野城市", :type=>"市", :district=>"九州地方", :furigana=>"おおのじょうし"},
      402206=>{:code=>"402206", :pref=>"福岡県", :name=>"宗像市", :type=>"市", :district=>"九州地方", :furigana=>"むなかたし"},
      402214=>{:code=>"402214", :pref=>"福岡県", :name=>"太宰府市", :type=>"市", :district=>"九州地方", :furigana=>"だざいふし"},
      402231=>{:code=>"402231", :pref=>"福岡県", :name=>"古賀市", :type=>"市", :district=>"九州地方", :furigana=>"こがし"},
      402249=>{:code=>"402249", :pref=>"福岡県", :name=>"福津市", :type=>"市", :district=>"九州地方", :furigana=>"ふくつし"},
      402257=>{:code=>"402257", :pref=>"福岡県", :name=>"うきは市", :type=>"市", :district=>"九州地方", :furigana=>"うきはし"},
      402265=>{:code=>"402265", :pref=>"福岡県", :name=>"宮若市", :type=>"市", :district=>"九州地方", :furigana=>"みやわかし"},
      402273=>{:code=>"402273", :pref=>"福岡県", :name=>"嘉麻市", :type=>"市", :district=>"九州地方", :furigana=>"かまし"},
      402281=>{:code=>"402281", :pref=>"福岡県", :name=>"朝倉市", :type=>"市", :district=>"九州地方", :furigana=>"あさくらし"},
      402290=>{:code=>"402290", :pref=>"福岡県", :name=>"みやま市", :type=>"市", :district=>"九州地方", :furigana=>"みやまし"},
      402303=>{:code=>"402303", :pref=>"福岡県", :name=>"糸島市", :type=>"市", :district=>"九州地方", :furigana=>"いとしまし"},
      403059=>{:code=>"403059", :pref=>"福岡県", :name=>"那珂川町", :type=>"町", :district=>"九州地方", :furigana=>"なかがわまち"},
      403415=>{:code=>"403415", :pref=>"福岡県", :name=>"宇美町", :type=>"町", :district=>"九州地方", :furigana=>"うみまち"},
      403423=>{:code=>"403423", :pref=>"福岡県", :name=>"篠栗町", :type=>"町", :district=>"九州地方", :furigana=>"ささぐりまち"},
      403431=>{:code=>"403431", :pref=>"福岡県", :name=>"志免町", :type=>"町", :district=>"九州地方", :furigana=>"しめまち"},
      403440=>{:code=>"403440", :pref=>"福岡県", :name=>"須恵町", :type=>"町", :district=>"九州地方", :furigana=>"すえまち"},
      403458=>{:code=>"403458", :pref=>"福岡県", :name=>"新宮町", :type=>"町", :district=>"九州地方", :furigana=>"しんぐうまち"},
      403482=>{:code=>"403482", :pref=>"福岡県", :name=>"久山町", :type=>"町", :district=>"九州地方", :furigana=>"ひさやままち"},
      403491=>{:code=>"403491", :pref=>"福岡県", :name=>"粕屋町", :type=>"町", :district=>"九州地方", :furigana=>"かすやまち"},
      403814=>{:code=>"403814", :pref=>"福岡県", :name=>"芦屋町", :type=>"町", :district=>"九州地方", :furigana=>"あしやまち"},
      403822=>{:code=>"403822", :pref=>"福岡県", :name=>"水巻町", :type=>"町", :district=>"九州地方", :furigana=>"みずまきまち"},
      403831=>{:code=>"403831", :pref=>"福岡県", :name=>"岡垣町", :type=>"町", :district=>"九州地方", :furigana=>"おかがきまち"},
      403849=>{:code=>"403849", :pref=>"福岡県", :name=>"遠賀町", :type=>"町", :district=>"九州地方", :furigana=>"おんがちょう"},
      404012=>{:code=>"404012", :pref=>"福岡県", :name=>"小竹町", :type=>"町", :district=>"九州地方", :furigana=>"こたけまち"},
      404021=>{:code=>"404021", :pref=>"福岡県", :name=>"鞍手町", :type=>"町", :district=>"九州地方", :furigana=>"くらてまち"},
      404217=>{:code=>"404217", :pref=>"福岡県", :name=>"桂川町", :type=>"町", :district=>"九州地方", :furigana=>"けいせんまち"},
      404471=>{:code=>"404471", :pref=>"福岡県", :name=>"筑前町", :type=>"町", :district=>"九州地方", :furigana=>"ちくぜんまち"},
      404489=>{:code=>"404489", :pref=>"福岡県", :name=>"東峰村", :type=>"村", :district=>"九州地方", :furigana=>"とうほうむら"},
      405035=>{:code=>"405035", :pref=>"福岡県", :name=>"大刀洗町", :type=>"町", :district=>"九州地方", :furigana=>"たちあらいまち"},
      405221=>{:code=>"405221", :pref=>"福岡県", :name=>"大木町", :type=>"町", :district=>"九州地方", :furigana=>"おおきまち"},
      405442=>{:code=>"405442", :pref=>"福岡県", :name=>"広川町", :type=>"町", :district=>"九州地方", :furigana=>"ひろかわまち"},
      406015=>{:code=>"406015", :pref=>"福岡県", :name=>"香春町", :type=>"町", :district=>"九州地方", :furigana=>"かわらまち"},
      406023=>{:code=>"406023", :pref=>"福岡県", :name=>"添田町", :type=>"町", :district=>"九州地方", :furigana=>"そえだまち"},
      406040=>{:code=>"406040", :pref=>"福岡県", :name=>"糸田町", :type=>"町", :district=>"九州地方", :furigana=>"いとだまち"},
      406058=>{:code=>"406058", :pref=>"福岡県", :name=>"川崎町", :type=>"町", :district=>"九州地方", :furigana=>"かわさきまち"},
      406082=>{:code=>"406082", :pref=>"福岡県", :name=>"大任町", :type=>"町", :district=>"九州地方", :furigana=>"おおとうまち"},
      406091=>{:code=>"406091", :pref=>"福岡県", :name=>"赤村", :type=>"村", :district=>"九州地方", :furigana=>"あかむら"},
      406104=>{:code=>"406104", :pref=>"福岡県", :name=>"福智町", :type=>"町", :district=>"九州地方", :furigana=>"ふくちまち"},
      406210=>{:code=>"406210", :pref=>"福岡県", :name=>"苅田町", :type=>"町", :district=>"九州地方", :furigana=>"かんだまち"},
      406252=>{:code=>"406252", :pref=>"福岡県", :name=>"みやこ町", :type=>"町", :district=>"九州地方", :furigana=>"みやこまち"},
      406422=>{:code=>"406422", :pref=>"福岡県", :name=>"吉富町", :type=>"町", :district=>"九州地方", :furigana=>"よしとみまち"},
      406465=>{:code=>"406465", :pref=>"福岡県", :name=>"上毛町", :type=>"町", :district=>"九州地方", :furigana=>"こうげまち"},
      406473=>{:code=>"406473", :pref=>"福岡県", :name=>"築上町", :type=>"町", :district=>"九州地方", :furigana=>"ちくじょうまち"},
      410004=>{:code=>"410004", :pref=>"佐賀県", :name=>"佐賀県", :type=>"都道府県", :district=>"九州地方", :furigana=>"さがけん"},
      412015=>{:code=>"412015", :pref=>"佐賀県", :name=>"佐賀市", :type=>"市", :district=>"九州地方", :furigana=>"さがし"},
      412023=>{:code=>"412023", :pref=>"佐賀県", :name=>"唐津市", :type=>"市", :district=>"九州地方", :furigana=>"からつし"},
      412031=>{:code=>"412031", :pref=>"佐賀県", :name=>"鳥栖市", :type=>"市", :district=>"九州地方", :furigana=>"とすし"},
      412040=>{:code=>"412040", :pref=>"佐賀県", :name=>"多久市", :type=>"市", :district=>"九州地方", :furigana=>"たくし"},
      412058=>{:code=>"412058", :pref=>"佐賀県", :name=>"伊万里市", :type=>"市", :district=>"九州地方", :furigana=>"いまりし"},
      412066=>{:code=>"412066", :pref=>"佐賀県", :name=>"武雄市", :type=>"市", :district=>"九州地方", :furigana=>"たけおし"},
      412074=>{:code=>"412074", :pref=>"佐賀県", :name=>"鹿島市", :type=>"市", :district=>"九州地方", :furigana=>"かしまし"},
      412082=>{:code=>"412082", :pref=>"佐賀県", :name=>"小城市", :type=>"市", :district=>"九州地方", :furigana=>"おぎし"},
      412091=>{:code=>"412091", :pref=>"佐賀県", :name=>"嬉野市", :type=>"市", :district=>"九州地方", :furigana=>"うれしのし"},
      412104=>{:code=>"412104", :pref=>"佐賀県", :name=>"神埼市", :type=>"市", :district=>"九州地方", :furigana=>"かんざきし"},
      413275=>{:code=>"413275", :pref=>"佐賀県", :name=>"吉野ヶ里町", :type=>"町", :district=>"九州地方", :furigana=>"よしのがりちょう"},
      413411=>{:code=>"413411", :pref=>"佐賀県", :name=>"基山町", :type=>"町", :district=>"九州地方", :furigana=>"きやまちょう"},
      413453=>{:code=>"413453", :pref=>"佐賀県", :name=>"上峰町", :type=>"町", :district=>"九州地方", :furigana=>"かみみねちょう"},
      413461=>{:code=>"413461", :pref=>"佐賀県", :name=>"みやき町", :type=>"町", :district=>"九州地方", :furigana=>"みやきちょう"},
      413879=>{:code=>"413879", :pref=>"佐賀県", :name=>"玄海町", :type=>"町", :district=>"九州地方", :furigana=>"げんかいちょう"},
      414018=>{:code=>"414018", :pref=>"佐賀県", :name=>"有田町", :type=>"町", :district=>"九州地方", :furigana=>"ありたちょう"},
      414239=>{:code=>"414239", :pref=>"佐賀県", :name=>"大町町", :type=>"町", :district=>"九州地方", :furigana=>"おおまちちょう"},
      414247=>{:code=>"414247", :pref=>"佐賀県", :name=>"江北町", :type=>"町", :district=>"九州地方", :furigana=>"こうほくまち"},
      414255=>{:code=>"414255", :pref=>"佐賀県", :name=>"白石町", :type=>"町", :district=>"九州地方", :furigana=>"しろいしちょう"},
      414417=>{:code=>"414417", :pref=>"佐賀県", :name=>"太良町", :type=>"町", :district=>"九州地方", :furigana=>"たらちょう"},
      420000=>{:code=>"420000", :pref=>"長崎県", :name=>"長崎県", :type=>"都道府県", :district=>"九州地方", :furigana=>"ながさきけん"},
      422011=>{:code=>"422011", :pref=>"長崎県", :name=>"長崎市", :type=>"市", :district=>"九州地方", :furigana=>"ながさきし"},
      422029=>{:code=>"422029", :pref=>"長崎県", :name=>"佐世保市", :type=>"市", :district=>"九州地方", :furigana=>"させぼし"},
      422037=>{:code=>"422037", :pref=>"長崎県", :name=>"島原市", :type=>"市", :district=>"九州地方", :furigana=>"しまばらし"},
      422045=>{:code=>"422045", :pref=>"長崎県", :name=>"諫早市", :type=>"市", :district=>"九州地方", :furigana=>"いさはやし"},
      422053=>{:code=>"422053", :pref=>"長崎県", :name=>"大村市", :type=>"市", :district=>"九州地方", :furigana=>"おおむらし"},
      422070=>{:code=>"422070", :pref=>"長崎県", :name=>"平戸市", :type=>"市", :district=>"九州地方", :furigana=>"ひらどし"},
      422088=>{:code=>"422088", :pref=>"長崎県", :name=>"松浦市", :type=>"市", :district=>"九州地方", :furigana=>"まつうらし"},
      422096=>{:code=>"422096", :pref=>"長崎県", :name=>"対馬市", :type=>"市", :district=>"九州地方", :furigana=>"つしまし"},
      422100=>{:code=>"422100", :pref=>"長崎県", :name=>"壱岐市", :type=>"市", :district=>"九州地方", :furigana=>"いきし"},
      422118=>{:code=>"422118", :pref=>"長崎県", :name=>"五島市", :type=>"市", :district=>"九州地方", :furigana=>"ごとうし"},
      422126=>{:code=>"422126", :pref=>"長崎県", :name=>"西海市", :type=>"市", :district=>"九州地方", :furigana=>"さいかいし"},
      422134=>{:code=>"422134", :pref=>"長崎県", :name=>"雲仙市", :type=>"市", :district=>"九州地方", :furigana=>"うんぜんし"},
      422142=>{:code=>"422142", :pref=>"長崎県", :name=>"南島原市", :type=>"市", :district=>"九州地方", :furigana=>"みなみしまばらし"},
      423076=>{:code=>"423076", :pref=>"長崎県", :name=>"長与町", :type=>"町", :district=>"九州地方", :furigana=>"ながよちょう"},
      423084=>{:code=>"423084", :pref=>"長崎県", :name=>"時津町", :type=>"町", :district=>"九州地方", :furigana=>"とぎつちょう"},
      423211=>{:code=>"423211", :pref=>"長崎県", :name=>"東彼杵町", :type=>"町", :district=>"九州地方", :furigana=>"ひがしそのぎちょう"},
      423220=>{:code=>"423220", :pref=>"長崎県", :name=>"川棚町", :type=>"町", :district=>"九州地方", :furigana=>"かわたなちょう"},
      423238=>{:code=>"423238", :pref=>"長崎県", :name=>"波佐見町", :type=>"町", :district=>"九州地方", :furigana=>"はさみちょう"},
      423831=>{:code=>"423831", :pref=>"長崎県", :name=>"小値賀町", :type=>"町", :district=>"九州地方", :furigana=>"おぢかちょう"},
      423912=>{:code=>"423912", :pref=>"長崎県", :name=>"佐々町", :type=>"町", :district=>"九州地方", :furigana=>"さざちょう"},
      424111=>{:code=>"424111", :pref=>"長崎県", :name=>"新上五島町", :type=>"町", :district=>"九州地方", :furigana=>"しんかみごとうちょう"},
      430005=>{:code=>"430005", :pref=>"熊本県", :name=>"熊本県", :type=>"都道府県", :district=>"九州地方", :furigana=>"くまもとけん"},
      431001=>{:code=>"431001", :pref=>"熊本県", :name=>"熊本市", :type=>"政令市", :district=>"九州地方", :furigana=>"くまもとし"},
      431010=>{:code=>"431010", :pref=>"熊本県", :name=>"熊本市中央区", :type=>"行政区", :district=>"九州地方", :furigana=>"くまもとしちゅうおうく"},
      431028=>{:code=>"431028", :pref=>"熊本県", :name=>"熊本市東区", :type=>"行政区", :district=>"九州地方", :furigana=>"くまもとしひがしく"},
      431036=>{:code=>"431036", :pref=>"熊本県", :name=>"熊本市西区", :type=>"行政区", :district=>"九州地方", :furigana=>"くまもとしにしく"},
      431044=>{:code=>"431044", :pref=>"熊本県", :name=>"熊本市南区", :type=>"行政区", :district=>"九州地方", :furigana=>"くまもとしみなみく"},
      431052=>{:code=>"431052", :pref=>"熊本県", :name=>"熊本市北区", :type=>"行政区", :district=>"九州地方", :furigana=>"くまもとしきたく"},
      432024=>{:code=>"432024", :pref=>"熊本県", :name=>"八代市", :type=>"市", :district=>"九州地方", :furigana=>"やつしろし"},
      432032=>{:code=>"432032", :pref=>"熊本県", :name=>"人吉市", :type=>"市", :district=>"九州地方", :furigana=>"ひとよしし"},
      432041=>{:code=>"432041", :pref=>"熊本県", :name=>"荒尾市", :type=>"市", :district=>"九州地方", :furigana=>"あらおし"},
      432059=>{:code=>"432059", :pref=>"熊本県", :name=>"水俣市", :type=>"市", :district=>"九州地方", :furigana=>"みなまたし"},
      432067=>{:code=>"432067", :pref=>"熊本県", :name=>"玉名市", :type=>"市", :district=>"九州地方", :furigana=>"たまなし"},
      432083=>{:code=>"432083", :pref=>"熊本県", :name=>"山鹿市", :type=>"市", :district=>"九州地方", :furigana=>"やまがし"},
      432105=>{:code=>"432105", :pref=>"熊本県", :name=>"菊池市", :type=>"市", :district=>"九州地方", :furigana=>"きくちし"},
      432113=>{:code=>"432113", :pref=>"熊本県", :name=>"宇土市", :type=>"市", :district=>"九州地方", :furigana=>"うとし"},
      432121=>{:code=>"432121", :pref=>"熊本県", :name=>"上天草市", :type=>"市", :district=>"九州地方", :furigana=>"かみあまくさし"},
      432130=>{:code=>"432130", :pref=>"熊本県", :name=>"宇城市", :type=>"市", :district=>"九州地方", :furigana=>"うきし"},
      432148=>{:code=>"432148", :pref=>"熊本県", :name=>"阿蘇市", :type=>"市", :district=>"九州地方", :furigana=>"あそし"},
      432156=>{:code=>"432156", :pref=>"熊本県", :name=>"天草市", :type=>"市", :district=>"九州地方", :furigana=>"あまくさし"},
      432164=>{:code=>"432164", :pref=>"熊本県", :name=>"合志市", :type=>"市", :district=>"九州地方", :furigana=>"こうしし"},
      433489=>{:code=>"433489", :pref=>"熊本県", :name=>"美里町", :type=>"町", :district=>"九州地方", :furigana=>"みさとまち"},
      433641=>{:code=>"433641", :pref=>"熊本県", :name=>"玉東町", :type=>"町", :district=>"九州地方", :furigana=>"ぎょくとうまち"},
      433675=>{:code=>"433675", :pref=>"熊本県", :name=>"南関町", :type=>"町", :district=>"九州地方", :furigana=>"なんかんまち"},
      433683=>{:code=>"433683", :pref=>"熊本県", :name=>"長洲町", :type=>"町", :district=>"九州地方", :furigana=>"ながすまち"},
      433691=>{:code=>"433691", :pref=>"熊本県", :name=>"和水町", :type=>"町", :district=>"九州地方", :furigana=>"なごみまち"},
      434035=>{:code=>"434035", :pref=>"熊本県", :name=>"大津町", :type=>"町", :district=>"九州地方", :furigana=>"おおづまち"},
      434043=>{:code=>"434043", :pref=>"熊本県", :name=>"菊陽町", :type=>"町", :district=>"九州地方", :furigana=>"きくようまち"},
      434230=>{:code=>"434230", :pref=>"熊本県", :name=>"南小国町", :type=>"町", :district=>"九州地方", :furigana=>"みなみおぐにまち"},
      434248=>{:code=>"434248", :pref=>"熊本県", :name=>"小国町", :type=>"町", :district=>"九州地方", :furigana=>"おぐにまち"},
      434256=>{:code=>"434256", :pref=>"熊本県", :name=>"産山村", :type=>"村", :district=>"九州地方", :furigana=>"うぶやまむら"},
      434281=>{:code=>"434281", :pref=>"熊本県", :name=>"高森町", :type=>"町", :district=>"九州地方", :furigana=>"たかもりまち"},
      434329=>{:code=>"434329", :pref=>"熊本県", :name=>"西原村", :type=>"村", :district=>"九州地方", :furigana=>"にしはらむら"},
      434337=>{:code=>"434337", :pref=>"熊本県", :name=>"南阿蘇村", :type=>"村", :district=>"九州地方", :furigana=>"みなみあそむら"},
      434418=>{:code=>"434418", :pref=>"熊本県", :name=>"御船町", :type=>"町", :district=>"九州地方", :furigana=>"みふねまち"},
      434426=>{:code=>"434426", :pref=>"熊本県", :name=>"嘉島町", :type=>"町", :district=>"九州地方", :furigana=>"かしままち"},
      434434=>{:code=>"434434", :pref=>"熊本県", :name=>"益城町", :type=>"町", :district=>"九州地方", :furigana=>"ましきまち"},
      434442=>{:code=>"434442", :pref=>"熊本県", :name=>"甲佐町", :type=>"町", :district=>"九州地方", :furigana=>"こうさまち"},
      434477=>{:code=>"434477", :pref=>"熊本県", :name=>"山都町", :type=>"町", :district=>"九州地方", :furigana=>"やまとちょう"},
      434680=>{:code=>"434680", :pref=>"熊本県", :name=>"氷川町", :type=>"町", :district=>"九州地方", :furigana=>"ひかわちょう"},
      434825=>{:code=>"434825", :pref=>"熊本県", :name=>"芦北町", :type=>"町", :district=>"九州地方", :furigana=>"あしきたまち"},
      434841=>{:code=>"434841", :pref=>"熊本県", :name=>"津奈木町", :type=>"町", :district=>"九州地方", :furigana=>"つなぎまち"},
      435015=>{:code=>"435015", :pref=>"熊本県", :name=>"錦町", :type=>"町", :district=>"九州地方", :furigana=>"にしきまち"},
      435058=>{:code=>"435058", :pref=>"熊本県", :name=>"多良木町", :type=>"町", :district=>"九州地方", :furigana=>"たらぎまち"},
      435066=>{:code=>"435066", :pref=>"熊本県", :name=>"湯前町", :type=>"町", :district=>"九州地方", :furigana=>"ゆのまえまち"},
      435074=>{:code=>"435074", :pref=>"熊本県", :name=>"水上村", :type=>"村", :district=>"九州地方", :furigana=>"みずかみむら"},
      435104=>{:code=>"435104", :pref=>"熊本県", :name=>"相良村", :type=>"村", :district=>"九州地方", :furigana=>"さがらむら"},
      435112=>{:code=>"435112", :pref=>"熊本県", :name=>"五木村", :type=>"村", :district=>"九州地方", :furigana=>"いつきむら"},
      435121=>{:code=>"435121", :pref=>"熊本県", :name=>"山江村", :type=>"村", :district=>"九州地方", :furigana=>"やまえむら"},
      435139=>{:code=>"435139", :pref=>"熊本県", :name=>"球磨村", :type=>"村", :district=>"九州地方", :furigana=>"くまむら"},
      435147=>{:code=>"435147", :pref=>"熊本県", :name=>"あさぎり町", :type=>"町", :district=>"九州地方", :furigana=>"あさぎりちょう"},
      435317=>{:code=>"435317", :pref=>"熊本県", :name=>"苓北町", :type=>"町", :district=>"九州地方", :furigana=>"れいほくまち"},
      440001=>{:code=>"440001", :pref=>"大分県", :name=>"大分県", :type=>"都道府県", :district=>"九州地方", :furigana=>"おおいたけん"},
      442011=>{:code=>"442011", :pref=>"大分県", :name=>"大分市", :type=>"市", :district=>"九州地方", :furigana=>"おおいたし"},
      442020=>{:code=>"442020", :pref=>"大分県", :name=>"別府市", :type=>"市", :district=>"九州地方", :furigana=>"べっぷし"},
      442038=>{:code=>"442038", :pref=>"大分県", :name=>"中津市", :type=>"市", :district=>"九州地方", :furigana=>"なかつし"},
      442046=>{:code=>"442046", :pref=>"大分県", :name=>"日田市", :type=>"市", :district=>"九州地方", :furigana=>"ひたし"},
      442054=>{:code=>"442054", :pref=>"大分県", :name=>"佐伯市", :type=>"市", :district=>"九州地方", :furigana=>"さいきし"},
      442062=>{:code=>"442062", :pref=>"大分県", :name=>"臼杵市", :type=>"市", :district=>"九州地方", :furigana=>"うすきし"},
      442071=>{:code=>"442071", :pref=>"大分県", :name=>"津久見市", :type=>"市", :district=>"九州地方", :furigana=>"つくみし"},
      442089=>{:code=>"442089", :pref=>"大分県", :name=>"竹田市", :type=>"市", :district=>"九州地方", :furigana=>"たけたし"},
      442097=>{:code=>"442097", :pref=>"大分県", :name=>"豊後高田市", :type=>"市", :district=>"九州地方", :furigana=>"ぶんごたかだし"},
      442101=>{:code=>"442101", :pref=>"大分県", :name=>"杵築市", :type=>"市", :district=>"九州地方", :furigana=>"きつきし"},
      442119=>{:code=>"442119", :pref=>"大分県", :name=>"宇佐市", :type=>"市", :district=>"九州地方", :furigana=>"うさし"},
      442127=>{:code=>"442127", :pref=>"大分県", :name=>"豊後大野市", :type=>"市", :district=>"九州地方", :furigana=>"ぶんごおおのし"},
      442135=>{:code=>"442135", :pref=>"大分県", :name=>"由布市", :type=>"市", :district=>"九州地方", :furigana=>"ゆふし"},
      442143=>{:code=>"442143", :pref=>"大分県", :name=>"国東市", :type=>"市", :district=>"九州地方", :furigana=>"くにさきし"},
      443221=>{:code=>"443221", :pref=>"大分県", :name=>"姫島村", :type=>"村", :district=>"九州地方", :furigana=>"ひめしまむら"},
      443417=>{:code=>"443417", :pref=>"大分県", :name=>"日出町", :type=>"町", :district=>"九州地方", :furigana=>"ひじまち"},
      444618=>{:code=>"444618", :pref=>"大分県", :name=>"九重町", :type=>"町", :district=>"九州地方", :furigana=>"ここのえまち"},
      444626=>{:code=>"444626", :pref=>"大分県", :name=>"玖珠町", :type=>"町", :district=>"九州地方", :furigana=>"くすまち"},
      450006=>{:code=>"450006", :pref=>"宮崎県", :name=>"宮崎県", :type=>"都道府県", :district=>"九州地方", :furigana=>"みやざきけん"},
      452017=>{:code=>"452017", :pref=>"宮崎県", :name=>"宮崎市", :type=>"市", :district=>"九州地方", :furigana=>"みやざきし"},
      452025=>{:code=>"452025", :pref=>"宮崎県", :name=>"都城市", :type=>"市", :district=>"九州地方", :furigana=>"みやこのじょうし"},
      452033=>{:code=>"452033", :pref=>"宮崎県", :name=>"延岡市", :type=>"市", :district=>"九州地方", :furigana=>"のべおかし"},
      452041=>{:code=>"452041", :pref=>"宮崎県", :name=>"日南市", :type=>"市", :district=>"九州地方", :furigana=>"にちなんし"},
      452050=>{:code=>"452050", :pref=>"宮崎県", :name=>"小林市", :type=>"市", :district=>"九州地方", :furigana=>"こばやしし"},
      452068=>{:code=>"452068", :pref=>"宮崎県", :name=>"日向市", :type=>"市", :district=>"九州地方", :furigana=>"ひゅうがし"},
      452076=>{:code=>"452076", :pref=>"宮崎県", :name=>"串間市", :type=>"市", :district=>"九州地方", :furigana=>"くしまし"},
      452084=>{:code=>"452084", :pref=>"宮崎県", :name=>"西都市", :type=>"市", :district=>"九州地方", :furigana=>"さいとし"},
      452092=>{:code=>"452092", :pref=>"宮崎県", :name=>"えびの市", :type=>"市", :district=>"九州地方", :furigana=>"えびのし"},
      453412=>{:code=>"453412", :pref=>"宮崎県", :name=>"三股町", :type=>"町", :district=>"九州地方", :furigana=>"みまたちょう"},
      453617=>{:code=>"453617", :pref=>"宮崎県", :name=>"高原町", :type=>"町", :district=>"九州地方", :furigana=>"たかはるちょう"},
      453820=>{:code=>"453820", :pref=>"宮崎県", :name=>"国富町", :type=>"町", :district=>"九州地方", :furigana=>"くにとみちょう"},
      453838=>{:code=>"453838", :pref=>"宮崎県", :name=>"綾町", :type=>"町", :district=>"九州地方", :furigana=>"あやちょう"},
      454010=>{:code=>"454010", :pref=>"宮崎県", :name=>"高鍋町", :type=>"町", :district=>"九州地方", :furigana=>"たかなべちょう"},
      454028=>{:code=>"454028", :pref=>"宮崎県", :name=>"新富町", :type=>"町", :district=>"九州地方", :furigana=>"しんとみちょう"},
      454036=>{:code=>"454036", :pref=>"宮崎県", :name=>"西米良村", :type=>"村", :district=>"九州地方", :furigana=>"にしめらそん"},
      454044=>{:code=>"454044", :pref=>"宮崎県", :name=>"木城町", :type=>"町", :district=>"九州地方", :furigana=>"きじょうちょう"},
      454052=>{:code=>"454052", :pref=>"宮崎県", :name=>"川南町", :type=>"町", :district=>"九州地方", :furigana=>"かわみなみちょう"},
      454061=>{:code=>"454061", :pref=>"宮崎県", :name=>"都農町", :type=>"町", :district=>"九州地方", :furigana=>"つのちょう"},
      454214=>{:code=>"454214", :pref=>"宮崎県", :name=>"門川町", :type=>"町", :district=>"九州地方", :furigana=>"かどがわちょう"},
      454290=>{:code=>"454290", :pref=>"宮崎県", :name=>"諸塚村", :type=>"村", :district=>"九州地方", :furigana=>"もろつかそん"},
      454303=>{:code=>"454303", :pref=>"宮崎県", :name=>"椎葉村", :type=>"村", :district=>"九州地方", :furigana=>"しいばそん"},
      454311=>{:code=>"454311", :pref=>"宮崎県", :name=>"美郷町", :type=>"町", :district=>"九州地方", :furigana=>"みさとちょう"},
      454419=>{:code=>"454419", :pref=>"宮崎県", :name=>"高千穂町", :type=>"町", :district=>"九州地方", :furigana=>"たかちほちょう"},
      454427=>{:code=>"454427", :pref=>"宮崎県", :name=>"日之影町", :type=>"町", :district=>"九州地方", :furigana=>"ひのかげちょう"},
      454435=>{:code=>"454435", :pref=>"宮崎県", :name=>"五ヶ瀬町", :type=>"町", :district=>"九州地方", :furigana=>"ごかせちょう"},
      460001=>{:code=>"460001", :pref=>"鹿児島県", :name=>"鹿児島県", :type=>"都道府県", :district=>"九州地方", :furigana=>"かごしまけん"},
      462012=>{:code=>"462012", :pref=>"鹿児島県", :name=>"鹿児島市", :type=>"市", :district=>"九州地方", :furigana=>"かごしまし"},
      462039=>{:code=>"462039", :pref=>"鹿児島県", :name=>"鹿屋市", :type=>"市", :district=>"九州地方", :furigana=>"かのやし"},
      462047=>{:code=>"462047", :pref=>"鹿児島県", :name=>"枕崎市", :type=>"市", :district=>"九州地方", :furigana=>"まくらざきし"},
      462063=>{:code=>"462063", :pref=>"鹿児島県", :name=>"阿久根市", :type=>"市", :district=>"九州地方", :furigana=>"あくねし"},
      462080=>{:code=>"462080", :pref=>"鹿児島県", :name=>"出水市", :type=>"市", :district=>"九州地方", :furigana=>"いずみし"},
      462101=>{:code=>"462101", :pref=>"鹿児島県", :name=>"指宿市", :type=>"市", :district=>"九州地方", :furigana=>"いぶすきし"},
      462136=>{:code=>"462136", :pref=>"鹿児島県", :name=>"西之表市", :type=>"市", :district=>"九州地方", :furigana=>"にしのおもてし"},
      462144=>{:code=>"462144", :pref=>"鹿児島県", :name=>"垂水市", :type=>"市", :district=>"九州地方", :furigana=>"たるみずし"},
      462152=>{:code=>"462152", :pref=>"鹿児島県", :name=>"薩摩川内市", :type=>"市", :district=>"九州地方", :furigana=>"さつませんだいし"},
      462161=>{:code=>"462161", :pref=>"鹿児島県", :name=>"日置市", :type=>"市", :district=>"九州地方", :furigana=>"ひおきし"},
      462179=>{:code=>"462179", :pref=>"鹿児島県", :name=>"曽於市", :type=>"市", :district=>"九州地方", :furigana=>"そおし"},
      462187=>{:code=>"462187", :pref=>"鹿児島県", :name=>"霧島市", :type=>"市", :district=>"九州地方", :furigana=>"きりしまし"},
      462195=>{:code=>"462195", :pref=>"鹿児島県", :name=>"いちき串木野市", :type=>"市", :district=>"九州地方", :furigana=>"いちきくしきのし"},
      462209=>{:code=>"462209", :pref=>"鹿児島県", :name=>"南さつま市", :type=>"市", :district=>"九州地方", :furigana=>"みなみさつまし"},
      462217=>{:code=>"462217", :pref=>"鹿児島県", :name=>"志布志市", :type=>"市", :district=>"九州地方", :furigana=>"しぶしし"},
      462225=>{:code=>"462225", :pref=>"鹿児島県", :name=>"奄美市", :type=>"市", :district=>"九州地方", :furigana=>"あまみし"},
      462233=>{:code=>"462233", :pref=>"鹿児島県", :name=>"南九州市", :type=>"市", :district=>"九州地方", :furigana=>"みなみきゅうしゅうし"},
      462241=>{:code=>"462241", :pref=>"鹿児島県", :name=>"伊佐市", :type=>"市", :district=>"九州地方", :furigana=>"いさし"},
      462250=>{:code=>"462250", :pref=>"鹿児島県", :name=>"姶良市", :type=>"市", :district=>"九州地方", :furigana=>"あいらし"},
      463035=>{:code=>"463035", :pref=>"鹿児島県", :name=>"三島村", :type=>"村", :district=>"九州地方", :furigana=>"みしまむら"},
      463043=>{:code=>"463043", :pref=>"鹿児島県", :name=>"十島村", :type=>"村", :district=>"九州地方", :furigana=>"としまむら"},
      463922=>{:code=>"463922", :pref=>"鹿児島県", :name=>"さつま町", :type=>"町", :district=>"九州地方", :furigana=>"さつまちょう"},
      464040=>{:code=>"464040", :pref=>"鹿児島県", :name=>"長島町", :type=>"町", :district=>"九州地方", :furigana=>"ながしまちょう"},
      464520=>{:code=>"464520", :pref=>"鹿児島県", :name=>"湧水町", :type=>"町", :district=>"九州地方", :furigana=>"ゆうすいちょう"},
      464686=>{:code=>"464686", :pref=>"鹿児島県", :name=>"大崎町", :type=>"町", :district=>"九州地方", :furigana=>"おおさきちょう"},
      464821=>{:code=>"464821", :pref=>"鹿児島県", :name=>"東串良町", :type=>"町", :district=>"九州地方", :furigana=>"ひがしくしらちょう"},
      464902=>{:code=>"464902", :pref=>"鹿児島県", :name=>"錦江町", :type=>"町", :district=>"九州地方", :furigana=>"きんこうちょう"},
      464911=>{:code=>"464911", :pref=>"鹿児島県", :name=>"南大隅町", :type=>"町", :district=>"九州地方", :furigana=>"みなみおおすみちょう"},
      464929=>{:code=>"464929", :pref=>"鹿児島県", :name=>"肝付町", :type=>"町", :district=>"九州地方", :furigana=>"きもつきちょう"},
      465011=>{:code=>"465011", :pref=>"鹿児島県", :name=>"中種子町", :type=>"町", :district=>"九州地方", :furigana=>"なかたねちょう"},
      465020=>{:code=>"465020", :pref=>"鹿児島県", :name=>"南種子町", :type=>"町", :district=>"九州地方", :furigana=>"みなみたねちょう"},
      465054=>{:code=>"465054", :pref=>"鹿児島県", :name=>"屋久島町", :type=>"町", :district=>"九州地方", :furigana=>"やくしまちょう"},
      465232=>{:code=>"465232", :pref=>"鹿児島県", :name=>"大和村", :type=>"村", :district=>"九州地方", :furigana=>"やまとそん"},
      465241=>{:code=>"465241", :pref=>"鹿児島県", :name=>"宇検村", :type=>"村", :district=>"九州地方", :furigana=>"うけんそん"},
      465259=>{:code=>"465259", :pref=>"鹿児島県", :name=>"瀬戸内町", :type=>"町", :district=>"九州地方", :furigana=>"せとうちちょう"},
      465275=>{:code=>"465275", :pref=>"鹿児島県", :name=>"龍郷町", :type=>"町", :district=>"九州地方", :furigana=>"たつごうちょう"},
      465291=>{:code=>"465291", :pref=>"鹿児島県", :name=>"喜界町", :type=>"町", :district=>"九州地方", :furigana=>"きかいちょう"},
      465305=>{:code=>"465305", :pref=>"鹿児島県", :name=>"徳之島町", :type=>"町", :district=>"九州地方", :furigana=>"とくのしまちょう"},
      465313=>{:code=>"465313", :pref=>"鹿児島県", :name=>"天城町", :type=>"町", :district=>"九州地方", :furigana=>"あまぎちょう"},
      465321=>{:code=>"465321", :pref=>"鹿児島県", :name=>"伊仙町", :type=>"町", :district=>"九州地方", :furigana=>"いせんちょう"},
      465330=>{:code=>"465330", :pref=>"鹿児島県", :name=>"和泊町", :type=>"町", :district=>"九州地方", :furigana=>"わどまりちょう"},
      465348=>{:code=>"465348", :pref=>"鹿児島県", :name=>"知名町", :type=>"町", :district=>"九州地方", :furigana=>"ちなちょう"},
      465356=>{:code=>"465356", :pref=>"鹿児島県", :name=>"与論町", :type=>"町", :district=>"九州地方", :furigana=>"よろんちょう"},
      470007=>{:code=>"470007", :pref=>"沖縄県", :name=>"沖縄県", :type=>"都道府県", :district=>"九州地方", :furigana=>"おきなわけん"},
      472018=>{:code=>"472018", :pref=>"沖縄県", :name=>"那覇市", :type=>"市", :district=>"九州地方", :furigana=>"なはし"},
      472051=>{:code=>"472051", :pref=>"沖縄県", :name=>"宜野湾市", :type=>"市", :district=>"九州地方", :furigana=>"ぎのわんし"},
      472077=>{:code=>"472077", :pref=>"沖縄県", :name=>"石垣市", :type=>"市", :district=>"九州地方", :furigana=>"いしがきし"},
      472085=>{:code=>"472085", :pref=>"沖縄県", :name=>"浦添市", :type=>"市", :district=>"九州地方", :furigana=>"うらそえし"},
      472093=>{:code=>"472093", :pref=>"沖縄県", :name=>"名護市", :type=>"市", :district=>"九州地方", :furigana=>"なごし"},
      472107=>{:code=>"472107", :pref=>"沖縄県", :name=>"糸満市", :type=>"市", :district=>"九州地方", :furigana=>"いとまんし"},
      472115=>{:code=>"472115", :pref=>"沖縄県", :name=>"沖縄市", :type=>"市", :district=>"九州地方", :furigana=>"おきなわし"},
      472123=>{:code=>"472123", :pref=>"沖縄県", :name=>"豊見城市", :type=>"市", :district=>"九州地方", :furigana=>"とみぐすくし"},
      472131=>{:code=>"472131", :pref=>"沖縄県", :name=>"うるま市", :type=>"市", :district=>"九州地方", :furigana=>"うるまし"},
      472140=>{:code=>"472140", :pref=>"沖縄県", :name=>"宮古島市", :type=>"市", :district=>"九州地方", :furigana=>"みやこじまし"},
      472158=>{:code=>"472158", :pref=>"沖縄県", :name=>"南城市", :type=>"市", :district=>"九州地方", :furigana=>"なんじょうし"},
      473014=>{:code=>"473014", :pref=>"沖縄県", :name=>"国頭村", :type=>"村", :district=>"九州地方", :furigana=>"くにがみそん"},
      473022=>{:code=>"473022", :pref=>"沖縄県", :name=>"大宜味村", :type=>"村", :district=>"九州地方", :furigana=>"おおぎみそん"},
      473031=>{:code=>"473031", :pref=>"沖縄県", :name=>"東村", :type=>"村", :district=>"九州地方", :furigana=>"ひがしそん"},
      473065=>{:code=>"473065", :pref=>"沖縄県", :name=>"今帰仁村", :type=>"村", :district=>"九州地方", :furigana=>"なきじんそん"},
      473081=>{:code=>"473081", :pref=>"沖縄県", :name=>"本部町", :type=>"町", :district=>"九州地方", :furigana=>"もとぶちょう"},
      473111=>{:code=>"473111", :pref=>"沖縄県", :name=>"恩納村", :type=>"村", :district=>"九州地方", :furigana=>"おんなそん"},
      473138=>{:code=>"473138", :pref=>"沖縄県", :name=>"宜野座村", :type=>"村", :district=>"九州地方", :furigana=>"ぎのざそん"},
      473146=>{:code=>"473146", :pref=>"沖縄県", :name=>"金武町", :type=>"町", :district=>"九州地方", :furigana=>"きんちょう"},
      473154=>{:code=>"473154", :pref=>"沖縄県", :name=>"伊江村", :type=>"村", :district=>"九州地方", :furigana=>"いえそん"},
      473243=>{:code=>"473243", :pref=>"沖縄県", :name=>"読谷村", :type=>"村", :district=>"九州地方", :furigana=>"よみたんそん"},
      473251=>{:code=>"473251", :pref=>"沖縄県", :name=>"嘉手納町", :type=>"町", :district=>"九州地方", :furigana=>"かでなちょう"},
      473260=>{:code=>"473260", :pref=>"沖縄県", :name=>"北谷町", :type=>"町", :district=>"九州地方", :furigana=>"ちやたんちょう"},
      473278=>{:code=>"473278", :pref=>"沖縄県", :name=>"北中城村", :type=>"村", :district=>"九州地方", :furigana=>"きたなかぐすくそん"},
      473286=>{:code=>"473286", :pref=>"沖縄県", :name=>"中城村", :type=>"村", :district=>"九州地方", :furigana=>"なかぐすくそん"},
      473294=>{:code=>"473294", :pref=>"沖縄県", :name=>"西原町", :type=>"町", :district=>"九州地方", :furigana=>"にしはらちょう"},
      473481=>{:code=>"473481", :pref=>"沖縄県", :name=>"与那原町", :type=>"町", :district=>"九州地方", :furigana=>"よなばるちょう"},
      473502=>{:code=>"473502", :pref=>"沖縄県", :name=>"南風原町", :type=>"町", :district=>"九州地方", :furigana=>"はえばるちょう"},
      473537=>{:code=>"473537", :pref=>"沖縄県", :name=>"渡嘉敷村", :type=>"村", :district=>"九州地方", :furigana=>"とかしきそん"},
      473545=>{:code=>"473545", :pref=>"沖縄県", :name=>"座間味村", :type=>"村", :district=>"九州地方", :furigana=>"ざまみそん"},
      473553=>{:code=>"473553", :pref=>"沖縄県", :name=>"粟国村", :type=>"村", :district=>"九州地方", :furigana=>"あぐにそん"},
      473561=>{:code=>"473561", :pref=>"沖縄県", :name=>"渡名喜村", :type=>"村", :district=>"九州地方", :furigana=>"となきそん"},
      473570=>{:code=>"473570", :pref=>"沖縄県", :name=>"南大東村", :type=>"村", :district=>"九州地方", :furigana=>"みなみだいとうそん"},
      473588=>{:code=>"473588", :pref=>"沖縄県", :name=>"北大東村", :type=>"村", :district=>"九州地方", :furigana=>"きただいとうそん"},
      473596=>{:code=>"473596", :pref=>"沖縄県", :name=>"伊平屋村", :type=>"村", :district=>"九州地方", :furigana=>"いへやそん"},
      473600=>{:code=>"473600", :pref=>"沖縄県", :name=>"伊是名村", :type=>"村", :district=>"九州地方", :furigana=>"いぜなそん"},
      473618=>{:code=>"473618", :pref=>"沖縄県", :name=>"久米島町", :type=>"町", :district=>"九州地方", :furigana=>"くめじまちょう"},
      473626=>{:code=>"473626", :pref=>"沖縄県", :name=>"八重瀬町", :type=>"町", :district=>"九州地方", :furigana=>"やえせちょう"},
      473758=>{:code=>"473758", :pref=>"沖縄県", :name=>"多良間村", :type=>"村", :district=>"九州地方", :furigana=>"たらまそん"},
      473812=>{:code=>"473812", :pref=>"沖縄県", :name=>"竹富町", :type=>"町", :district=>"九州地方", :furigana=>"たけとみちょう"},
      473821=>{:code=>"473821", :pref=>"沖縄県", :name=>"与那国町", :type=>"町", :district=>"九州地方", :furigana=>"よなぐにちょう"},
    }
    # 地方自治体の名前でデータを引くためインデックス 都道府県、自治体名でコードを取得できる
    GOV_DATA_NAME_INDEX={
      '北海道'=>{
        '北海道'=>10006,
        '札幌市'=>11002,
        '札幌市中央区'=>11011,
        '札幌市北区'=>11029,
        '札幌市東区'=>11037,
        '札幌市白石区'=>11045,
        '札幌市豊平区'=>11053,
        '札幌市南区'=>11061,
        '札幌市西区'=>11070,
        '札幌市厚別区'=>11088,
        '札幌市手稲区'=>11096,
        '札幌市清田区'=>11100,
        '函館市'=>12025,
        '小樽市'=>12033,
        '旭川市'=>12041,
        '室蘭市'=>12050,
        '釧路市'=>12068,
        '帯広市'=>12076,
        '北見市'=>12084,
        '夕張市'=>12092,
        '岩見沢市'=>12106,
        '網走市'=>12114,
        '留萌市'=>12122,
        '苫小牧市'=>12131,
        '稚内市'=>12149,
        '美唄市'=>12157,
        '芦別市'=>12165,
        '江別市'=>12173,
        '赤平市'=>12181,
        '紋別市'=>12190,
        '士別市'=>12203,
        '名寄市'=>12211,
        '三笠市'=>12220,
        '根室市'=>12238,
        '千歳市'=>12246,
        '滝川市'=>12254,
        '砂川市'=>12262,
        '歌志内市'=>12271,
        '深川市'=>12289,
        '富良野市'=>12297,
        '登別市'=>12301,
        '恵庭市'=>12319,
        '伊達市'=>12335,
        '北広島市'=>12343,
        '石狩市'=>12351,
        '北斗市'=>12360,
        '当別町'=>13030,
        '新篠津村'=>13048,
        '松前町'=>13315,
        '福島町'=>13323,
        '知内町'=>13331,
        '木古内町'=>13340,
        '七飯町'=>13374,
        '鹿部町'=>13439,
        '森町'=>13455,
        '八雲町'=>13463,
        '長万部町'=>13471,
        '江差町'=>13617,
        '上ノ国町'=>13625,
        '厚沢部町'=>13633,
        '乙部町'=>13641,
        '奥尻町'=>13676,
        '今金町'=>13706,
        'せたな町'=>13714,
        '島牧村'=>13919,
        '寿都町'=>13927,
        '黒松内町'=>13935,
        '蘭越町'=>13943,
        'ニセコ町'=>13951,
        '真狩村'=>13960,
        '留寿都村'=>13978,
        '喜茂別町'=>13986,
        '京極町'=>13994,
        '倶知安町'=>14001,
        '共和町'=>14010,
        '岩内町'=>14028,
        '泊村'=>14036,
        '神恵内村'=>14044,
        '積丹町'=>14052,
        '古平町'=>14061,
        '仁木町'=>14079,
        '余市町'=>14087,
        '赤井川村'=>14095,
        '南幌町'=>14231,
        '奈井江町'=>14249,
        '上砂川町'=>14257,
        '由仁町'=>14273,
        '長沼町'=>14281,
        '栗山町'=>14290,
        '月形町'=>14303,
        '浦臼町'=>14311,
        '新十津川町'=>14320,
        '妹背牛町'=>14338,
        '秩父別町'=>14346,
        '雨竜町'=>14362,
        '北竜町'=>14371,
        '沼田町'=>14389,
        '鷹栖町'=>14524,
        '東神楽町'=>14532,
        '当麻町'=>14541,
        '比布町'=>14559,
        '愛別町'=>14567,
        '上川町'=>14575,
        '東川町'=>14583,
        '美瑛町'=>14591,
        '上富良野町'=>14605,
        '中富良野町'=>14613,
        '南富良野町'=>14621,
        '占冠村'=>14630,
        '和寒町'=>14648,
        '剣淵町'=>14656,
        '下川町'=>14681,
        '美深町'=>14699,
        '音威子府村'=>14702,
        '中川町'=>14711,
        '幌加内町'=>14729,
        '増毛町'=>14818,
        '小平町'=>14826,
        '苫前町'=>14834,
        '羽幌町'=>14842,
        '初山別村'=>14851,
        '遠別町'=>14869,
        '天塩町'=>14877,
        '猿払村'=>15113,
        '浜頓別町'=>15121,
        '中頓別町'=>15130,
        '枝幸町'=>15148,
        '豊富町'=>15164,
        '礼文町'=>15172,
        '利尻町'=>15181,
        '利尻富士町'=>15199,
        '幌延町'=>15202,
        '美幌町'=>15431,
        '津別町'=>15440,
        '斜里町'=>15458,
        '清里町'=>15466,
        '小清水町'=>15474,
        '訓子府町'=>15491,
        '置戸町'=>15504,
        '佐呂間町'=>15521,
        '遠軽町'=>15555,
        '湧別町'=>15598,
        '滝上町'=>15601,
        '興部町'=>15610,
        '西興部村'=>15628,
        '雄武町'=>15636,
        '大空町'=>15644,
        '豊浦町'=>15717,
        '壮瞥町'=>15750,
        '白老町'=>15784,
        '厚真町'=>15814,
        '洞爺湖町'=>15849,
        '安平町'=>15857,
        'むかわ町'=>15865,
        '日高町'=>16012,
        '平取町'=>16021,
        '新冠町'=>16047,
        '浦河町'=>16071,
        '様似町'=>16080,
        'えりも町'=>16098,
        '新ひだか町'=>16101,
        '音更町'=>16314,
        '士幌町'=>16322,
        '上士幌町'=>16331,
        '鹿追町'=>16349,
        '新得町'=>16357,
        '清水町'=>16365,
        '芽室町'=>16373,
        '中札内村'=>16381,
        '更別村'=>16390,
        '大樹町'=>16411,
        '広尾町'=>16420,
        '幕別町'=>16438,
        '池田町'=>16446,
        '豊頃町'=>16454,
        '本別町'=>16462,
        '足寄町'=>16471,
        '陸別町'=>16489,
        '浦幌町'=>16497,
        '釧路町'=>16616,
        '厚岸町'=>16624,
        '浜中町'=>16632,
        '標茶町'=>16641,
        '弟子屈町'=>16659,
        '鶴居村'=>16675,
        '白糠町'=>16683,
        '別海町'=>16918,
        '中標津町'=>16926,
        '標津町'=>16934,
        '羅臼町'=>16942,
      },
      '青森県'=>{
        '青森県'=>20001,
        '青森市'=>22012,
        '弘前市'=>22021,
        '八戸市'=>22039,
        '黒石市'=>22047,
        '五所川原市'=>22055,
        '十和田市'=>22063,
        '三沢市'=>22071,
        'むつ市'=>22080,
        'つがる市'=>22098,
        '平川市'=>22101,
        '平内町'=>23019,
        '今別町'=>23035,
        '蓬田村'=>23043,
        '外ヶ浜町'=>23078,
        '鰺ヶ沢町'=>23213,
        '深浦町'=>23230,
        '西目屋村'=>23434,
        '藤崎町'=>23612,
        '大鰐町'=>23621,
        '田舎館村'=>23671,
        '板柳町'=>23817,
        '鶴田町'=>23841,
        '中泊町'=>23876,
        '野辺地町'=>24015,
        '七戸町'=>24023,
        '六戸町'=>24058,
        '横浜町'=>24066,
        '東北町'=>24082,
        '六ヶ所村'=>24112,
        'おいらせ町'=>24121,
        '大間町'=>24236,
        '東通村'=>24244,
        '風間浦村'=>24252,
        '佐井村'=>24261,
        '三戸町'=>24414,
        '五戸町'=>24422,
        '田子町'=>24431,
        '南部町'=>24457,
        '階上町'=>24465,
        '新郷村'=>24503,
      },
      '岩手県'=>{
        '岩手県'=>30007,
        '盛岡市'=>32018,
        '宮古市'=>32026,
        '大船渡市'=>32034,
        '花巻市'=>32051,
        '北上市'=>32069,
        '久慈市'=>32077,
        '遠野市'=>32085,
        '一関市'=>32093,
        '陸前高田市'=>32107,
        '釜石市'=>32115,
        '二戸市'=>32131,
        '八幡平市'=>32140,
        '奥州市'=>32158,
        '滝沢市'=>32166,
        '雫石町'=>33014,
        '葛巻町'=>33022,
        '岩手町'=>33031,
        '紫波町'=>33219,
        '矢巾町'=>33227,
        '西和賀町'=>33669,
        '金ケ崎町'=>33812,
        '平泉町'=>34029,
        '住田町'=>34410,
        '大槌町'=>34614,
        '山田町'=>34827,
        '岩泉町'=>34835,
        '田野畑村'=>34843,
        '普代村'=>34851,
        '軽米町'=>35017,
        '野田村'=>35033,
        '九戸村'=>35068,
        '洋野町'=>35076,
        '一戸町'=>35246,
      },
      '宮城県'=>{
        '宮城県'=>40002,
        '仙台市'=>41009,
        '仙台市青葉区'=>41017,
        '仙台市宮城野区'=>41025,
        '仙台市若林区'=>41033,
        '仙台市太白区'=>41041,
        '仙台市泉区'=>41050,
        '石巻市'=>42021,
        '塩竈市'=>42030,
        '気仙沼市'=>42056,
        '白石市'=>42064,
        '名取市'=>42072,
        '角田市'=>42081,
        '多賀城市'=>42099,
        '岩沼市'=>42111,
        '登米市'=>42129,
        '栗原市'=>42137,
        '東松島市'=>42145,
        '大崎市'=>42153,
        '富谷市'=>42161,
        '蔵王町'=>43010,
        '七ヶ宿町'=>43028,
        '大河原町'=>43214,
        '村田町'=>43222,
        '柴田町'=>43231,
        '川崎町'=>43249,
        '丸森町'=>43419,
        '亘理町'=>43613,
        '山元町'=>43621,
        '松島町'=>44016,
        '七ヶ浜町'=>44041,
        '利府町'=>44067,
        '大和町'=>44211,
        '大郷町'=>44229,
        '大衡村'=>44245,
        '色麻町'=>44440,
        '加美町'=>44458,
        '涌谷町'=>45012,
        '美里町'=>45055,
        '女川町'=>45811,
        '南三陸町'=>46060,
      },
      '秋田県'=>{
        '秋田県'=>50008,
        '秋田市'=>52019,
        '能代市'=>52027,
        '横手市'=>52035,
        '大館市'=>52043,
        '男鹿市'=>52060,
        '湯沢市'=>52078,
        '鹿角市'=>52094,
        '由利本荘市'=>52108,
        '潟上市'=>52116,
        '大仙市'=>52124,
        '北秋田市'=>52132,
        'にかほ市'=>52141,
        '仙北市'=>52159,
        '小坂町'=>53031,
        '上小阿仁村'=>53279,
        '藤里町'=>53465,
        '三種町'=>53481,
        '八峰町'=>53490,
        '五城目町'=>53619,
        '八郎潟町'=>53635,
        '井川町'=>53660,
        '大潟村'=>53686,
        '美郷町'=>54348,
        '羽後町'=>54631,
        '東成瀬村'=>54640,
      },
      '山形県'=>{
        '山形県'=>60003,
        '山形市'=>62014,
        '米沢市'=>62022,
        '鶴岡市'=>62031,
        '酒田市'=>62049,
        '新庄市'=>62057,
        '寒河江市'=>62065,
        '上山市'=>62073,
        '村山市'=>62081,
        '長井市'=>62090,
        '天童市'=>62103,
        '東根市'=>62111,
        '尾花沢市'=>62120,
        '南陽市'=>62138,
        '山辺町'=>63011,
        '中山町'=>63029,
        '河北町'=>63215,
        '西川町'=>63223,
        '朝日町'=>63231,
        '大江町'=>63240,
        '大石田町'=>63410,
        '金山町'=>63614,
        '最上町'=>63622,
        '舟形町'=>63631,
        '真室川町'=>63649,
        '大蔵村'=>63657,
        '鮭川村'=>63665,
        '戸沢村'=>63673,
        '高畠町'=>63819,
        '川西町'=>63827,
        '小国町'=>64017,
        '白鷹町'=>64025,
        '飯豊町'=>64033,
        '三川町'=>64262,
        '庄内町'=>64289,
        '遊佐町'=>64611,
      },
      '福島県'=>{
        '福島県'=>70009,
        '福島市'=>72010,
        '会津若松市'=>72028,
        '郡山市'=>72036,
        'いわき市'=>72044,
        '白河市'=>72052,
        '須賀川市'=>72079,
        '喜多方市'=>72087,
        '相馬市'=>72095,
        '二本松市'=>72109,
        '田村市'=>72117,
        '南相馬市'=>72125,
        '伊達市'=>72133,
        '本宮市'=>72141,
        '桑折町'=>73016,
        '国見町'=>73032,
        '川俣町'=>73083,
        '大玉村'=>73229,
        '鏡石町'=>73423,
        '天栄村'=>73440,
        '下郷町'=>73628,
        '檜枝岐村'=>73644,
        '只見町'=>73679,
        '南会津町'=>73687,
        '北塩原村'=>74021,
        '西会津町'=>74055,
        '磐梯町'=>74071,
        '猪苗代町'=>74080,
        '会津坂下町'=>74217,
        '湯川村'=>74225,
        '柳津町'=>74233,
        '三島町'=>74446,
        '金山町'=>74454,
        '昭和村'=>74462,
        '会津美里町'=>74471,
        '西郷村'=>74616,
        '泉崎村'=>74641,
        '中島村'=>74659,
        '矢吹町'=>74667,
        '棚倉町'=>74811,
        '矢祭町'=>74829,
        '塙町'=>74837,
        '鮫川村'=>74845,
        '石川町'=>75019,
        '玉川村'=>75027,
        '平田村'=>75035,
        '浅川町'=>75043,
        '古殿町'=>75051,
        '三春町'=>75213,
        '小野町'=>75221,
        '広野町'=>75418,
        '楢葉町'=>75426,
        '富岡町'=>75434,
        '川内村'=>75442,
        '大熊町'=>75451,
        '双葉町'=>75469,
        '浪江町'=>75477,
        '葛尾村'=>75485,
        '新地町'=>75612,
        '飯舘村'=>75647,
      },
      '茨城県'=>{
        '茨城県'=>80004,
        '水戸市'=>82015,
        '日立市'=>82023,
        '土浦市'=>82031,
        '古河市'=>82040,
        '石岡市'=>82058,
        '結城市'=>82074,
        '龍ケ崎市'=>82082,
        '下妻市'=>82104,
        '常総市'=>82112,
        '常陸太田市'=>82121,
        '高萩市'=>82147,
        '北茨城市'=>82155,
        '笠間市'=>82163,
        '取手市'=>82171,
        '牛久市'=>82198,
        'つくば市'=>82201,
        'ひたちなか市'=>82210,
        '鹿嶋市'=>82228,
        '潮来市'=>82236,
        '守谷市'=>82244,
        '常陸大宮市'=>82252,
        '那珂市'=>82261,
        '筑西市'=>82279,
        '坂東市'=>82287,
        '稲敷市'=>82295,
        'かすみがうら市'=>82309,
        '桜川市'=>82317,
        '神栖市'=>82325,
        '行方市'=>82333,
        '鉾田市'=>82341,
        'つくばみらい市'=>82350,
        '小美玉市'=>82368,
        '茨城町'=>83020,
        '大洗町'=>83097,
        '城里町'=>83101,
        '東海村'=>83411,
        '大子町'=>83640,
        '美浦村'=>84425,
        '阿見町'=>84433,
        '河内町'=>84476,
        '八千代町'=>85219,
        '五霞町'=>85421,
        '境町'=>85464,
        '利根町'=>85642,
      },
      '栃木県'=>{
        '栃木県'=>90000,
        '宇都宮市'=>92011,
        '足利市'=>92029,
        '栃木市'=>92037,
        '佐野市'=>92045,
        '鹿沼市'=>92053,
        '日光市'=>92061,
        '小山市'=>92088,
        '真岡市'=>92096,
        '大田原市'=>92100,
        '矢板市'=>92118,
        '那須塩原市'=>92134,
        'さくら市'=>92142,
        '那須烏山市'=>92151,
        '下野市'=>92169,
        '上三川町'=>93017,
        '益子町'=>93424,
        '茂木町'=>93432,
        '市貝町'=>93441,
        '芳賀町'=>93459,
        '壬生町'=>93611,
        '野木町'=>93645,
        '塩谷町'=>93840,
        '高根沢町'=>93866,
        '那須町'=>94072,
        '那珂川町'=>94111,
      },
      '群馬県'=>{
        '群馬県'=>100005,
        '前橋市'=>102016,
        '高崎市'=>102024,
        '桐生市'=>102032,
        '伊勢崎市'=>102041,
        '太田市'=>102059,
        '沼田市'=>102067,
        '館林市'=>102075,
        '渋川市'=>102083,
        '藤岡市'=>102091,
        '富岡市'=>102105,
        '安中市'=>102113,
        'みどり市'=>102121,
        '榛東村'=>103446,
        '吉岡町'=>103454,
        '上野村'=>103667,
        '神流町'=>103675,
        '下仁田町'=>103829,
        '南牧村'=>103837,
        '甘楽町'=>103845,
        '中之条町'=>104213,
        '長野原町'=>104248,
        '嬬恋村'=>104256,
        '草津町'=>104264,
        '高山村'=>104281,
        '東吾妻町'=>104299,
        '片品村'=>104434,
        '川場村'=>104442,
        '昭和村'=>104485,
        'みなかみ町'=>104493,
        '玉村町'=>104647,
        '板倉町'=>105210,
        '明和町'=>105228,
        '千代田町'=>105236,
        '大泉町'=>105244,
        '邑楽町'=>105252,
      },
      '埼玉県'=>{
        '埼玉県'=>110001,
        'さいたま市'=>111007,
        'さいたま市西区'=>111015,
        'さいたま市北区'=>111023,
        'さいたま市大宮区'=>111031,
        'さいたま市見沼区'=>111040,
        'さいたま市中央区'=>111058,
        'さいたま市桜区'=>111066,
        'さいたま市浦和区'=>111074,
        'さいたま市南区'=>111082,
        'さいたま市緑区'=>111091,
        'さいたま市岩槻区'=>111104,
        '川越市'=>112011,
        '熊谷市'=>112020,
        '川口市'=>112038,
        '行田市'=>112062,
        '秩父市'=>112071,
        '所沢市'=>112089,
        '飯能市'=>112097,
        '加須市'=>112101,
        '本庄市'=>112119,
        '東松山市'=>112127,
        '春日部市'=>112143,
        '狭山市'=>112151,
        '羽生市'=>112160,
        '鴻巣市'=>112178,
        '深谷市'=>112186,
        '上尾市'=>112194,
        '草加市'=>112216,
        '越谷市'=>112224,
        '蕨市'=>112232,
        '戸田市'=>112241,
        '入間市'=>112259,
        '朝霞市'=>112275,
        '志木市'=>112283,
        '和光市'=>112291,
        '新座市'=>112305,
        '桶川市'=>112313,
        '久喜市'=>112321,
        '北本市'=>112330,
        '八潮市'=>112348,
        '富士見市'=>112356,
        '三郷市'=>112372,
        '蓮田市'=>112381,
        '坂戸市'=>112399,
        '幸手市'=>112402,
        '鶴ヶ島市'=>112411,
        '日高市'=>112429,
        '吉川市'=>112437,
        'ふじみ野市'=>112453,
        '白岡市'=>112461,
        '伊奈町'=>113018,
        '三芳町'=>113247,
        '毛呂山町'=>113263,
        '越生町'=>113271,
        '滑川町'=>113417,
        '嵐山町'=>113425,
        '小川町'=>113433,
        '川島町'=>113468,
        '吉見町'=>113476,
        '鳩山町'=>113484,
        'ときがわ町'=>113492,
        '横瀬町'=>113611,
        '皆野町'=>113620,
        '長瀞町'=>113638,
        '小鹿野町'=>113654,
        '東秩父村'=>113697,
        '美里町'=>113816,
        '神川町'=>113832,
        '上里町'=>113859,
        '寄居町'=>114081,
        '宮代町'=>114421,
        '杉戸町'=>114642,
        '松伏町'=>114651,
      },
      '千葉県'=>{
        '千葉県'=>120006,
        '千葉市'=>121002,
        '千葉市中央区'=>121011,
        '千葉市花見川区'=>121029,
        '千葉市稲毛区'=>121037,
        '千葉市若葉区'=>121045,
        '千葉市緑区'=>121053,
        '千葉市美浜区'=>121061,
        '銚子市'=>122025,
        '市川市'=>122033,
        '船橋市'=>122041,
        '館山市'=>122050,
        '木更津市'=>122068,
        '松戸市'=>122076,
        '野田市'=>122084,
        '茂原市'=>122106,
        '成田市'=>122114,
        '佐倉市'=>122122,
        '東金市'=>122131,
        '旭市'=>122157,
        '習志野市'=>122165,
        '柏市'=>122173,
        '勝浦市'=>122181,
        '市原市'=>122190,
        '流山市'=>122203,
        '八千代市'=>122211,
        '我孫子市'=>122220,
        '鴨川市'=>122238,
        '鎌ケ谷市'=>122246,
        '君津市'=>122254,
        '富津市'=>122262,
        '浦安市'=>122271,
        '四街道市'=>122289,
        '袖ケ浦市'=>122297,
        '八街市'=>122301,
        '印西市'=>122319,
        '白井市'=>122327,
        '富里市'=>122335,
        '南房総市'=>122343,
        '匝瑳市'=>122351,
        '香取市'=>122360,
        '山武市'=>122378,
        'いすみ市'=>122386,
        '大網白里市'=>122394,
        '酒々井町'=>123226,
        '栄町'=>123293,
        '神崎町'=>123421,
        '多古町'=>123471,
        '東庄町'=>123498,
        '九十九里町'=>124036,
        '芝山町'=>124095,
        '横芝光町'=>124109,
        '一宮町'=>124214,
        '睦沢町'=>124222,
        '長生村'=>124231,
        '白子町'=>124249,
        '長柄町'=>124265,
        '長南町'=>124273,
        '大多喜町'=>124419,
        '御宿町'=>124435,
        '鋸南町'=>124630,
      },
      '東京都'=>{
        '東京都'=>130001,
        '千代田区'=>131016,
        '中央区'=>131024,
        '港区'=>131032,
        '新宿区'=>131041,
        '文京区'=>131059,
        '台東区'=>131067,
        '墨田区'=>131075,
        '江東区'=>131083,
        '品川区'=>131091,
        '目黒区'=>131105,
        '大田区'=>131113,
        '世田谷区'=>131121,
        '渋谷区'=>131130,
        '中野区'=>131148,
        '杉並区'=>131156,
        '豊島区'=>131164,
        '北区'=>131172,
        '荒川区'=>131181,
        '板橋区'=>131199,
        '練馬区'=>131202,
        '足立区'=>131211,
        '葛飾区'=>131229,
        '江戸川区'=>131237,
        '八王子市'=>132012,
        '立川市'=>132021,
        '武蔵野市'=>132039,
        '三鷹市'=>132047,
        '青梅市'=>132055,
        '府中市'=>132063,
        '昭島市'=>132071,
        '調布市'=>132080,
        '町田市'=>132098,
        '小金井市'=>132101,
        '小平市'=>132110,
        '日野市'=>132128,
        '東村山市'=>132136,
        '国分寺市'=>132144,
        '国立市'=>132152,
        '福生市'=>132187,
        '狛江市'=>132195,
        '東大和市'=>132209,
        '清瀬市'=>132217,
        '東久留米市'=>132225,
        '武蔵村山市'=>132233,
        '多摩市'=>132241,
        '稲城市'=>132250,
        '羽村市'=>132276,
        'あきる野市'=>132284,
        '西東京市'=>132292,
        '瑞穂町'=>133035,
        '日の出町'=>133051,
        '檜原村'=>133078,
        '奥多摩町'=>133086,
        '大島町'=>133612,
        '利島村'=>133621,
        '新島村'=>133639,
        '神津島村'=>133647,
        '三宅村'=>133817,
        '御蔵島村'=>133825,
        '八丈町'=>134015,
        '青ヶ島村'=>134023,
        '小笠原村'=>134210,
      },
      '神奈川県'=>{
        '神奈川県'=>140007,
        '横浜市'=>141003,
        '横浜市鶴見区'=>141011,
        '横浜市神奈川区'=>141020,
        '横浜市西区'=>141038,
        '横浜市中区'=>141046,
        '横浜市南区'=>141054,
        '横浜市保土ケ谷区'=>141062,
        '横浜市磯子区'=>141071,
        '横浜市金沢区'=>141089,
        '横浜市港北区'=>141097,
        '横浜市戸塚区'=>141101,
        '横浜市港南区'=>141119,
        '横浜市旭区'=>141127,
        '横浜市緑区'=>141135,
        '横浜市瀬谷区'=>141143,
        '横浜市栄区'=>141151,
        '横浜市泉区'=>141160,
        '横浜市青葉区'=>141178,
        '横浜市都筑区'=>141186,
        '川崎市'=>141305,
        '川崎市川崎区'=>141313,
        '川崎市幸区'=>141321,
        '川崎市中原区'=>141330,
        '川崎市高津区'=>141348,
        '川崎市多摩区'=>141356,
        '川崎市宮前区'=>141364,
        '川崎市麻生区'=>141372,
        '相模原市'=>141500,
        '相模原市緑区'=>141518,
        '相模原市中央区'=>141526,
        '相模原市南区'=>141534,
        '横須賀市'=>142018,
        '平塚市'=>142034,
        '鎌倉市'=>142042,
        '藤沢市'=>142051,
        '小田原市'=>142069,
        '茅ヶ崎市'=>142077,
        '逗子市'=>142085,
        '三浦市'=>142107,
        '秦野市'=>142115,
        '厚木市'=>142123,
        '大和市'=>142131,
        '伊勢原市'=>142140,
        '海老名市'=>142158,
        '座間市'=>142166,
        '南足柄市'=>142174,
        '綾瀬市'=>142182,
        '葉山町'=>143014,
        '寒川町'=>143219,
        '大磯町'=>143413,
        '二宮町'=>143421,
        '中井町'=>143618,
        '大井町'=>143626,
        '松田町'=>143634,
        '山北町'=>143642,
        '開成町'=>143669,
        '箱根町'=>143821,
        '真鶴町'=>143839,
        '湯河原町'=>143847,
        '愛川町'=>144011,
        '清川村'=>144029,
      },
      '新潟県'=>{
        '新潟県'=>150002,
        '新潟市'=>151009,
        '新潟市北区'=>151017,
        '新潟市東区'=>151025,
        '新潟市中央区'=>151033,
        '新潟市江南区'=>151041,
        '新潟市秋葉区'=>151050,
        '新潟市南区'=>151068,
        '新潟市西区'=>151076,
        '新潟市西蒲区'=>151084,
        '長岡市'=>152021,
        '三条市'=>152048,
        '柏崎市'=>152056,
        '新発田市'=>152064,
        '小千谷市'=>152081,
        '加茂市'=>152099,
        '十日町市'=>152102,
        '見附市'=>152111,
        '村上市'=>152129,
        '燕市'=>152137,
        '糸魚川市'=>152161,
        '妙高市'=>152170,
        '五泉市'=>152188,
        '上越市'=>152226,
        '阿賀野市'=>152234,
        '佐渡市'=>152242,
        '魚沼市'=>152251,
        '南魚沼市'=>152269,
        '胎内市'=>152277,
        '聖籠町'=>153079,
        '弥彦村'=>153427,
        '田上町'=>153613,
        '阿賀町'=>153851,
        '出雲崎町'=>154059,
        '湯沢町'=>154610,
        '津南町'=>154822,
        '刈羽村'=>155047,
        '関川村'=>155811,
        '粟島浦村'=>155861,
      },
      '富山県'=>{
        '富山県'=>160008,
        '富山市'=>162019,
        '高岡市'=>162027,
        '魚津市'=>162043,
        '氷見市'=>162051,
        '滑川市'=>162060,
        '黒部市'=>162078,
        '砺波市'=>162086,
        '小矢部市'=>162094,
        '南砺市'=>162108,
        '射水市'=>162116,
        '舟橋村'=>163210,
        '上市町'=>163228,
        '立山町'=>163236,
        '入善町'=>163422,
        '朝日町'=>163431,
      },
      '石川県'=>{
        '石川県'=>170003,
        '金沢市'=>172014,
        '七尾市'=>172022,
        '小松市'=>172031,
        '輪島市'=>172049,
        '珠洲市'=>172057,
        '加賀市'=>172065,
        '羽咋市'=>172073,
        'かほく市'=>172090,
        '白山市'=>172103,
        '能美市'=>172111,
        '野々市市'=>172120,
        '川北町'=>173240,
        '津幡町'=>173614,
        '内灘町'=>173657,
        '志賀町'=>173843,
        '宝達志水町'=>173860,
        '中能登町'=>174076,
        '穴水町'=>174611,
        '能登町'=>174637,
      },
      '福井県'=>{
        '福井県'=>180009,
        '福井市'=>182010,
        '敦賀市'=>182028,
        '小浜市'=>182044,
        '大野市'=>182052,
        '勝山市'=>182061,
        '鯖江市'=>182079,
        'あわら市'=>182087,
        '越前市'=>182095,
        '坂井市'=>182109,
        '永平寺町'=>183229,
        '池田町'=>183822,
        '南越前町'=>184047,
        '越前町'=>184233,
        '美浜町'=>184420,
        '高浜町'=>184811,
        'おおい町'=>184837,
        '若狭町'=>185019,
      },
      '山梨県'=>{
        '山梨県'=>190004,
        '甲府市'=>192015,
        '富士吉田市'=>192023,
        '都留市'=>192040,
        '山梨市'=>192058,
        '大月市'=>192066,
        '韮崎市'=>192074,
        '南アルプス市'=>192082,
        '北杜市'=>192091,
        '甲斐市'=>192104,
        '笛吹市'=>192112,
        '上野原市'=>192121,
        '甲州市'=>192139,
        '中央市'=>192147,
        '市川三郷町'=>193461,
        '早川町'=>193640,
        '身延町'=>193658,
        '南部町'=>193666,
        '富士川町'=>193682,
        '昭和町'=>193844,
        '道志村'=>194221,
        '西桂町'=>194239,
        '忍野村'=>194247,
        '山中湖村'=>194255,
        '鳴沢村'=>194298,
        '富士河口湖町'=>194301,
        '小菅村'=>194425,
        '丹波山村'=>194433,
      },
      '長野県'=>{
        '長野県'=>200000,
        '長野市'=>202011,
        '松本市'=>202029,
        '上田市'=>202037,
        '岡谷市'=>202045,
        '飯田市'=>202053,
        '諏訪市'=>202061,
        '須坂市'=>202070,
        '小諸市'=>202088,
        '伊那市'=>202096,
        '駒ヶ根市'=>202100,
        '中野市'=>202118,
        '大町市'=>202126,
        '飯山市'=>202134,
        '茅野市'=>202142,
        '塩尻市'=>202151,
        '佐久市'=>202177,
        '千曲市'=>202185,
        '東御市'=>202193,
        '安曇野市'=>202207,
        '小海町'=>203033,
        '川上村'=>203041,
        '南牧村'=>203050,
        '南相木村'=>203068,
        '北相木村'=>203076,
        '佐久穂町'=>203092,
        '軽井沢町'=>203211,
        '御代田町'=>203238,
        '立科町'=>203246,
        '青木村'=>203491,
        '長和町'=>203505,
        '下諏訪町'=>203611,
        '富士見町'=>203629,
        '原村'=>203637,
        '辰野町'=>203823,
        '箕輪町'=>203831,
        '飯島町'=>203840,
        '南箕輪村'=>203858,
        '中川村'=>203866,
        '宮田村'=>203882,
        '松川町'=>204021,
        '高森町'=>204030,
        '阿南町'=>204048,
        '阿智村'=>204072,
        '平谷村'=>204099,
        '根羽村'=>204102,
        '下條村'=>204111,
        '売木村'=>204129,
        '天龍村'=>204137,
        '泰阜村'=>204145,
        '喬木村'=>204153,
        '豊丘村'=>204161,
        '大鹿村'=>204170,
        '上松町'=>204226,
        '南木曽町'=>204234,
        '木祖村'=>204251,
        '王滝村'=>204293,
        '大桑村'=>204307,
        '木曽町'=>204323,
        '麻績村'=>204463,
        '生坂村'=>204480,
        '山形村'=>204501,
        '朝日村'=>204510,
        '筑北村'=>204528,
        '池田町'=>204811,
        '松川村'=>204820,
        '白馬村'=>204854,
        '小谷村'=>204862,
        '坂城町'=>205214,
        '小布施町'=>205419,
        '高山村'=>205435,
        '山ノ内町'=>205613,
        '木島平村'=>205621,
        '野沢温泉村'=>205630,
        '信濃町'=>205834,
        '小川村'=>205885,
        '飯綱町'=>205907,
        '栄村'=>206024,
      },
      '岐阜県'=>{
        '岐阜県'=>210005,
        '岐阜市'=>212016,
        '大垣市'=>212024,
        '高山市'=>212032,
        '多治見市'=>212041,
        '関市'=>212059,
        '中津川市'=>212067,
        '美濃市'=>212075,
        '瑞浪市'=>212083,
        '羽島市'=>212091,
        '恵那市'=>212105,
        '美濃加茂市'=>212113,
        '土岐市'=>212121,
        '各務原市'=>212130,
        '可児市'=>212148,
        '山県市'=>212156,
        '瑞穂市'=>212164,
        '飛騨市'=>212172,
        '本巣市'=>212181,
        '郡上市'=>212199,
        '下呂市'=>212202,
        '海津市'=>212211,
        '岐南町'=>213021,
        '笠松町'=>213039,
        '養老町'=>213411,
        '垂井町'=>213616,
        '関ケ原町'=>213624,
        '神戸町'=>213811,
        '輪之内町'=>213829,
        '安八町'=>213837,
        '揖斐川町'=>214019,
        '大野町'=>214035,
        '池田町'=>214043,
        '北方町'=>214213,
        '坂祝町'=>215015,
        '富加町'=>215023,
        '川辺町'=>215031,
        '七宗町'=>215040,
        '八百津町'=>215058,
        '白川町'=>215066,
        '東白川村'=>215074,
        '御嵩町'=>215210,
        '白川村'=>216046,
      },
      '静岡県'=>{
        '静岡県'=>220001,
        '静岡市'=>221007,
        '静岡市葵区'=>221015,
        '静岡市駿河区'=>221023,
        '静岡市清水区'=>221031,
        '浜松市'=>221309,
        '浜松市中区'=>221317,
        '浜松市東区'=>221325,
        '浜松市西区'=>221333,
        '浜松市南区'=>221341,
        '浜松市北区'=>221350,
        '浜松市浜北区'=>221368,
        '浜松市天竜区'=>221376,
        '沼津市'=>222038,
        '熱海市'=>222054,
        '三島市'=>222062,
        '富士宮市'=>222071,
        '伊東市'=>222089,
        '島田市'=>222097,
        '富士市'=>222101,
        '磐田市'=>222119,
        '焼津市'=>222127,
        '掛川市'=>222135,
        '藤枝市'=>222143,
        '御殿場市'=>222151,
        '袋井市'=>222160,
        '下田市'=>222194,
        '裾野市'=>222208,
        '湖西市'=>222216,
        '伊豆市'=>222224,
        '御前崎市'=>222232,
        '菊川市'=>222241,
        '伊豆の国市'=>222259,
        '牧之原市'=>222267,
        '東伊豆町'=>223018,
        '河津町'=>223026,
        '南伊豆町'=>223042,
        '松崎町'=>223051,
        '西伊豆町'=>223069,
        '函南町'=>223255,
        '清水町'=>223417,
        '長泉町'=>223425,
        '小山町'=>223441,
        '吉田町'=>224243,
        '川根本町'=>224294,
        '森町'=>224618,
      },
      '愛知県'=>{
        '愛知県'=>230006,
        '名古屋市'=>231002,
        '名古屋市千種区'=>231011,
        '名古屋市東区'=>231029,
        '名古屋市北区'=>231037,
        '名古屋市西区'=>231045,
        '名古屋市中村区'=>231053,
        '名古屋市中区'=>231061,
        '名古屋市昭和区'=>231070,
        '名古屋市瑞穂区'=>231088,
        '名古屋市熱田区'=>231096,
        '名古屋市中川区'=>231100,
        '名古屋市港区'=>231118,
        '名古屋市南区'=>231126,
        '名古屋市守山区'=>231134,
        '名古屋市緑区'=>231142,
        '名古屋市名東区'=>231151,
        '名古屋市天白区'=>231169,
        '豊橋市'=>232017,
        '岡崎市'=>232025,
        '一宮市'=>232033,
        '瀬戸市'=>232041,
        '半田市'=>232050,
        '春日井市'=>232068,
        '豊川市'=>232076,
        '津島市'=>232084,
        '碧南市'=>232092,
        '刈谷市'=>232106,
        '豊田市'=>232114,
        '安城市'=>232122,
        '西尾市'=>232131,
        '蒲郡市'=>232149,
        '犬山市'=>232157,
        '常滑市'=>232165,
        '江南市'=>232173,
        '小牧市'=>232190,
        '稲沢市'=>232203,
        '新城市'=>232211,
        '東海市'=>232220,
        '大府市'=>232238,
        '知多市'=>232246,
        '知立市'=>232254,
        '尾張旭市'=>232262,
        '高浜市'=>232271,
        '岩倉市'=>232289,
        '豊明市'=>232297,
        '日進市'=>232301,
        '田原市'=>232319,
        '愛西市'=>232327,
        '清須市'=>232335,
        '北名古屋市'=>232343,
        '弥富市'=>232351,
        'みよし市'=>232360,
        'あま市'=>232378,
        '長久手市'=>232386,
        '東郷町'=>233021,
        '豊山町'=>233421,
        '大口町'=>233617,
        '扶桑町'=>233625,
        '大治町'=>234249,
        '蟹江町'=>234257,
        '飛島村'=>234273,
        '阿久比町'=>234419,
        '東浦町'=>234427,
        '南知多町'=>234451,
        '美浜町'=>234460,
        '武豊町'=>234478,
        '幸田町'=>235016,
        '設楽町'=>235610,
        '東栄町'=>235628,
        '豊根村'=>235636,
      },
      '三重県'=>{
        '三重県'=>240001,
        '津市'=>242012,
        '四日市市'=>242021,
        '伊勢市'=>242039,
        '松阪市'=>242047,
        '桑名市'=>242055,
        '鈴鹿市'=>242071,
        '名張市'=>242080,
        '尾鷲市'=>242098,
        '亀山市'=>242101,
        '鳥羽市'=>242110,
        '熊野市'=>242128,
        'いなべ市'=>242144,
        '志摩市'=>242152,
        '伊賀市'=>242161,
        '木曽岬町'=>243035,
        '東員町'=>243248,
        '菰野町'=>243418,
        '朝日町'=>243434,
        '川越町'=>243442,
        '多気町'=>244414,
        '明和町'=>244422,
        '大台町'=>244431,
        '玉城町'=>244619,
        '度会町'=>244708,
        '大紀町'=>244716,
        '南伊勢町'=>244724,
        '紀北町'=>245437,
        '御浜町'=>245615,
        '紀宝町'=>245623,
      },
      '滋賀県'=>{
        '滋賀県'=>250007,
        '大津市'=>252018,
        '彦根市'=>252026,
        '長浜市'=>252034,
        '近江八幡市'=>252042,
        '草津市'=>252069,
        '守山市'=>252077,
        '栗東市'=>252085,
        '甲賀市'=>252093,
        '野洲市'=>252107,
        '湖南市'=>252115,
        '高島市'=>252123,
        '東近江市'=>252131,
        '米原市'=>252140,
        '日野町'=>253839,
        '竜王町'=>253847,
        '愛荘町'=>254258,
        '豊郷町'=>254410,
        '甲良町'=>254428,
        '多賀町'=>254436,
      },
      '京都府'=>{
        '京都府'=>260002,
        '京都市'=>261009,
        '京都市北区'=>261017,
        '京都市上京区'=>261025,
        '京都市左京区'=>261033,
        '京都市中京区'=>261041,
        '京都市東山区'=>261050,
        '京都市下京区'=>261068,
        '京都市南区'=>261076,
        '京都市右京区'=>261084,
        '京都市伏見区'=>261092,
        '京都市山科区'=>261106,
        '京都市西京区'=>261114,
        '福知山市'=>262013,
        '舞鶴市'=>262021,
        '綾部市'=>262030,
        '宇治市'=>262048,
        '宮津市'=>262056,
        '亀岡市'=>262064,
        '城陽市'=>262072,
        '向日市'=>262081,
        '長岡京市'=>262099,
        '八幡市'=>262102,
        '京田辺市'=>262111,
        '京丹後市'=>262129,
        '南丹市'=>262137,
        '木津川市'=>262145,
        '大山崎町'=>263036,
        '久御山町'=>263222,
        '井手町'=>263435,
        '宇治田原町'=>263443,
        '笠置町'=>263648,
        '和束町'=>263656,
        '精華町'=>263664,
        '南山城村'=>263672,
        '京丹波町'=>264075,
        '伊根町'=>264636,
        '与謝野町'=>264652,
      },
      '大阪府'=>{
        '大阪府'=>270008,
        '大阪市'=>271004,
        '大阪市都島区'=>271021,
        '大阪市福島区'=>271039,
        '大阪市此花区'=>271047,
        '大阪市西区'=>271063,
        '大阪市港区'=>271071,
        '大阪市大正区'=>271080,
        '大阪市天王寺区'=>271098,
        '大阪市浪速区'=>271110,
        '大阪市西淀川区'=>271136,
        '大阪市東淀川区'=>271144,
        '大阪市東成区'=>271152,
        '大阪市生野区'=>271161,
        '大阪市旭区'=>271179,
        '大阪市城東区'=>271187,
        '大阪市阿倍野区'=>271195,
        '大阪市住吉区'=>271209,
        '大阪市東住吉区'=>271217,
        '大阪市西成区'=>271225,
        '大阪市淀川区'=>271233,
        '大阪市鶴見区'=>271241,
        '大阪市住之江区'=>271250,
        '大阪市平野区'=>271268,
        '大阪市北区'=>271276,
        '大阪市中央区'=>271284,
        '堺市'=>271403,
        '堺市堺区'=>271411,
        '堺市中区'=>271420,
        '堺市東区'=>271438,
        '堺市西区'=>271446,
        '堺市南区'=>271454,
        '堺市北区'=>271462,
        '堺市美原区'=>271471,
        '岸和田市'=>272027,
        '豊中市'=>272035,
        '池田市'=>272043,
        '吹田市'=>272051,
        '泉大津市'=>272060,
        '高槻市'=>272078,
        '貝塚市'=>272086,
        '守口市'=>272094,
        '枚方市'=>272108,
        '茨木市'=>272116,
        '八尾市'=>272124,
        '泉佐野市'=>272132,
        '富田林市'=>272141,
        '寝屋川市'=>272159,
        '河内長野市'=>272167,
        '松原市'=>272175,
        '大東市'=>272183,
        '和泉市'=>272191,
        '箕面市'=>272205,
        '柏原市'=>272213,
        '羽曳野市'=>272221,
        '門真市'=>272230,
        '摂津市'=>272248,
        '高石市'=>272256,
        '藤井寺市'=>272264,
        '東大阪市'=>272272,
        '泉南市'=>272281,
        '四條畷市'=>272299,
        '交野市'=>272302,
        '大阪狭山市'=>272311,
        '阪南市'=>272329,
        '島本町'=>273015,
        '豊能町'=>273210,
        '能勢町'=>273228,
        '忠岡町'=>273414,
        '熊取町'=>273619,
        '田尻町'=>273627,
        '岬町'=>273660,
        '太子町'=>273813,
        '河南町'=>273821,
        '千早赤阪村'=>273830,
      },
      '兵庫県'=>{
        '兵庫県'=>280003,
        '神戸市'=>281000,
        '神戸市東灘区'=>281018,
        '神戸市灘区'=>281026,
        '神戸市兵庫区'=>281051,
        '神戸市長田区'=>281069,
        '神戸市須磨区'=>281077,
        '神戸市垂水区'=>281085,
        '神戸市北区'=>281093,
        '神戸市中央区'=>281107,
        '神戸市西区'=>281115,
        '姫路市'=>282014,
        '尼崎市'=>282022,
        '明石市'=>282031,
        '西宮市'=>282049,
        '洲本市'=>282057,
        '芦屋市'=>282065,
        '伊丹市'=>282073,
        '相生市'=>282081,
        '豊岡市'=>282090,
        '加古川市'=>282103,
        '赤穂市'=>282120,
        '西脇市'=>282138,
        '宝塚市'=>282146,
        '三木市'=>282154,
        '高砂市'=>282162,
        '川西市'=>282171,
        '小野市'=>282189,
        '三田市'=>282197,
        '加西市'=>282201,
        '篠山市'=>282219,
        '養父市'=>282227,
        '丹波市'=>282235,
        '南あわじ市'=>282243,
        '朝来市'=>282251,
        '淡路市'=>282260,
        '宍粟市'=>282278,
        '加東市'=>282286,
        'たつの市'=>282294,
        '猪名川町'=>283011,
        '多可町'=>283657,
        '稲美町'=>283819,
        '播磨町'=>283827,
        '市川町'=>284424,
        '福崎町'=>284432,
        '神河町'=>284467,
        '太子町'=>284645,
        '上郡町'=>284815,
        '佐用町'=>285013,
        '香美町'=>285854,
        '新温泉町'=>285862,
      },
      '奈良県'=>{
        '奈良県'=>290009,
        '奈良市'=>292010,
        '大和高田市'=>292028,
        '大和郡山市'=>292036,
        '天理市'=>292044,
        '橿原市'=>292052,
        '桜井市'=>292061,
        '五條市'=>292079,
        '御所市'=>292087,
        '生駒市'=>292095,
        '香芝市'=>292109,
        '葛城市'=>292117,
        '宇陀市'=>292125,
        '山添村'=>293229,
        '平群町'=>293423,
        '三郷町'=>293431,
        '斑鳩町'=>293440,
        '安堵町'=>293458,
        '川西町'=>293610,
        '三宅町'=>293628,
        '田原本町'=>293636,
        '曽爾村'=>293857,
        '御杖村'=>293865,
        '高取町'=>294012,
        '明日香村'=>294021,
        '上牧町'=>294241,
        '王寺町'=>294250,
        '広陵町'=>294268,
        '河合町'=>294276,
        '吉野町'=>294411,
        '大淀町'=>294420,
        '下市町'=>294438,
        '黒滝村'=>294446,
        '天川村'=>294462,
        '野迫川村'=>294471,
        '十津川村'=>294497,
        '下北山村'=>294501,
        '上北山村'=>294519,
        '川上村'=>294527,
        '東吉野村'=>294535,
      },
      '和歌山県'=>{
        '和歌山県'=>300004,
        '和歌山市'=>302015,
        '海南市'=>302023,
        '橋本市'=>302031,
        '有田市'=>302040,
        '御坊市'=>302058,
        '田辺市'=>302066,
        '新宮市'=>302074,
        '紀の川市'=>302082,
        '岩出市'=>302091,
        '紀美野町'=>303046,
        'かつらぎ町'=>303411,
        '九度山町'=>303437,
        '高野町'=>303445,
        '湯浅町'=>303615,
        '広川町'=>303623,
        '有田川町'=>303666,
        '美浜町'=>303810,
        '日高町'=>303828,
        '由良町'=>303836,
        '印南町'=>303909,
        'みなべ町'=>303917,
        '日高川町'=>303925,
        '白浜町'=>304018,
        '上富田町'=>304042,
        'すさみ町'=>304069,
        '那智勝浦町'=>304212,
        '太地町'=>304221,
        '古座川町'=>304247,
        '北山村'=>304271,
        '串本町'=>304280,
      },
      '鳥取県'=>{
        '鳥取県'=>310000,
        '鳥取市'=>312011,
        '米子市'=>312029,
        '倉吉市'=>312037,
        '境港市'=>312045,
        '岩美町'=>313025,
        '若桜町'=>313254,
        '智頭町'=>313289,
        '八頭町'=>313297,
        '三朝町'=>313645,
        '湯梨浜町'=>313700,
        '琴浦町'=>313718,
        '北栄町'=>313726,
        '日吉津村'=>313840,
        '大山町'=>313866,
        '南部町'=>313891,
        '伯耆町'=>313904,
        '日南町'=>314013,
        '日野町'=>314021,
        '江府町'=>314030,
      },
      '島根県'=>{
        '島根県'=>320005,
        '松江市'=>322016,
        '浜田市'=>322024,
        '出雲市'=>322032,
        '益田市'=>322041,
        '大田市'=>322059,
        '安来市'=>322067,
        '江津市'=>322075,
        '雲南市'=>322091,
        '奥出雲町'=>323438,
        '飯南町'=>323861,
        '川本町'=>324418,
        '美郷町'=>324485,
        '邑南町'=>324493,
        '津和野町'=>325015,
        '吉賀町'=>325058,
        '海士町'=>325252,
        '西ノ島町'=>325261,
        '知夫村'=>325279,
        '隠岐の島町'=>325287,
      },
      '岡山県'=>{
        '岡山県'=>330001,
        '岡山市'=>331007,
        '岡山市北区'=>331015,
        '岡山市中区'=>331023,
        '岡山市東区'=>331031,
        '岡山市南区'=>331040,
        '倉敷市'=>332020,
        '津山市'=>332038,
        '玉野市'=>332046,
        '笠岡市'=>332054,
        '井原市'=>332071,
        '総社市'=>332089,
        '高梁市'=>332097,
        '新見市'=>332101,
        '備前市'=>332119,
        '瀬戸内市'=>332127,
        '赤磐市'=>332135,
        '真庭市'=>332143,
        '美作市'=>332151,
        '浅口市'=>332160,
        '和気町'=>333468,
        '早島町'=>334235,
        '里庄町'=>334456,
        '矢掛町'=>334618,
        '新庄村'=>335860,
        '鏡野町'=>336068,
        '勝央町'=>336220,
        '奈義町'=>336238,
        '西粟倉村'=>336432,
        '久米南町'=>336637,
        '美咲町'=>336661,
        '吉備中央町'=>336815,
      },
      '広島県'=>{
        '広島県'=>340006,
        '広島市'=>341002,
        '広島市中区'=>341011,
        '広島市東区'=>341029,
        '広島市南区'=>341037,
        '広島市西区'=>341045,
        '広島市安佐南区'=>341053,
        '広島市安佐北区'=>341061,
        '広島市安芸区'=>341070,
        '広島市佐伯区'=>341088,
        '呉市'=>342025,
        '竹原市'=>342033,
        '三原市'=>342041,
        '尾道市'=>342050,
        '福山市'=>342076,
        '府中市'=>342084,
        '三次市'=>342092,
        '庄原市'=>342106,
        '大竹市'=>342114,
        '東広島市'=>342122,
        '廿日市市'=>342131,
        '安芸高田市'=>342149,
        '江田島市'=>342157,
        '府中町'=>343021,
        '海田町'=>343048,
        '熊野町'=>343072,
        '坂町'=>343099,
        '安芸太田町'=>343684,
        '北広島町'=>343692,
        '大崎上島町'=>344311,
        '世羅町'=>344621,
        '神石高原町'=>345458,
      },
      '山口県'=>{
        '山口県'=>350001,
        '下関市'=>352012,
        '宇部市'=>352021,
        '山口市'=>352039,
        '萩市'=>352047,
        '防府市'=>352063,
        '下松市'=>352071,
        '岩国市'=>352080,
        '光市'=>352101,
        '長門市'=>352110,
        '柳井市'=>352128,
        '美祢市'=>352136,
        '周南市'=>352152,
        '山陽小野田市'=>352161,
        '周防大島町'=>353051,
        '和木町'=>353213,
        '上関町'=>353418,
        '田布施町'=>353434,
        '平生町'=>353442,
        '阿武町'=>355020,
      },
      '徳島県'=>{
        '徳島県'=>360007,
        '徳島市'=>362018,
        '鳴門市'=>362026,
        '小松島市'=>362034,
        '阿南市'=>362042,
        '吉野川市'=>362051,
        '阿波市'=>362069,
        '美馬市'=>362077,
        '三好市'=>362085,
        '勝浦町'=>363014,
        '上勝町'=>363022,
        '佐那河内村'=>363219,
        '石井町'=>363413,
        '神山町'=>363421,
        '那賀町'=>363685,
        '牟岐町'=>363839,
        '美波町'=>363871,
        '海陽町'=>363880,
        '松茂町'=>364011,
        '北島町'=>364029,
        '藍住町'=>364037,
        '板野町'=>364045,
        '上板町'=>364053,
        'つるぎ町'=>364681,
        '東みよし町'=>364894,
      },
      '香川県'=>{
        '香川県'=>370002,
        '高松市'=>372013,
        '丸亀市'=>372021,
        '坂出市'=>372030,
        '善通寺市'=>372048,
        '観音寺市'=>372056,
        'さぬき市'=>372064,
        '東かがわ市'=>372072,
        '三豊市'=>372081,
        '土庄町'=>373222,
        '小豆島町'=>373249,
        '三木町'=>373419,
        '直島町'=>373648,
        '宇多津町'=>373869,
        '綾川町'=>373877,
        '琴平町'=>374032,
        '多度津町'=>374041,
        'まんのう町'=>374067,
      },
      '愛媛県'=>{
        '愛媛県'=>380008,
        '松山市'=>382019,
        '今治市'=>382027,
        '宇和島市'=>382035,
        '八幡浜市'=>382043,
        '新居浜市'=>382051,
        '西条市'=>382060,
        '大洲市'=>382078,
        '伊予市'=>382108,
        '四国中央市'=>382132,
        '西予市'=>382141,
        '東温市'=>382159,
        '上島町'=>383562,
        '久万高原町'=>383864,
        '松前町'=>384011,
        '砥部町'=>384020,
        '内子町'=>384224,
        '伊方町'=>384429,
        '松野町'=>384844,
        '鬼北町'=>384887,
        '愛南町'=>385069,
      },
      '高知県'=>{
        '高知県'=>390003,
        '高知市'=>392014,
        '室戸市'=>392022,
        '安芸市'=>392031,
        '南国市'=>392049,
        '土佐市'=>392057,
        '須崎市'=>392065,
        '宿毛市'=>392081,
        '土佐清水市'=>392090,
        '四万十市'=>392103,
        '香南市'=>392111,
        '香美市'=>392120,
        '東洋町'=>393011,
        '奈半利町'=>393029,
        '田野町'=>393037,
        '安田町'=>393045,
        '北川村'=>393053,
        '馬路村'=>393061,
        '芸西村'=>393070,
        '本山町'=>393410,
        '大豊町'=>393444,
        '土佐町'=>393631,
        '大川村'=>393649,
        'いの町'=>393860,
        '仁淀川町'=>393878,
        '中土佐町'=>394017,
        '佐川町'=>394025,
        '越知町'=>394033,
        '梼原町'=>394050,
        '日高村'=>394106,
        '津野町'=>394114,
        '四万十町'=>394122,
        '大月町'=>394246,
        '三原村'=>394271,
        '黒潮町'=>394289,
      },
      '福岡県'=>{
        '福岡県'=>400009,
        '北九州市'=>401005,
        '北九州市門司区'=>401013,
        '北九州市若松区'=>401030,
        '北九州市戸畑区'=>401056,
        '北九州市小倉北区'=>401064,
        '北九州市小倉南区'=>401072,
        '北九州市八幡東区'=>401081,
        '北九州市八幡西区'=>401099,
        '福岡市'=>401307,
        '福岡市東区'=>401315,
        '福岡市博多区'=>401323,
        '福岡市中央区'=>401331,
        '福岡市南区'=>401340,
        '福岡市西区'=>401358,
        '福岡市城南区'=>401366,
        '福岡市早良区'=>401374,
        '大牟田市'=>402028,
        '久留米市'=>402036,
        '直方市'=>402044,
        '飯塚市'=>402052,
        '田川市'=>402061,
        '柳川市'=>402079,
        '八女市'=>402109,
        '筑後市'=>402117,
        '大川市'=>402125,
        '行橋市'=>402133,
        '豊前市'=>402141,
        '中間市'=>402150,
        '小郡市'=>402168,
        '筑紫野市'=>402176,
        '春日市'=>402184,
        '大野城市'=>402192,
        '宗像市'=>402206,
        '太宰府市'=>402214,
        '古賀市'=>402231,
        '福津市'=>402249,
        'うきは市'=>402257,
        '宮若市'=>402265,
        '嘉麻市'=>402273,
        '朝倉市'=>402281,
        'みやま市'=>402290,
        '糸島市'=>402303,
        '那珂川町'=>403059,
        '宇美町'=>403415,
        '篠栗町'=>403423,
        '志免町'=>403431,
        '須恵町'=>403440,
        '新宮町'=>403458,
        '久山町'=>403482,
        '粕屋町'=>403491,
        '芦屋町'=>403814,
        '水巻町'=>403822,
        '岡垣町'=>403831,
        '遠賀町'=>403849,
        '小竹町'=>404012,
        '鞍手町'=>404021,
        '桂川町'=>404217,
        '筑前町'=>404471,
        '東峰村'=>404489,
        '大刀洗町'=>405035,
        '大木町'=>405221,
        '広川町'=>405442,
        '香春町'=>406015,
        '添田町'=>406023,
        '糸田町'=>406040,
        '川崎町'=>406058,
        '大任町'=>406082,
        '赤村'=>406091,
        '福智町'=>406104,
        '苅田町'=>406210,
        'みやこ町'=>406252,
        '吉富町'=>406422,
        '上毛町'=>406465,
        '築上町'=>406473,
      },
      '佐賀県'=>{
        '佐賀県'=>410004,
        '佐賀市'=>412015,
        '唐津市'=>412023,
        '鳥栖市'=>412031,
        '多久市'=>412040,
        '伊万里市'=>412058,
        '武雄市'=>412066,
        '鹿島市'=>412074,
        '小城市'=>412082,
        '嬉野市'=>412091,
        '神埼市'=>412104,
        '吉野ヶ里町'=>413275,
        '基山町'=>413411,
        '上峰町'=>413453,
        'みやき町'=>413461,
        '玄海町'=>413879,
        '有田町'=>414018,
        '大町町'=>414239,
        '江北町'=>414247,
        '白石町'=>414255,
        '太良町'=>414417,
      },
      '長崎県'=>{
        '長崎県'=>420000,
        '長崎市'=>422011,
        '佐世保市'=>422029,
        '島原市'=>422037,
        '諫早市'=>422045,
        '大村市'=>422053,
        '平戸市'=>422070,
        '松浦市'=>422088,
        '対馬市'=>422096,
        '壱岐市'=>422100,
        '五島市'=>422118,
        '西海市'=>422126,
        '雲仙市'=>422134,
        '南島原市'=>422142,
        '長与町'=>423076,
        '時津町'=>423084,
        '東彼杵町'=>423211,
        '川棚町'=>423220,
        '波佐見町'=>423238,
        '小値賀町'=>423831,
        '佐々町'=>423912,
        '新上五島町'=>424111,
      },
      '熊本県'=>{
        '熊本県'=>430005,
        '熊本市'=>431001,
        '熊本市中央区'=>431010,
        '熊本市東区'=>431028,
        '熊本市西区'=>431036,
        '熊本市南区'=>431044,
        '熊本市北区'=>431052,
        '八代市'=>432024,
        '人吉市'=>432032,
        '荒尾市'=>432041,
        '水俣市'=>432059,
        '玉名市'=>432067,
        '山鹿市'=>432083,
        '菊池市'=>432105,
        '宇土市'=>432113,
        '上天草市'=>432121,
        '宇城市'=>432130,
        '阿蘇市'=>432148,
        '天草市'=>432156,
        '合志市'=>432164,
        '美里町'=>433489,
        '玉東町'=>433641,
        '南関町'=>433675,
        '長洲町'=>433683,
        '和水町'=>433691,
        '大津町'=>434035,
        '菊陽町'=>434043,
        '南小国町'=>434230,
        '小国町'=>434248,
        '産山村'=>434256,
        '高森町'=>434281,
        '西原村'=>434329,
        '南阿蘇村'=>434337,
        '御船町'=>434418,
        '嘉島町'=>434426,
        '益城町'=>434434,
        '甲佐町'=>434442,
        '山都町'=>434477,
        '氷川町'=>434680,
        '芦北町'=>434825,
        '津奈木町'=>434841,
        '錦町'=>435015,
        '多良木町'=>435058,
        '湯前町'=>435066,
        '水上村'=>435074,
        '相良村'=>435104,
        '五木村'=>435112,
        '山江村'=>435121,
        '球磨村'=>435139,
        'あさぎり町'=>435147,
        '苓北町'=>435317,
      },
      '大分県'=>{
        '大分県'=>440001,
        '大分市'=>442011,
        '別府市'=>442020,
        '中津市'=>442038,
        '日田市'=>442046,
        '佐伯市'=>442054,
        '臼杵市'=>442062,
        '津久見市'=>442071,
        '竹田市'=>442089,
        '豊後高田市'=>442097,
        '杵築市'=>442101,
        '宇佐市'=>442119,
        '豊後大野市'=>442127,
        '由布市'=>442135,
        '国東市'=>442143,
        '姫島村'=>443221,
        '日出町'=>443417,
        '九重町'=>444618,
        '玖珠町'=>444626,
      },
      '宮崎県'=>{
        '宮崎県'=>450006,
        '宮崎市'=>452017,
        '都城市'=>452025,
        '延岡市'=>452033,
        '日南市'=>452041,
        '小林市'=>452050,
        '日向市'=>452068,
        '串間市'=>452076,
        '西都市'=>452084,
        'えびの市'=>452092,
        '三股町'=>453412,
        '高原町'=>453617,
        '国富町'=>453820,
        '綾町'=>453838,
        '高鍋町'=>454010,
        '新富町'=>454028,
        '西米良村'=>454036,
        '木城町'=>454044,
        '川南町'=>454052,
        '都農町'=>454061,
        '門川町'=>454214,
        '諸塚村'=>454290,
        '椎葉村'=>454303,
        '美郷町'=>454311,
        '高千穂町'=>454419,
        '日之影町'=>454427,
        '五ヶ瀬町'=>454435,
      },
      '鹿児島県'=>{
        '鹿児島県'=>460001,
        '鹿児島市'=>462012,
        '鹿屋市'=>462039,
        '枕崎市'=>462047,
        '阿久根市'=>462063,
        '出水市'=>462080,
        '指宿市'=>462101,
        '西之表市'=>462136,
        '垂水市'=>462144,
        '薩摩川内市'=>462152,
        '日置市'=>462161,
        '曽於市'=>462179,
        '霧島市'=>462187,
        'いちき串木野市'=>462195,
        '南さつま市'=>462209,
        '志布志市'=>462217,
        '奄美市'=>462225,
        '南九州市'=>462233,
        '伊佐市'=>462241,
        '姶良市'=>462250,
        '三島村'=>463035,
        '十島村'=>463043,
        'さつま町'=>463922,
        '長島町'=>464040,
        '湧水町'=>464520,
        '大崎町'=>464686,
        '東串良町'=>464821,
        '錦江町'=>464902,
        '南大隅町'=>464911,
        '肝付町'=>464929,
        '中種子町'=>465011,
        '南種子町'=>465020,
        '屋久島町'=>465054,
        '大和村'=>465232,
        '宇検村'=>465241,
        '瀬戸内町'=>465259,
        '龍郷町'=>465275,
        '喜界町'=>465291,
        '徳之島町'=>465305,
        '天城町'=>465313,
        '伊仙町'=>465321,
        '和泊町'=>465330,
        '知名町'=>465348,
        '与論町'=>465356,
      },
      '沖縄県'=>{
        '沖縄県'=>470007,
        '那覇市'=>472018,
        '宜野湾市'=>472051,
        '石垣市'=>472077,
        '浦添市'=>472085,
        '名護市'=>472093,
        '糸満市'=>472107,
        '沖縄市'=>472115,
        '豊見城市'=>472123,
        'うるま市'=>472131,
        '宮古島市'=>472140,
        '南城市'=>472158,
        '国頭村'=>473014,
        '大宜味村'=>473022,
        '東村'=>473031,
        '今帰仁村'=>473065,
        '本部町'=>473081,
        '恩納村'=>473111,
        '宜野座村'=>473138,
        '金武町'=>473146,
        '伊江村'=>473154,
        '読谷村'=>473243,
        '嘉手納町'=>473251,
        '北谷町'=>473260,
        '北中城村'=>473278,
        '中城村'=>473286,
        '西原町'=>473294,
        '与那原町'=>473481,
        '南風原町'=>473502,
        '渡嘉敷村'=>473537,
        '座間味村'=>473545,
        '粟国村'=>473553,
        '渡名喜村'=>473561,
        '南大東村'=>473570,
        '北大東村'=>473588,
        '伊平屋村'=>473596,
        '伊是名村'=>473600,
        '久米島町'=>473618,
        '八重瀬町'=>473626,
        '多良間村'=>473758,
        '竹富町'=>473812,
        '与那国町'=>473821,
      },
    }
  end
end
